
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CABBAGE CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<Cabbage>

;color macros:
#define PLANT colour(76,130,180,155) outlineColour(0,0,0,255) outlineThickness(2)
#define BASIC colour(56, 150, 180, 255) trackerColour("MediumTurquoise") outlineColour(17,37,37,155)
#define VBASIC colour("Gainsboro") trackerColour("MediumTurquoise") outlineColour(17,37,37,155)
#define FTABLES tableGridColour("Silver") tableColour:0(20,20,20,245) tableBackgroundColour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("MediumTurquoise") colour:0("DarkSlateGrey")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0) presetIgnore(1) 
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) presetIgnore(1) 
#define FONT fontColour("Gainsboro") presetIgnore(1) 

;MAIN GUI:
form channel("f1") caption("Syncopath") size(1088, 492) pluginId("Sync") colour(76,130,180,155) style("legacy") fontColour("Gainsboro")
label channel("l1") bounds(5, 5, 40, 10) text("Presets") $FONT
combobox bounds(43,2,120,15) populate("*.snaps") channelType("string") channel("combobox") ;$FONT
filebutton bounds(165,2,35,15) text("Save") populate("*.snaps") mode("named preset") channel("fb1") presetIgnore(1) 
filebutton bounds(200,2,50,15) text("Remove") populate("*.snaps") mode("remove preset") channel("fb2") presetIgnore(1)
label channel("l2") bounds(250,5,30,10) text("Inputs") $FONT
button bounds(282,2,40,16) channel("liveon") text("Mic/Line") $BUTTONS
combobox bounds(325,2,50,15) channel("livech") text("Stereo","Mono")
button bounds(378,2,27,15) text("Amp") channel("mapliveamp") $MIDI
button bounds(405,2,9,15) text("") channel("mapliveampX") $MIDIX
rslider bounds(415, 0, 20, 20) channel("liveamp") range(0, 5, 0, 0.75, 0.001) $BASIC
filebutton bounds(440,2,45,16) channel("openFile") text("Load SF") $BUTTONS
button bounds(487,2,35,16) channel("sfplay") text("Play") $BUTTONS
button bounds(525,2,35,16) channel("sfloop") text("Loop") $BUTTONS
button bounds(567,2,27,15) text("Amp") channel("mapsfamp") $MIDI
button bounds(593,2,9,15) text("") channel("mapsfampX") $MIDIX
rslider bounds(605, 0, 20, 20) channel("sfamp") range(0, 5, 0, 0.75, 0.001) $BASIC
button bounds(628,2,30,15) channel("livetoOsc") text("to Osc","to Osc") value(1) $BUTTONS
button bounds(661,2,30,15) channel("livetoFX") text("to FX","to FX") value(1) $BUTTONS
label channel("l3") bounds(678,5,70,10) text("Tuning") $FONT
combobox bounds(735, 2, 70, 17), channel("MasterScale") text("Equal Temp", "1/8 Tone", "1/6 Tone", "1/4 Tone", "1/3 Tone",  "7 Tone", "8 Tone", "9 Tone", "10 Tone", "11 Tone", "11.6 Tone", "11.8 Tone", "12.2 Tone", "12.4 Tone", "13 Tone", "14 Tone", "15 Tone")
label channel("l4") bounds(788,5,100,10) text("Tune From") $FONT
nslider bounds(865,2,40,15) channel("ScaleStart") range(20,108,60.00,1,.01)
label channel("l5") bounds(925,5,80,10) text("jitter depth/rate") $FONT
rslider bounds(1002, 0, 20, 20) channel("Mjit") range(0, 10, 1, 0.5, 0.01) $BASIC
rslider bounds(1020, 0, 20, 20) channel("Mjitrate") range(.1, 10, 1, 0.5, 0.01) $BASIC
button bounds(100, 328, 45, 20) channel("record") text("Record","Stop") colour("red") fontColour("white")
combobox bounds(100,350,45,15) channel("recch") value(2) text("mono","stereo")
combobox bounds(100,367,45,15) channel("bit") value(1) text("16-bit","24-bit","32-bit")
button bounds(100, 384, 45, 20), channel("play") text("Play") colour("green") fontColour("white")
keyboard channel("k1") bounds(101,409,940, 80) value(21)

;PLANTS
;Master Volume Control
image channel("i1") bounds(4,20,40,212) plant("Amp") $PLANT
{
label channel("l6") bounds(8,2,25,12) text("Amp") $FONT
vslider bounds(5,12,30,170) channel("MAmp") range(0.00, 1.5, 0.75, 1, 0.0001) $VBASIC
button bounds(2,190,27,15) text("Amp") channel("mapMamp") $MIDI
button bounds(29,190,9,15) text("") channel("mapMampX") $MIDIX
}

;ADSR Bank
image channel("i2") bounds(46,20,102,212) plant("ADSR") $PLANT
{
label channel("l7") bounds(20, 4, 20, 12) text("A") $FONT
label channel("l8") bounds(40, 4, 20, 12) text("D") $FONT
label channel("l9") bounds(60, 4, 20, 12) text("S") $FONT
label channel("l10") bounds(80, 4, 20, 12) text("R") $FONT
label channel("l11") bounds(5,21,15,12) text("1") $FONT
label channel("l12") bounds(5,40,15,12) text("2") $FONT
label channel("l13") bounds(5,59,15,12) text("3") $FONT
label channel("l14") bounds(5,78,15,12) text("4") $FONT
label channel("l15") bounds(5,97,15,12) text("5") $FONT
label channel("l16") bounds(5,116,15,12) text("6") $FONT
label channel("l17") bounds(5,135,15,12) text("7") $FONT
label channel("l18") bounds(5,154,15,12) text("8") $FONT
label channel("l19") bounds(5,173,15,12) text("9") $FONT
label channel("l20") bounds(0,192,25,12) text("10") $FONT
rslider bounds(20, 19, 20, 20) channel("1a") range(0.001, 5, 0.01, 0.75, 0.001) $BASIC
rslider bounds(40, 19, 20, 20) channel("1d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 19, 20, 20) channel("1s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 19, 20, 20) channel("1r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 38, 20, 20) channel("2a") range(0.001, 5, 0.02, 0.75, 0.001) $BASIC
rslider bounds(40, 38, 20, 20) channel("2d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 38, 20, 20) channel("2s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 38, 20, 20) channel("2r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 57, 20, 20) channel("3a") range(0.001, 5, 0.03, 0.75, 0.001) $BASIC
rslider bounds(40, 57, 20, 20) channel("3d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 57, 20, 20) channel("3s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 57, 20, 20) channel("3r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 76, 20, 20) channel("4a") range(0.001, 5, 0.05, 0.75, 0.001) $BASIC
rslider bounds(40, 76, 20, 20) channel("4d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 76, 20, 20) channel("4s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 76, 20, 20) channel("4r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 95, 20, 20) channel("5a") range(0.001, 5, 0.07, 0.75, 0.001) $BASIC
rslider bounds(40, 95, 20, 20) channel("5d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 95, 20, 20) channel("5s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 95, 20, 20) channel("5r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 114, 20, 20) channel("6a") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC
rslider bounds(40, 114, 20, 20) channel("6d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 114, 20, 20) channel("6s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 114, 20, 20) channel("6r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 133, 20, 20) channel("7a") range(0.001, 5, 0.15, 0.75, 0.001) $BASIC
rslider bounds(40, 133, 20, 20) channel("7d") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(60, 133, 20, 20) channel("7s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 133, 20, 20) channel("7r") range(0.001, 5, 0.1, 0.75, 0.001) $BASIC 
rslider bounds(20, 152, 20, 20) channel("8a") range(0.001, 5, 0.2, 0.75, 0.001) $BASIC
rslider bounds(40, 152, 20, 20) channel("8d") range(0.001, 5, 0.15, 0.75, 0.001) $BASIC 
rslider bounds(60, 152, 20, 20) channel("8s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 152, 20, 20) channel("8r") range(0.001, 5, 0.2, 0.75, 0.001) $BASIC 
rslider bounds(20, 171, 20, 20) channel("9a") range(0.001, 5, 0.25, 0.75, 0.001) $BASIC
rslider bounds(40, 171, 20, 20) channel("9d") range(0.001, 5, 0.2, 0.75, 0.001) $BASIC 
rslider bounds(60, 171, 20, 20) channel("9s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 171, 20, 20) channel("9r") range(0.001, 5, 0.25, 0.75, 0.001) $BASIC 
rslider bounds(20, 190, 20, 20) channel("10a") range(0.001, 5, 0.5, 0.75, 0.001) $BASIC
rslider bounds(40, 190, 20, 20) channel("10d") range(0.001, 5, 0.25, 0.75, 0.001) $BASIC 
rslider bounds(60, 190, 20, 20) channel("10s") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(80, 190, 20, 20) channel("10r") range(0.001, 5, 0.5, 0.75, 0.001) $BASIC 
}

;LFO Bank
image channel("i3") bounds(151,20,173,212) plant("ADSR") $PLANT
{
label channel("l21") bounds(30, 4, 40, 12) text("Wave") $FONT
label channel("l22") bounds(70, 4, 40, 12) text("Rate") $FONT
label channel("l23") bounds(97,14,50,10) text("x10 x100") $FONT
label channel("l24") bounds(136, 4, 40, 12) text("Rand") $FONT
button bounds(5, 20, 20, 15) channel("lfo1") text("1", "1") value(0) $BUTTONS
button bounds(5, 39, 20, 15) channel("lfo2") text("2", "2") value(0) $BUTTONS
button bounds(5, 58, 20, 15) channel("lfo3") text("3", "3") value(0) $BUTTONS
button bounds(5, 77, 20, 15) channel("lfo4") text("4", "4") value(0) $BUTTONS
button bounds(5, 96, 20, 15) channel("lfo5") text("5", "5") value(0) $BUTTONS
button bounds(5, 115, 20, 15) channel("lfo6") text("6", "6") value(0) $BUTTONS
button bounds(5, 134, 20, 15) channel("lfo7") text("7", "7") value(0) $BUTTONS
button bounds(5, 153, 20, 15) channel("lfo8") text("8", "8") value(0) $BUTTONS
button bounds(5, 172, 20, 15) channel("lfo9") text("9", "9") value(0) $BUTTONS
button bounds(5, 191, 20, 15) channel("lfo10") text("10", "10") value(0) $BUTTONS
combobox bounds(29,21,50,13) channel("lfo1fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,40,50,13) channel("lfo2fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,59,50,13) channel("lfo3fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,78,50,13) channel("lfo4fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,97,50,13) channel("lfo5fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,116,50,13) channel("lfo6fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,135,50,13) channel("lfo7fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,154,50,13) channel("lfo8fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,173,50,13) channel("lfo9fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
combobox bounds(29,192,50,13) channel("lfo10fn") text("sine", "triangle", "square", "rampup", "rampdown", "pulse", "S&H", "rand")
rslider bounds(81, 19, 20, 20) channel("lfo1r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 38, 20, 20) channel("lfo2r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 57, 20, 20) channel("lfo3r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 76, 20, 20) channel("lfo4r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 95, 20, 20) channel("lfo5r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 114, 20, 20) channel("lfo6r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 133, 20, 20) channel("lfo7r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 152, 20, 20) channel("lfo8r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 171, 20, 20) channel("lfo9r") range(0, 15, 0, .5, 0.01) $BASIC 
rslider bounds(81, 190, 20, 20) channel("lfo10r") range(0, 15, 0, .5, 0.01) $BASIC 
button bounds(102,24,20,10) channel("lfo1x10") text("", "10") $BUTTONS
button bounds(124,24,20,10) channel("lfo1x100") text("", "100") $BUTTONS
button bounds(102,43,20,10) channel("lfo2x10") text("", "10") $BUTTONS
button bounds(124,43,20,10) channel("lfo2x100") text("", "100") $BUTTONS
button bounds(102,62,20,10) channel("lfo3x10") text("", "10") $BUTTONS
button bounds(124,62,20,10) channel("lfo3x100") text("", "100") $BUTTONS
button bounds(102,81,20,10) channel("lfo4x10") text("", "10") $BUTTONS
button bounds(124,81,20,10) channel("lfo4x100") text("", "100") $BUTTONS
button bounds(102,100,20,10) channel("lfo5x10") text("", "10") $BUTTONS
button bounds(124,100,20,10) channel("lfo5x100") text("", "100") $BUTTONS
button bounds(102,119,20,10) channel("lfo6x10") text("", "10") $BUTTONS
button bounds(124,119,20,10) channel("lfo6x100") text("", "100") $BUTTONS
button bounds(102,138,20,10) channel("lfo7x10") text("", "10") $BUTTONS
button bounds(124,138,20,10) channel("lfo7x100") text("", "100") $BUTTONS
button bounds(102,157,20,10) channel("lfo8x10") text("", "10") $BUTTONS
button bounds(124,157,20,10) channel("lfo8x100") text("", "100") $BUTTONS
button bounds(102,176,20,10) channel("lfo9x10") text("", "10") $BUTTONS
button bounds(124,176,20,10) channel("lfo9x100") text("", "100") $BUTTONS
button bounds(102,195,20,10) channel("lfo10x10") text("", "10") $BUTTONS
button bounds(124,195,20,10) channel("lfo10x100") text("", "100") $BUTTONS
rslider bounds(147, 19, 20, 20) channel("lfo1j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 38, 20, 20) channel("lfo2j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 57, 20, 20) channel("lfo3j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 76, 20, 20) channel("lfo4j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 95, 20, 20) channel("lfo5j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 114, 20, 20) channel("lfo6j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 133, 20, 20) channel("lfo7j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 152, 20, 20) channel("lfo8j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 171, 20, 20) channel("lfo9j") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(147, 190, 20, 20) channel("lfo10j") range(0, 1, 0, 1, 0.01) $BASIC 
}

;Oscillators
image channel("i4") bounds(326,20,717,212) plant("Osc1") $PLANT
{
label channel("l25") bounds(0,4,25,12) text("Osc") $FONT
label channel("l26") bounds(25,6,25,10) text("Amp") $FONT
label channel("l27") bounds(49,6,25,10) text("Pan") $FONT
label channel("l28") bounds(75,4,30,12) text("Wave") $FONT
label channel("l29") bounds(132,6,35,10) text("Morph") $FONT
label channel("l30") bounds(159,6,30,10) text("PW") $FONT
label channel("l31") bounds(173,6,40,10) text("rate") $FONT
label channel("l32") bounds(198,6,40,10) text("depth") $FONT
label channel("l33") bounds(230,4,40,12) text("Sync") $FONT
label channel("l34") bounds(277,4,30,12) text("ADSR") $FONT
label channel("l35") bounds(319,3,30,10) text("Tune") $FONT 
label channel("l36") bounds(313,11,45,8) text("Coarse/Fine") $FONT
label channel("l37") bounds(375,3,30,10) text("Bend") $FONT
label channel("l38") bounds(367,11,45,8) text("Up/Down") $FONT 
label channel("l39") bounds(440,4,25,12) text("FM") $FONT
label channel("l40") bounds(474,6,35,10) text("Depth") $FONT
label channel("l41") bounds(510,6,30,10) text("ADSR") $FONT
label channel("l42") bounds(555,4,25,12) text("AM") $FONT
label channel("l43") bounds(589,6,35,10) text("Depth") $FONT
label channel("l44") bounds(625,6,30,10) text("ADSR") $FONT
label channel("l45") bounds(673,4,25,12) text("RM") $FONT
button bounds(3, 20, 20, 15) channel("osc1") text("1", "1") value(1) $BUTTONS
button bounds(3, 39, 20, 15) channel("osc2") text("2", "2") value(1) $BUTTONS
button bounds(3, 58, 20, 15) channel("osc3") text("3", "3") value(1) $BUTTONS
button bounds(3, 77, 20, 15) channel("osc4") text("4", "4") value(1) $BUTTONS
button bounds(3, 96, 20, 15) channel("osc5") text("5", "5") value(1) $BUTTONS
button bounds(3, 115, 20, 15) channel("osc6") text("6", "6") value(1) $BUTTONS
button bounds(3, 134, 20, 15) channel("osc7") text("7", "7") value(1) $BUTTONS
button bounds(3, 153, 20, 15) channel("osc8") text("8", "8") value(1) $BUTTONS
button bounds(3, 172, 20, 15) channel("osc9") text("9", "9") value(1) $BUTTONS
button bounds(3, 191, 20, 15) channel("osc10") text("10", "10") value(1) $BUTTONS
rslider bounds(28, 18, 20, 20) channel("amp1") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(28, 37, 20, 20) channel("amp2") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(28, 56, 20, 20) channel("amp3") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(28, 75, 20, 20) channel("amp4") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(28, 94, 20, 20) channel("amp5") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(28, 113, 20, 20) channel("amp6") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(28, 132, 20, 20) channel("amp7") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(28, 151, 20, 20) channel("amp8") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(28, 170, 20, 20) channel("amp9") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(28, 189, 20, 20) channel("amp10") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(53, 18, 20, 20) channel("pan1") range(0, 1, .48, 1, 0.01) $BASIC 
rslider bounds(53, 37, 20, 20) channel("pan2") range(0, 1, .45, 1, 0.01) $BASIC 
rslider bounds(53, 56, 20, 20) channel("pan3") range(0, 1, .55, 1, 0.01) $BASIC 
rslider bounds(53, 75, 20, 20) channel("pan4") range(0, 1, .35, 1, 0.01) $BASIC 
rslider bounds(53, 94, 20, 20) channel("pan5") range(0, 1, .65, 1, 0.01) $BASIC 
rslider bounds(53, 113, 20, 20) channel("pan6") range(0, 1, .25, 1, 0.01) $BASIC 
rslider bounds(53, 132, 20, 20) channel("pan7") range(0, 1, .75, 1, 0.01) $BASIC 
rslider bounds(53, 151, 20, 20) channel("pan8") range(0, 1, .15, 1, 0.01) $BASIC 
rslider bounds(53, 170, 20, 20) channel("pan9") range(0, 1, .95, 1, 0.01) $BASIC 
rslider bounds(53, 189, 20, 20) channel("pan10") range(0, 1, .52, 1, 0.01) $BASIC 
combobox bounds(75,21,70,14) channel("fn1") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(75,40,70,14) channel("fn2") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(75,59,70,14) channel("fn3") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(75,78,70,14) channel("fn4") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(75,97,70,14) channel("fn5") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(75,116,70,14) channel("fn6") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(75,135,70,14) channel("fn7") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(75,154,70,14) channel("fn8") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(75,173,70,14) channel("fn9") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
combobox bounds(75,192,70,14) channel("fn10") text("sine","square","saw","pulse","Triangle","Ramp","harm 2","harm 3","harm 4","harm 5","harm 6","harm 7","harm 8","harm 9","harm 10","harm 11","harm 12","harm 13","harm 14","harm 15","harm 16","cello","violin","trombone","horn","trumpet","c bassoon","bassoon","oboe","sax","b clarinet","clarinet","b flute","flute","piccolo","piano","guitar","ahhh")
button bounds(147,21,16,14) channel("mrf1") text("") value(0) $BUTTONS
button bounds(147,40,16,14) channel("mrf2") text("") value(0) $BUTTONS
button bounds(147,59,16,14) channel("mrf3") text("") value(0) $BUTTONS
button bounds(147,78,16,14) channel("mrf4") text("") value(0) $BUTTONS
button bounds(147,97,16,14) channel("mrf5") text("") value(0) $BUTTONS
button bounds(147,116,16,14) channel("mrf6") text("") value(0) $BUTTONS
button bounds(147,135,16,14) channel("mrf7") text("") value(0) $BUTTONS
button bounds(147,154,16,14) channel("mrf8") text("") value(0) $BUTTONS
button bounds(147,173,16,14) channel("mrf9") text("") value(0) $BUTTONS
button bounds(147,192,16,14) channel("mrf10") text("") value(0) $BUTTONS
rslider bounds(165, 18, 20, 20) channel("pw1") range(1, 5, 1, 1, .001) $BASIC 
rslider bounds(165, 37, 20, 20) channel("pw2") range(1, 5, 1, 1, .001) $BASIC
rslider bounds(165, 56, 20, 20) channel("pw3") range(1, 5, 1, 1, .001) $BASIC 
rslider bounds(165, 75, 20, 20) channel("pw4") range(1, 5, 1, 1, .001) $BASIC 
rslider bounds(165, 94, 20, 20) channel("pw5") range(1, 5, 1, 1, .001) $BASIC 
rslider bounds(165, 113, 20, 20) channel("pw6") range(1, 5, 1, 1, .001) $BASIC 
rslider bounds(165, 132, 20, 20) channel("pw7") range(1, 5, 1, 1, .001) $BASIC 
rslider bounds(165, 151, 20, 20) channel("pw8") range(1, 5, 1, 1, .001) $BASIC 
rslider bounds(165, 170, 20, 20) channel("pw9") range(1, 5, 1, 1, .001) $BASIC
rslider bounds(165, 189, 20, 20) channel("pw10") range(1, 5, 1, 1, .001) $BASIC
rslider bounds(187, 18, 20, 20) channel("pwr1") range(0, 50, 0, .5, .01) $BASIC
rslider bounds(187, 37, 20, 20) channel("pwr2") range(0, 50, 0, .5, .01) $BASIC 
rslider bounds(187, 56, 20, 20) channel("pwr3") range(0, 50, 0, .5, .01) $BASIC 
rslider bounds(187, 75, 20, 20) channel("pwr4") range(0, 50, 0, .5, .01) $BASIC 
rslider bounds(187, 94, 20, 20) channel("pwr5") range(0, 50, 0, .5, .01) $BASIC 
rslider bounds(187, 113, 20, 20) channel("pwr6") range(0, 50, 0, .5, .01) $BASIC
rslider bounds(187, 132, 20, 20) channel("pwr7") range(0, 50, 0, .5, .01) $BASIC
rslider bounds(187, 151, 20, 20) channel("pwr8") range(0, 50, 0, .5, .01) $BASIC
rslider bounds(187, 170, 20, 20) channel("pwr9") range(0, 50, 0, .5, .01) $BASIC
rslider bounds(187, 189, 20, 20) channel("pwr10") range(0, 50, 0, .5, .01) $BASIC
rslider bounds(210, 18, 20, 20) channel("pwd1") range(0, .75, 0, 1, .01) $BASIC 
rslider bounds(210, 37, 20, 20) channel("pwd2") range(0, .75, 0, 1, .01) $BASIC
rslider bounds(210, 56, 20, 20) channel("pwd3") range(0, .75, 0, 1, .01) $BASIC 
rslider bounds(210, 75, 20, 20) channel("pwd4") range(0, .75, 0, 1, .01) $BASIC 
rslider bounds(210, 94, 20, 20) channel("pwd5") range(0, .75, 0, 1, .01) $BASIC 
rslider bounds(210, 113, 20, 20) channel("pwd6") range(0, .75, 0, 1, .01) $BASIC 
rslider bounds(210, 132, 20, 20) channel("pwd7") range(0, .75, 0, 1, .01) $BASIC
rslider bounds(210, 151, 20, 20) channel("pwd8") range(0, .75, 0, 1, .01) $BASIC
rslider bounds(210, 170, 20, 20) channel("pwd9") range(0, .75, 0, 1, .01) $BASIC 
rslider bounds(210, 189, 20, 20) channel("pwd10") range(0, .75, 0, 1, .01) $BASIC
combobox bounds(231,21,40,14) channel("sync1") text("none","2","3","4","5","6","7","8","9","10")
combobox bounds(231,40,40,14) channel("sync2") text("none","1","3","4","5","6","7","8","9","10")
combobox bounds(231,59,40,14) channel("sync3") text("none","1","2","4","5","6","7","8","9","10")
combobox bounds(231,78,40,14) channel("sync4") text("none","1","2","3","5","6","7","8","9","10")
combobox bounds(231,97,40,14) channel("sync5") text("none","1","2","3","4","6","7","8","9","10")
combobox bounds(231,116,40,14) channel("sync6") text("none","1","2","3","4","5","7","8","9","10")
combobox bounds(231,135,40,14) channel("sync7") text("none","1","2","3","4","5","6","8","9","10")
combobox bounds(231,154,40,14) channel("sync8") text("none","1","2","3","4","5","6","7","9","10")
combobox bounds(231,173,40,14) channel("sync9") text("none","1","2","3","4","5","6","7","8","10")
combobox bounds(231,192,40,14) channel("sync10") text("none","1","2","3","4","5","6","7","8","9")
combobox bounds(276,21,35,14) channel("env1") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(276,40,35,14) channel("env2") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(276,59,35,14) channel("env3") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(276,78,35,14) channel("env4") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(276,97,35,14) channel("env5") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(276,116,35,14) channel("env6") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(276,135,35,14) channel("env7") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(276,154,35,14) channel("env8") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(276,173,35,14) channel("env9") text("1","2","3","4","5","6","7","8","9","10")
combobox bounds(276,192,35,14) channel("env10") text("1","2","3","4","5","6","7","8","9","10")
rslider bounds(315, 18, 20, 20) channel("tc1") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(315, 37, 20, 20) channel("tc2") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(315, 56, 20, 20) channel("tc3") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(315, 75, 20, 20) channel("tc4") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(315, 94, 20, 20) channel("tc5") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(315, 113, 20, 20) channel("tc6") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(315, 132, 20, 20) channel("tc7") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(315, 151, 20, 20) channel("tc8") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(315, 170, 20, 20) channel("tc9") range(-24, 24, 0, 1, 1) $BASIC 
rslider bounds(315, 189, 20, 20) channel("tc10") range(-24, 24, 0, 1, 1) $BASIC
rslider bounds(335, 18, 20, 20) channel("tf1") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(335, 37, 20, 20) channel("tf2") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(335, 56, 20, 20) channel("tf3") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(335, 75, 20, 20) channel("tf4") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(335, 94, 20, 20) channel("tf5") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(335, 113, 20, 20) channel("tf6") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(335, 132, 20, 20) channel("tf7") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(335, 151, 20, 20) channel("tf8") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(335, 170, 20, 20) channel("tf9") range(-1, 1, 0, 1, 0.01) $BASIC 
rslider bounds(335, 189, 20, 20) channel("tf10") range(-1, 1, 0, 1, 0.01) $BASIC
nslider bounds(358,21,35,18) channel("up1") range(-24,24,2,1,.01)
nslider bounds(358,40,35,18) channel("up2") range(-24,24,2,1,.01)
nslider bounds(358,59,35,18) channel("up3") range(-24,24,2,1,.01)
nslider bounds(358,78,35,18) channel("up4") range(-24,24,2,1,.01)
nslider bounds(358,97,35,18) channel("up5") range(-24,24,2,1,.01)
nslider bounds(358,116,35,18) channel("up6") range(-24,24,2,1,.01)
nslider bounds(358,135,35,18) channel("up7") range(-24,24,2,1,.01)
nslider bounds(358,154,35,18) channel("up8") range(-24,24,2,1,.01)
nslider bounds(358,173,35,18) channel("up9") range(-24,24,2,1,.01)
nslider bounds(358,192,35,18) channel("up10") range(-24,24,2,1,.01)
nslider bounds(394,21,35,18) channel("down1") range(-24,24,2,1,.01)
nslider bounds(394,40,35,18) channel("down2") range(-24,24,2,1,.01)
nslider bounds(394,59,35,18) channel("down3") range(-24,24,2,1,.01)
nslider bounds(394,78,35,18) channel("down4") range(-24,24,2,1,.01)
nslider bounds(394,97,35,18) channel("down5") range(-24,24,2,1,.01)
nslider bounds(394,116,35,18) channel("down6") range(-24,24,2,1,.01)
nslider bounds(394,135,35,18) channel("down7") range(-24,24,2,1,.01)
nslider bounds(394,154,35,18) channel("down8") range(-24,24,2,1,.01)
nslider bounds(394,173,35,18) channel("down9") range(-24,24,2,1,.01)
nslider bounds(394,192,35,18) channel("down10") range(-24,24,2,1,.01)
combobox bounds(431,21,50,14) channel("fm1") text("none", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(431,40,50,14) channel("fm2") text("none", "Osc 1", "Osc 3", "Osc 4", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(431,59,50,14) channel("fm3") text("none", "Osc 1", "Osc 2", "Osc 4", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(431,78,50,14) channel("fm4") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(431,97,50,14) channel("fm5") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(431,116,50,14) channel("fm6") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(431,135,50,14) channel("fm7") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(431,154,50,14) channel("fm8") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 7", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(431,173,50,14) channel("fm9") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 7", "Osc 8", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(431,192,50,14) channel("fm10") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 7", "Osc 8", "Osc 9", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
rslider bounds(484, 18, 20, 20) channel("ind1") range(0, 75, 1, .5, 0.01) identChannel("fi1") visible(0) $BASIC 
rslider bounds(484, 37, 20, 20) channel("ind2") range(0, 75, 1, .5, 0.01) identChannel("fi2") visible(0) $BASIC 
rslider bounds(484, 56, 20, 20) channel("ind3") range(0, 75, 1, .5, 0.01) identChannel("fi3") visible(0) $BASIC 
rslider bounds(484, 75, 20, 20) channel("ind4") range(0, 75, 1, .5, 0.01) identChannel("fi4") visible(0) $BASIC 
rslider bounds(484, 94, 20, 20) channel("ind5") range(0, 75, 1, .5, 0.01) identChannel("fi5") visible(0) $BASIC 
rslider bounds(484, 113, 20, 20) channel("ind6") range(0, 75, 1, .5, 0.01) identChannel("fi6") visible(0) $BASIC 
rslider bounds(484, 132, 20, 20) channel("ind7") range(0, 75, 1, .5, 0.01) identChannel("fi7") visible(0) $BASIC 
rslider bounds(484, 151, 20, 20) channel("ind8") range(0, 75, 1, .5, 0.01) identChannel("fi8") visible(0) $BASIC 
rslider bounds(484, 170, 20, 20) channel("ind9") range(0, 75, 1, .5, 0.01) identChannel("fi9") visible(0) $BASIC 
rslider bounds(484, 189, 20, 20) channel("ind10") range(0, 75, 1, .5, 0.01) identChannel("fi10") visible(0) $BASIC
combobox bounds(507,21,35,14) channel("fmenv1") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe1") visible(0) 
combobox bounds(507,40,35,14) channel("fmenv2") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe2") visible(0) 
combobox bounds(507,59,35,14) channel("fmenv3") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe3") visible(0) 
combobox bounds(507,78,35,14) channel("fmenv4") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe4") visible(0) 
combobox bounds(507,97,35,14) channel("fmenv5") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe5") visible(0) 
combobox bounds(507,116,35,14) channel("fmenv6") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe6") visible(0) 
combobox bounds(507,135,35,14) channel("fmenv7") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe7") visible(0) 
combobox bounds(507,154,35,14) channel("fmenv8") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe8") visible(0) 
combobox bounds(507,173,35,14) channel("fmenv9") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe9") visible(0) 
combobox bounds(507,192,35,14) channel("fmenv10") text("1","2","3","4","5","6","7","8","9","10") identChannel("fe10") visible(0) 
combobox bounds(548,21,50,14) channel("am1") text("none", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(548,40,50,14) channel("am2") text("none", "Osc 1", "Osc 3", "Osc 4", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(548,59,50,14) channel("am3") text("none", "Osc 1", "Osc 2", "Osc 4", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(548,78,50,14) channel("am4") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(548,97,50,14) channel("am5") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(548,116,50,14) channel("am6") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(548,135,50,14) channel("am7") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(548,154,50,14) channel("am8") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 7", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(548,173,50,14) channel("am9") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 7", "Osc 8", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(548,192,50,14) channel("am10") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 7", "Osc 8", "Osc 9", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
rslider bounds(601, 18, 20, 20) channel("aind1") range(0, 5, 1, 1, 0.001) identChannel("ai1") visible(0) $BASIC 
rslider bounds(601, 37, 20, 20) channel("aind2") range(0, 5, 1, 1, 0.001) identChannel("ai2") visible(0) $BASIC 
rslider bounds(601, 56, 20, 20) channel("aind3") range(0, 5, 1, 1, 0.001) identChannel("ai3") visible(0) $BASIC 
rslider bounds(601, 75, 20, 20) channel("aind4") range(0, 5, 1, 1, 0.001) identChannel("ai4") visible(0) $BASIC 
rslider bounds(601, 94, 20, 20) channel("aind5") range(0, 5, 1, 1, 0.001) identChannel("ai5") visible(0) $BASIC 
rslider bounds(601, 113, 20, 20) channel("aind6") range(0, 5, 1, 1, 0.001) identChannel("ai6") visible(0) $BASIC 
rslider bounds(601, 132, 20, 20) channel("aind7") range(0, 5, 1, 1, 0.001) identChannel("ai7") visible(0) $BASIC 
rslider bounds(601, 151, 20, 20) channel("aind8") range(0, 5, 1, 1, 0.001) identChannel("ai8") visible(0) $BASIC 
rslider bounds(601, 170, 20, 20) channel("aind9") range(0, 5, 1, 1, 0.001) identChannel("ai9") visible(0) $BASIC 
rslider bounds(601, 189, 20, 20) channel("aind10") range(0, 5, 1, 1, 0.001) identChannel("ai10") visible(0) $BASIC
combobox bounds(624,21,35,14) channel("amenv1") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae1") visible(0) 
combobox bounds(624,40,35,14) channel("amenv2") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae2") visible(0)
combobox bounds(624,59,35,14) channel("amenv3") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae3") visible(0)
combobox bounds(624,78,35,14) channel("amenv4") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae4") visible(0)
combobox bounds(624,97,35,14) channel("amenv5") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae5") visible(0)
combobox bounds(624,116,35,14) channel("amenv6") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae6") visible(0)
combobox bounds(624,135,35,14) channel("amenv7") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae7") visible(0)
combobox bounds(624,154,35,14) channel("amenv8") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae8") visible(0)
combobox bounds(624,173,35,14) channel("amenv9") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae9") visible(0)
combobox bounds(624,192,35,14) channel("amenv10") text("1","2","3","4","5","6","7","8","9","10") identChannel("ae10") visible(0)
combobox bounds(663,21,50,14) channel("rm1") text("none", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,40,50,14) channel("rm2") text("none", "Osc 1", "Osc 3", "Osc 4", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,59,50,14) channel("rm3") text("none", "Osc 1", "Osc 2", "Osc 4", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,78,50,14) channel("rm4") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 5", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,97,50,14) channel("rm5") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 6","Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,116,50,14) channel("rm6") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 7", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,135,50,14) channel("rm7") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 8", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,154,50,14) channel("rm8") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 7", "Osc 9", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,173,50,14) channel("rm9") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 7", "Osc 8", "Osc 10", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
combobox bounds(663,192,50,14) channel("rm10") text("none", "Osc 1", "Osc 2", "Osc 3", "Osc 4", "Osc 5", "Osc 6", "Osc 7", "Osc 8", "Osc 9", "LFO1", "LFO2", "LFO3", "LFO4", "LFO5", "LFO6", "LFO7", "LFO8", "LFO9", "LFO10", "Input")
}

;FX plants:
;Latched Lowpass 
image channel("i5") bounds(4,234,144,92) plant("LatchedLP") $PLANT
{
button bounds(2,2,70,18) channel("LLPon") text("Dynamic Filter","Dynamic Filter") value(0) $BUTTONS
button bounds(74,2,22,17) channel("LLPlp") text("LP","LP") value(1) $BUTTONS
button bounds(97,2,22,17) channel("LLPbp") text("BP","BP") value(0) $BUTTONS
button bounds(120,2,22,17) channel("LLPhp") text("HP","HP") value(0) $BUTTONS
label channel("l46") bounds(2,29,35,12) text("Freq") $FONT
label channel("l47") bounds(90,21,50,8) text("(pitch in MIDI)") $FONT
label channel("l48") bounds(59,31,25,10) text("ADSR") $FONT
combobox bounds(2,44,50,14) channel("LLPcfset") text("MIDI in","Static")
combobox bounds(57,44,32,14) channel("LLPadsr") text("1","2","3","4","5","6","7","8","9","10")
label channel("l49") bounds(85,31,35,8) text("Offset") identChannel("offsetlabel") visible(1) $FONT
rslider bounds(92,39,25,25) channel("offset") range(-36,36,12,1,.01) identChannel("LLPoffset") visible(1) $BASIC
label channel("l50") bounds(92,31,25,8) text("Base") identChannel("baselabel") visible(0) $FONT
rslider bounds(92,39,25,25) channel("base") range(20,120,84,1,.01) identChannel("LLPbase") visible(0) $BASIC
label channel("l51") bounds(110,31,35,8) text("Target") $FONT
rslider bounds(115,39,25,25) channel("target") range(-36,36,18,1,.01) $BASIC
label channel("l52") bounds(10,69,20,12) text("Q") $FONT
label channel("l53") bounds(59,60,25,10) text("ADSR") $FONT
combobox bounds(57,73,30,14) channel("LLPQadsr") text("1","2","3","4","5","6","7","8","9","10")
label channel("l54") bounds(92,60,25,8) text("Base") $FONT
rslider bounds(92,68,25,25) channel("LLPQbase") range(.5, 25, 5, 1, 0.01) $BASIC
label channel("l55") bounds(110,60,35,8) text("Target") $FONT
rslider bounds(115,68,25,25) channel("LLPQtarget") range(.5, 25, 10, 1, 0.01) $BASIC
}

;Noise Generators
;Static Noise Generator
image channel("i6") bounds(150,234,100,35) plant("Static") $PLANT
{
button bounds(5, 8, 40, 18) channel("duston") text("Static", "Static") value(0) $BUTTONS
label channel("l56") bounds(44,2,30,10) text("Amp") $FONT
rslider bounds(50,10,20,20) channel("dustamp") range(0,1.5,0,.5,.0001) $BASIC
label channel("l57") bounds(67,2,30,10) text("Rate") $FONT
rslider bounds(72,10,20,20) channel("dustrate") range(.5,250,25,.5,.1) $BASIC
}
;white noise generator
image channel("i7") bounds(252,234,72,35) plant("White") $PLANT
{
button bounds(3, 8, 40, 18) channel("whiteon") text("White", "White") value(0) $BUTTONS
label channel("l58") bounds(42,2,30,10) text("Amp") $FONT
rslider bounds(48,10,20,20) channel("whiteamp") range(0,1.5,0,.5,.0001) $BASIC
}
;pink noise generator
image channel("i8") bounds(327,234,72,35) plant("Pink") $PLANT
{
button bounds(3, 8, 40, 18) channel("pinkon") text("Pink", "Pink") value(0) $BUTTONS
label channel("l59") bounds(42,2,30,10) text("Amp") $FONT
rslider bounds(48,10,20,20) channel("pinkamp") range(0,1.5,0,.5,.0001) $BASIC
}
;gaussian noise generator
image channel("i9") bounds(402,234,82,35) plant("Gauss") $PLANT
{
button bounds(3, 8, 50, 18) channel("gausson") text("Gaussian", "Gaussian") value(0) $BUTTONS
label channel("l60") bounds(52,2,30,10) text("Amp") $FONT
rslider bounds(58,10,20,20) channel("gaussamp") range(0,1.5,0,.5,.0001) $BASIC
}

;Random Note Generator
image channel("i10") bounds(487,234,300,35) plant("Random Note Generator") $PLANT
{
button bounds(5, 2, 110, 15) channel("RNGon") text("Random Note Generator", "Random Note Generator") value(0) $BUTTONS
combobox bounds(5, 18, 73, 14) channel("RNGmicro") text("Equal Temp", "Microtonal", "1/4 Tone", "1/8 Tone", "Whole Tone", "Minor 3rds", "Major 3rds", "4ths", "Tritones", "5ths", "10 Tone", "13 Tone", "15 Tone", "7 Tone", "8 Tone")
button bounds(79, 18, 34, 14) channel("RNGgliss") text("S&H", "Gliss") value(0) $BUTTONS
button bounds(117,10,27,15) text("Rate") channel("mapRNGrate") $MIDI
button bounds(144,10,9,15) text("") channel("mapRNGrateX") $MIDIX
button bounds(177,10,27,15) text("R Dev") channel("mapRNGraterand") $MIDI
button bounds(204,10,9,15) text("") channel("mapRNGraterandX") $MIDIX
button bounds(237,10,27,15) text("F Dev") channel("mapRNGdev") $MIDI
button bounds(264,10,9,15) text("") channel("mapRNGdevX") $MIDIX
rslider bounds(152, 5, 25, 25) channel("RNGrate") range(0.01, 100, 3.3, .5, 0.01) $BASIC
rslider bounds(212, 5, 25, 25) channel("RNGraterand") range(0, .95, 0, 1, 0.01) $BASIC
rslider bounds(272, 5, 25, 25) channel("RNGdev") range(0, 60, 6, 1, 0.01) $BASIC
}

;Distortion
image channel("i11") bounds(790,234,253,35) plant("Distort") $PLANT
{
button bounds(5,8,50,18) channel("diston") text("Distort", "Distort") value(0) $BUTTONS
button bounds(58,10,27,15) text("Dist") channel("mapdist") $MIDI
button bounds(85,10,9,15) text("") channel("mapdistX") $MIDIX
button bounds(121,10,30,15) text("Shape") channel("mapdist2") $MIDI
button bounds(151,10,9,15) text("") channel("mapdist2X") $MIDIX
button bounds(187,10,27,15) text("Fold") channel("mapdist3") $MIDI
button bounds(214,10,9,15) text("") channel("mapdist3X") $MIDIX
rslider bounds(94, 5, 25, 25) channel("distA") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(160, 5, 25, 25) channel("distB") range(0, .999, 0, 1, 0.001) $BASIC 
rslider bounds(223, 5, 25, 25) channel("distC") range(1, 25, 1, .5, 0.001) $BASIC 
}

;Vibrato (LFO Modulation, controller 1)
image channel("i12") bounds(4,328,93,162) plant("Vib") $PLANT
{
label channel("l61") bounds(0,2,50,12) text("Vibrato") $FONT
button bounds(53,15,27,15) text("R Dev") channel("mapvibrand") $MIDI
button bounds(80,15,9,15) text("") channel("mapvibrandX") $MIDIX
rslider bounds(33,12,20,20) channel("vibrand") range(0, .99, 0.05, .5, 0.001) $BASIC
button bounds(8,143,27,15) text("Rate") channel("mapvibcps") $MIDI
button bounds(35,143,9,15) text("") channel("mapvibcpsX") $MIDIX
vslider bounds(13,50,25,95) channel("vibcps") range(0, 1, 0, .5, .01) $VBASIC
button bounds(53,143,27,15) text("Depth") channel("mapvibdepth") $MIDI
button bounds(80,143,9,15) text("") channel("mapvibdepthX") $MIDIX
vslider bounds(55,50,25,95) channel("vibdepth") range(0, 1, .5, .5, 0.01) $VBASIC
label channel("l62") bounds(3,25,25,10) text("max:") fontColour(255,255,255,255)
nslider bounds(1,37,45,18) channel("vibcpsmax") range(0,2500,10,1,.01)
nslider bounds(45,37,45,18) channel("vibdepthmax") range(0,48,.75,1,.01)
}

;LP Filter
image channel("i13") bounds(150,271,82,108) plant("LP") $PLANT
{
button bounds(18,2,45,17) channel("LPon") text("Lowpass", "Lowpass") value(0) $BUTTONS
combobox bounds(11,20,60,12) channel("LPsel") text("-6 dB","-12 dB","-18 dB","-24 dB")
label channel("l63") bounds(33,35,55,8) text("rate depth") $FONT
label channel("l64") bounds(45,59,25,8) text("rand") $FONT
button bounds(3,35,27,13) text("Cutoff") channel("mapLPcps") $MIDI
button bounds(30,35,9,13) text("") channel("mapLPcpsX") $MIDIX
rslider bounds(8,46,25,25) channel("LPcps") range(2, 14, 11, 1, .001) $BASIC ;pitch expressed in oct
button bounds(3,70,27,13) text("Res") channel("mapLPres") $MIDI
button bounds(30,70,9,13) text("") channel("mapLPresX") $MIDIX
rslider bounds(8,81,25,25) channel("LPres") range(0.01, .99, 0.1, 1, 0.01) $BASIC
rslider bounds(40,42,20,20) channel("LPcfr") range(0,75,0,.5,.01) $BASIC
rslider bounds(58,42,20,20) channel("LPcfd") range(0,2.5,0,.5,.01) $BASIC
rslider bounds(49,65,20,20) channel("LPrand") range(0,.95,0,1,.01) $BASIC
rslider bounds(40,85,20,20) channel("LPresr") range(0,75,0,.5,.01) $BASIC
rslider bounds(58,85,20,20) channel("LPresd") range(0,2.5,0,.5,.01) $BASIC
}

;Parallel Filters (selectable)
image channel("i14") bounds(235,271,173,108) plant("parallel") $PLANT
{
button bounds(5,2,45,17) channel("paron") text("Filters") value(0) $BUTTONS
combobox bounds(53,3,80,15) channel("vpresets") text("Voice Formants","Soprano ah","Soprano eh","Soprano ih","Soprano oh","Soprano uh","Alto ah","Alto eh","Alto ih","Alto oh","Alto uh","Tenor ah","Tenor eh","Tenor ih","Tenor oh","Tenor uh","Bass ah","Bass eh","Bass ih","Bass oh","Bass uh", )
label channel("l65") bounds(131,5,25,8) text("port") $FONT
rslider bounds(153,0,20,20) channel("fport") range(0,5,.1,.25,0.01) $BASIC 
label channel("l66") bounds(5,20,35,10) text("Select") $FONT
label channel("l67") bounds(36,20,35,10) text("Cutoff") $FONT
label channel("l68") bounds(68,23,55,8) text("rate depth rand") $FONT
label channel("l69") bounds(118,20,35,10) text("Res") $FONT
label channel("l70") bounds(140,20,35,10) text("Amp") $FONT
combobox bounds(5,34,36,12) channel("parsel1") text("LP","BP","HP","off") value(1)
combobox bounds(5,53,36,12) channel("parsel2") text("LP","BP","HP","off") value(2)
combobox bounds(5,72,36,12) channel("parsel3") text("LP","BP","HP","off") value(2)
combobox bounds(5,91,36,12) channel("parsel4") text("LP","BP","HP","off") value(3)
rslider bounds(41,27,25,25) channel("parF1") range(2, 14, 8, 1, 0.001) $BASIC ;expressing pitch in oct and resonance needs to be between .5-25
rslider bounds(41,46,25,25) channel("parF2") range(2, 14, 9, 1, 0.001) $BASIC
rslider bounds(41,65,25,25) channel("parF3") range(2, 14, 10, 1, 0.001) $BASIC
rslider bounds(41,84,25,25) channel("parF4") range(2, 14, 11, 1, 0.001) $BASIC
rslider bounds(68,30,20,20) channel("parcfr1") range(0,75,0,.5,.01) $BASIC
rslider bounds(68,49,20,20) channel("parcfr2") range(0,75,0,.5,.01) $BASIC
rslider bounds(68,68,20,20) channel("parcfr3") range(0,75,0,.5,.01) $BASIC
rslider bounds(68,87,20,20) channel("parcfr4") range(0,75,0,.5,.01) $BASIC
rslider bounds(86,30,20,20) channel("parcfd1") range(0,2.5,0,.5,.001) $BASIC ;depth calculated in oct as well
rslider bounds(86,49,20,20) channel("parcfd2") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(86,68,20,20) channel("parcfd3") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(86,87,20,20) channel("parcfd4") range(0,2.5,0,.5,.001) $BASIC
rslider bounds(104,30,20,20) channel("parcfrnd1") range(0,.95,0,1,.01) $BASIC
rslider bounds(104,49,20,20) channel("parcfrnd2") range(0,.95,0,1,.01) $BASIC
rslider bounds(104,68,20,20) channel("parcfrnd3") range(0,.95,0,1,.01) $BASIC
rslider bounds(104,87,20,20) channel("parcfrnd4") range(0,.95,0,1,.01) $BASIC
rslider bounds(123,27,25,25) channel("parres1") range(.5, 25, 1, 1, 0.01) $BASIC 
rslider bounds(123,46,25,25) channel("parres2") range(.5, 25, 1, 1, 0.01) $BASIC 
rslider bounds(123,65,25,25) channel("parres3") range(.5, 25, 1, 1, 0.01) $BASIC 
rslider bounds(123,84,25,25) channel("parres4") range(.5, 25, 1, 1, 0.01) $BASIC 
rslider bounds(145,27,25,25) channel("paramp1") range(0, 1.5, 1, 1, 0.001) $BASIC 
rslider bounds(145,46,25,25) channel("paramp2") range(0, 1.5, 1, 1, 0.001) $BASIC 
rslider bounds(145,65,25,25) channel("paramp3") range(0, 1.5, 1, 1, 0.001) $BASIC 
rslider bounds(145,84,25,25) channel("paramp4") range(0, 1.5, 1, 1, 0.001) $BASIC 
}

;phaser
image channel("i15") bounds(411,271,72,108) plant("Phaser") $PLANT
{
button bounds(13,2,45,17) channel("phson") text("Phaser", "Phaser") $BUTTONS
button bounds(7,32,27,15) text("Speed") channel("mapphscps") $MIDI
button bounds(34,32,9,15) text("") channel("mapphscpsX") $MIDIX
rslider bounds(44,27,25,25) channel("phscps") range(0.01, 100, .4, 0.25, 0.01) $BASIC
button bounds(7,55,27,15) text("FB") channel("mapphsFB") $MIDI
button bounds(34,55,9,15) text("") channel("mapphsFBX") $MIDIX
rslider bounds(44,50,25,25) channel("phsFB") range(0, 1, 0.5, 1, 0.01) $BASIC
button bounds(7,78,27,15) text("Q") channel("mapphsQ") $MIDI
button bounds(34,78,9,15) text("") channel("mapphsQX") $MIDIX
rslider bounds(44,74,25,25) channel("phsQ") range(0.01, 100, 1, .25, 0.01) $BASIC
}

;flanger
image channel("i16") bounds(485,271,55,108) plant("Flanger") $PLANT
{
button bounds(7,2,40,17) channel("flon") text("Flanger", "Flanger") $BUTTONS
button bounds(10,28,27,15) text("Speed") channel("mapflcps") $MIDI
button bounds(37,28,9,15) text("") channel("mapflcpsX") $MIDIX
rslider bounds(15,41,25,25) channel("flcps") range(0.01, 100, .05, 0.25, 0.01) $BASIC
button bounds(10,64,27,15) text("FB") channel("mapflFB") $MIDI
button bounds(37,64,9,15) text("") channel("mapflFBX") $MIDIX
rslider bounds(15,77,25,25) channel("flFB") range(0, .99, 0.5, 1, 0.01) $BASIC
}

;Transposer/Harmonizer
image channel("i17") bounds(542,271,248,108) plant("Transposer") $PLANT
{
button bounds(4,2,58,17) channel("ton") text("Transposer", "Transposer") $BUTTONS
button bounds(87,6,27,12) text("Mix") channel("mapharmmix") $MIDI
button bounds(114,6,9,12) text("") channel("mapharmmixX") $MIDIX
rslider bounds(62, 0, 25, 25) channel("harmmix") range(0, 1, .5, 1, 0.01) $BASIC
combobox bounds(128,3,80,15) channel("Tpresets") text("Fat","Fatter","Warble","5ths","4ths","M3rds","Mi3rds","Cluster 1","Cluster 2","Whole Tones","Stacked 5ths","Stacked 4ths","Stacked M3rds","Stacked Mi3rds","8ves","Big 5ths","Major","Minor","V7","M7","M9","Mi7","Sus","V7sus","V7+9","V9","V7+9B")
label channel("l71") bounds(206,5,25,8) text("port") $FONT
rslider bounds(228,0,20,20) channel("Tport") range(0,5,.02,.25,0.01) $BASIC 
 
button bounds(5,21,18,13) channel("harmon1") text("Off", "On") value(1) $BUTTONS
button bounds(5,35,27,13) text("Coarse") channel("mapharmon1C") $MIDI
button bounds(32,35,9,13) text("") channel("mapharmon1CX") $MIDIX
rslider bounds(8, 46, 25, 25) channel("harmon1C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(7,70,27,13) text("Fine") channel("mapharmon1F") $MIDI
button bounds(34,70,9,13) text("") channel("mapharmon1FX") $MIDIX
rslider bounds(8, 81, 25, 25) channel("harmon1F") range(-1, 1, .14, 1, 0.01) $BASIC
button bounds(45,21,18,13) channel("harmon2") text("Off", "On") value(1) $BUTTONS
button bounds(45,35,27,13) text("Coarse") channel("mapharmon2C") $MIDI
button bounds(72,35,9,13) text("") channel("mapharmon2CX") $MIDIX
rslider bounds(48, 46, 25, 25) channel("harmon2C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(45,70,27,13) text("Fine") channel("mapharmon2F") $MIDI
button bounds(72,70,9,13) text("") channel("mapharmon2FX") $MIDIX
rslider bounds(48, 81, 25, 25) channel("harmon2F") range(-1, 1, 0-.16, 1, 0.01) $BASIC
button bounds(85,21,18,13) channel("harmon3") text("Off", "On") value(1) $BUTTONS
button bounds(85,35,27,13) text("Coarse") channel("mapharmon3C") $MIDI
button bounds(112,35,9,13) text("") channel("mapharmon3CX") $MIDIX
rslider bounds(88, 46, 25, 25) channel("harmon3C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(85,70,27,13) text("Fine") channel("mapharmon3F") $MIDI
button bounds(112,70,9,13) text("") channel("mapharmon3FX") $MIDIX
rslider bounds(88, 81, 25, 25) channel("harmon3F") range(-1, 1, .09, 1, 0.01) $BASIC
button bounds(125,21,18,13) channel("harmon4") text("Off", "On") value(1) $BUTTONS
button bounds(125,35,27,13) text("Coarse") channel("mapharmon4C") $MIDI
button bounds(152,35,9,13) text("") channel("mapharmon4CX") $MIDIX
rslider bounds(128, 46, 25, 25) channel("harmon4C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(125,70,27,13) text("Fine") channel("mapharmon4F") $MIDI
button bounds(152,70,9,13) text("") channel("mapharmon4FX") $MIDIX
rslider bounds(128, 81, 25, 25) channel("harmon4F") range(-1, 1, 0-.12, 1, 0.01) $BASIC
button bounds(165,21,18,13) channel("harmon5") text("Off", "On") value(1) $BUTTONS
button bounds(165,35,27,13) text("Coarse") channel("mapharmon5C") $MIDI
button bounds(192,35,9,13) text("") channel("mapharmon5CX") $MIDIX
rslider bounds(168, 46, 25, 25) channel("harmon5C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(165,70,27,13) text("Fine") channel("mapharmon5F") $MIDI
button bounds(192,70,9,13) text("") channel("mapharmon5FX") $MIDIX
rslider bounds(168, 81, 25, 25) channel("harmon5F") range(-1, 1, 0.11, 1, 0.01) $BASIC
button bounds(205,21,18,13) channel("harmon6") text("Off", "On") value(1) $BUTTONS
button bounds(205,35,27,13) text("Coarse") channel("mapharmon6C") $MIDI
button bounds(232,35,9,13) text("") channel("mapharmon6CX") $MIDIX
rslider bounds(208, 46, 25, 25) channel("harmon6C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(205,70,27,13) text("Fine") channel("mapharmon6F") $MIDI
button bounds(232,70,9,13) text("") channel("mapharmon6FX") $MIDIX
rslider bounds(208, 81, 25, 25) channel("harmon6F") range(-1, 1, -.05, 1, 0.01) $BASIC
}

;Chorus
image channel("i18") bounds(792,271,123,108) plant("Chorus") $PLANT
{
;label bounds(2, 2, 35, 10) text("Chorus") $FONT
button bounds(40,2,45,17) channel("chon") text("Chorus", "Chorus") $BUTTONS
button bounds(5,24,27,15) text("Mix") channel("mapchmix") $MIDI
button bounds(32,24,9,15) text("") channel("mapchmixX") $MIDIX
button bounds(44,24,27,15) text("Rate") channel("mapchcps") $MIDI
button bounds(71,24,9,15) text("") channel("mapchcpsX") $MIDIX
button bounds(83,24,27,15) text("FB") channel("mapchFB") $MIDI
button bounds(110,24,9,15) text("") channel("mapchFBX") $MIDIX
rslider bounds(9, 37, 25, 25) channel("chmix") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(48, 37, 25, 25) channel("chcps") range(.01, 25, .5, .5, 0.001) $BASIC 
rslider bounds(87, 37, 25, 25) channel("chFB") range(0, .999, .7, 1, 0.001) $BASIC 
button bounds(5,60,27,15) text("Depth") channel("mapchdepth") $MIDI
button bounds(32,60,9,15) text("") channel("mapchdepthX") $MIDIX
button bounds(43,60,27,15) text("Delay") channel("mapchdel") $MIDI
button bounds(71,60,9,15) text("") channel("mapchdelX") $MIDIX
button bounds(83,60,27,15) text("Rand") channel("mapchrand") $MIDI
button bounds(110,60,9,15) text("") channel("mapchrandX") $MIDIX
rslider bounds(9, 73, 25, 25) channel("chdepth") range(.1, 50, 1.5, .5, 0.01) $BASIC 
rslider bounds(48, 73, 25, 25) channel("chdel") range(.1, 50, 15, 1, 0.01) $BASIC 
rslider bounds(87, 73, 25, 25) channel("chrand") range(0, .9, .1, .5, 0.001) $BASIC 
}

;delay
image channel("i19") bounds(917,271,52,108) plant("Delay") $PLANT
{
;label bounds(2,2,30,10) text("Delay") $FONT
button bounds(6,2,40,17) channel("delon") text("Delay", "Delay") $BUTTONS
button bounds(8,24,27,15) text("Time") channel("mapdeltime") $MIDI
button bounds(35,24,9,15) text("") channel("mapdeltimeX") $MIDIX
rslider bounds(13,37,25,25) channel("deltime") range(0.001, 4.99, .08, 0.25, 0.0001) $BASIC
button bounds(8,60,27,15) text("FB") channel("mapdelFB") $MIDI
button bounds(35,60,9,15) text("") channel("mapdelFBX") $MIDIX
rslider bounds(13,73,25,25) channel("delFB") range(0, .99, .35, 1, 0.01) $BASIC
}

;reverbsc
image channel("i20") bounds(971,271,72,108) plant("Reverb") $PLANT
{
;label bounds(2,2,40,10) text("Reverb") $FONT
button bounds(14,2,45,17) channel("revon") text("Reverb", "Reverb") $BUTTONS
button bounds(5,28,30,15) text("Mix") channel("maprevmix") $MIDI
button bounds(35,28,9,15) text("") channel("maprevmixX") $MIDIX
rslider bounds(44,23,25,25) channel("revmix") range(0,1, .35, 1, 0.01) $BASIC
button bounds(5,51,30,15) text("Decay") channel("maprevFB") $MIDI
button bounds(35,51,9,15) text("") channel("maprevFBX") $MIDIX
rslider bounds(44,46,25,25) channel("revFB") range(0.01,0.999, .75, 1.75, 0.001) $BASIC
button bounds(5,74,30,15) text("LP") channel("maprevLP") $MIDI
button bounds(35,74,9,15) text("") channel("maprevLPX") $MIDIX
rslider bounds(44,69,25,25) channel("revLP") range(200, 20000, 12500, .5, 10) $BASIC
}

;ribbon controller
image channel("i21") bounds(150,381,892,25) plant("ribbon") $PLANT
{
button bounds(5,5,40,15) text("Ribbon") channel("maprib") $MIDI
button bounds(45,5,9,15) text("") channel("mapribX") $MIDIX
hslider bounds(56,2,795,20) channel("ribbon") range(-36, 36, 0, 1, .0001) valueTextBox(1) textBoxColour("black") textColour("Gainsboro") $VBASIC
button bounds(857,4,30,17) channel("ribon") text("Off", "On") $BUTTONS
}

;Morph slider
image channel("i22") bounds(1046,20,40,470) plant("Morph") $PLANT
{
label channel("l72") bounds(2,2,35,12) text("Morph") $FONT
vslider bounds(5,12,30,428) channel("morph") range(0, 7, 4.5, 1, 0.001) $VBASIC
button bounds(2,448,27,15) text("Morph") channel("mapmorph") $MIDI
button bounds(29,448,9,15) text("") channel("mapmorphX") $MIDIX
}

</Cabbage>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CSOUND CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5 --displays ;sends MIDI note number and velocity to instr 1 as p4 and p5 respectively
</CsOptions>
<CsInstruments>

; Initialize the global variables. 
;sr = 48000
gisr=sr
ksmps = 100
nchnls = 2
0dbfs = 1
massign	0,10

gaSynL,gaSynR init 0   ;global synth sends to effects, need global to send all instances of instr 1 to FX
gaChorL,gaChorR init 0  ;global audio for chorus effect
gaDelL,gaDelR init 0   ;global feedback delay lines sends to reverb
gaFXL,gaFXR init 0    ;send to global reverb and audio outs
gamicL, gamicR, gasfL, gasfR init 0
galiveL,galiveR,galiveRM,galiveAM init 0
gkliveFM init 0
galfo1,galfo2,galfo3,galfo4,galfo5,galfo6,galfo7,galfo8,galfo9,galfo10 init 0 ;bipolar LFO signals used for RM
galfo1u,galfo2u,galfo3u,galfo4u,galfo5u,galfo6u,galfo7u,galfo8u,galfo9u,galfo10u init 0 ;unipolar LFO signals used for AM
gkstatus,gkchan,gkdata1,gkdata2 init 0 ;initialize global MIDI settings
gichnls init 0 ;globals for soundfile table loading
giReady init 0
gSfilepath init ""
gkTabLen init 2
giTable init 501
gimorph ftgen 98,0,8,-2,101,102,103,104,105,106,107,108
gkRecordingActiveFlag,gkFileRecorded init 0

instr 1   ;live audio input and record/play control
kplay   chnget  "sfplay"
gSfilepath chnget "openFile"
    
if changed(gSfilepath) == 1 then ;loads soundfile
    SIdentString sprintfk "file(\"%s\")", gSfilepath
;    chnset SIdentString, "filer"
    event   "i",3,0,0
endif
        
if changed(kplay) == 1 then ;turns on soundfile player
    if kplay=1 then 
    event "i",2,0,10000
    else
    turnoff2  2,0,.05
    endif
endif

kliveon chnget "liveon"
kliveon port kliveon,.025
klivech chnget "livech"
kliveamp chnget "liveamp"

ainL,ainR ins
ainL=ainL*kliveon*kliveamp
ainR=ainR*kliveon*kliveamp
if klivech=1 then
gamicL=ainL
gamicR=ainR
else
gamicL=ainL+ainR
gamicR=ainL+ainR
endif

gkrecord	chnget	"record"
gkplay		chnget	"play"
kRecStart	trigger	gkrecord,0.5,0
  if kRecStart==1 && gkRecordingActiveFlag==0 then
    event	"i",600,0,-1
    gkRecordingActiveFlag	=	1
  endif
  kPlayStart	trigger	gkplay,0.5,0
  if kPlayStart==1 && gkFileRecorded==1 then
    event	"i",601,ksmps/sr,3600
  endif
  
;this final section loads the selected function table numbers to f98 to control ftmorf
kfn1 chnget "fn1"
kfn2 chnget "fn2"
kfn3 chnget "fn3"
kfn4 chnget "fn4"
kfn5 chnget "fn5"
kfn6 chnget "fn6"
kfn7 chnget "fn7"
kfn8 chnget "fn8"
ktrigger changed kfn1,kfn2,kfn3,kfn4,kfn5,kfn6,kfn7,kfn8
if ktrigger=1 then
event "f",gimorph,0,8,-2,kfn1+100,kfn2+100,kfn3+100,kfn4+100,kfn5+100,kfn6+100,kfn7+100,kfn8+100
endif

kmorph chnget "morph"
kmorph port kmorph,.05
ftmorf kmorph,gimorph,99

endin

instr 2
kloop chnget "sfloop"
iloop=i(kloop)
kingain chnget  "sfamp"
kEnv linsegr 0,.05,1,p3-.05,1,.1,0
    if  gichnls==1 then
    a1  loscil 1,1,giTable,1,iloop
    gasfL=a1*kingain*kEnv;*ksfon ;add output into global audio mix
    gasfR=a1*kingain*kEnv;*ksfon
    elseif  gichnls==2 then
    a1,a2   loscil  1,1,giTable,1,iloop
    gasfL=a1*kingain*kEnv;*ksfon
    gasfR=a2*kingain*kEnv;*ksfon
    endif
endin

instr 3
giTable ftgen   1,0,0,1,gSfilepath,0,0,0
gichnls filenchnls  gSfilepath
giReady=1 ;default if no string has been loaded yet
gkTabLen    init    ftlen(giTable)/gichnls
Smessage    sprintfk    "file(%s)", gSfilepath
endin

instr 4 ;mixes mic/line and soundfile player to create signal to send 
klivetoOsc chnget "livetoOsc"
klivetoOsc port klivetoOsc,.025
klivetoFX chnget "livetoFX"
klivetoFX port klivetoFX,.025
ainL=gamicL+gasfL
ainR=gamicR+gasfR
galiveL=ainL*klivetoFX
galiveR=ainR*klivetoFX
galiveRM=((ainL+ainR)*.7)*klivetoOsc
galiveAM=(galiveRM*.5*klivetoOsc)+.5
endin

instr 5    ;global LFO data
klfo1on chnget "lfo1"
klfo2on chnget "lfo2"
klfo3on chnget "lfo3"
klfo4on chnget "lfo4"
klfo5on chnget "lfo5"
klfo6on chnget "lfo6"
klfo7on chnget "lfo7"
klfo8on chnget "lfo8"
klfo9on chnget "lfo9"
klfo10on chnget "lfo10"
klfo1fn chnget "lfo1fn"
klfo2fn chnget "lfo2fn"
klfo3fn chnget "lfo3fn"
klfo4fn chnget "lfo4fn"
klfo5fn chnget "lfo5fn"
klfo6fn chnget "lfo6fn"
klfo7fn chnget "lfo7fn"
klfo8fn chnget "lfo8fn"
klfo9fn chnget "lfo9fn"
klfo10fn chnget "lfo10fn"
klfo1r chnget "lfo1r"
klfo2r chnget "lfo2r"
klfo3r chnget "lfo3r"
klfo4r chnget "lfo4r"
klfo5r chnget "lfo5r"
klfo6r chnget "lfo6r"
klfo7r chnget "lfo7r"
klfo8r chnget "lfo8r"
klfo9r chnget "lfo9r"
klfo10r chnget "lfo10r"
klfo1x10 chnget "lfo1x10"
klfo1x10=1+(klfo1x10*9)
klfo2x10 chnget "lfo2x10"
klfo2x10=1+(klfo2x10*9)
klfo3x10 chnget "lfo3x10"
klfo3x10=1+(klfo3x10*9)
klfo4x10 chnget "lfo4x10"
klfo4x10=1+(klfo4x10*9)
klfo5x10 chnget "lfo5x10"
klfo5x10=1+(klfo5x10*9)
klfo6x10 chnget "lfo6x10"
klfo6x10=1+(klfo6x10*9)
klfo7x10 chnget "lfo7x10"
klfo7x10=1+(klfo7x10*9)
klfo8x10 chnget "lfo8x10"
klfo8x10=1+(klfo8x10*9)
klfo9x10 chnget "lfo9x10"
klfo9x10=1+(klfo9x10*9)
klfo10x10 chnget "lfo10x10"
klfo10x10=1+(klfo10x10*9)
klfo1x100 chnget "lfo1x100"
klfo1x100=1+(klfo1x100*99)
klfo2x100 chnget "lfo2x100"
klfo2x100=1+(klfo2x100*99)
klfo3x100 chnget "lfo3x100"
klfo3x100=1+(klfo3x100*99)
klfo4x100 chnget "lfo4x100"
klfo4x100=1+(klfo4x100*99)
klfo5x100 chnget "lfo5x100"
klfo5x100=1+(klfo5x100*99)
klfo6x100 chnget "lfo6x100"
klfo6x100=1+(klfo6x100*99)
klfo7x100 chnget "lfo7x100"
klfo7x100=1+(klfo7x100*99)
klfo8x100 chnget "lfo8x100"
klfo8x100=1+(klfo8x100*99)
klfo9x100 chnget "lfo9x100"
klfo9x100=1+(klfo9x100*99)
klfo10x100 chnget "lfo10x100"
klfo10x100=1+(klfo10x100*99)
klfo1j chnget "lfo1j"
klfo2j chnget "lfo2j"
klfo3j chnget "lfo3j"
klfo4j chnget "lfo4j"
klfo5j chnget "lfo5j"
klfo6j chnget "lfo6j"
klfo7j chnget "lfo7j"
klfo8j chnget "lfo8j"
klfo9j chnget "lfo9j"
klfo10j chnget "lfo10j"

klfo1F=klfo1r*klfo1x10*klfo1x100 ;calculate base cps
kjit1 jitter klfo1j*klfo1F,4,10 ;create jitter relative to base cps
klfo1cps=klfo1F+kjit1 ;add together for final cps for oscillators
if klfo1fn = 1 then
galfo1 oscili 1,klfo1cps,25
elseif klfo1fn = 2 then 
galfo1 oscili 1,klfo1cps,30
elseif klfo1fn = 3 then 
galfo1 oscili 1,klfo1cps,31
elseif klfo1fn = 4 then 
galfo1 oscili 1,klfo1cps,32
elseif klfo1fn = 5 then 
galfo1 oscili 1,klfo1cps,33
elseif klfo1fn = 6 then 
galfo1 oscili 1,klfo1cps,34
elseif klfo1fn = 7 then 
galfo1 randh 1,klfo1cps
elseif klfo1fn = 8 then 
galfo1 randi 1,klfo1cps
endif
if klfo1r==0 goto Z1
galfo1=galfo1*klfo1on
goto NEXT1
Z1:
galfo1=0
NEXT1:
galfo1u=(galfo1*.5)+.5 ;a-rate LFO used for AM

klfo2F=klfo2r*klfo2x10*klfo2x100
kjit2 jitter klfo2j*klfo2F,4,10
klfo2cps=klfo2F+kjit2
if klfo2fn = 1 then
galfo2 oscili 1,klfo2cps,25
elseif klfo2fn = 2 then 
galfo2 oscili 1,klfo2cps,30
elseif klfo2fn = 3 then 
galfo2 oscili 1,klfo2cps,31
elseif klfo2fn = 4 then 
galfo2 oscili 1,klfo2cps,32
elseif klfo2fn = 5 then 
galfo2 oscili 1,klfo2cps,33
elseif klfo2fn = 6 then 
galfo2 oscili 1,klfo2cps,34
elseif klfo2fn = 7 then 
galfo2 randh 1,klfo2cps
elseif klfo2fn = 8 then 
galfo2 randi 1,klfo2cps
endif
if klfo2r==0 goto Z2
galfo2=galfo2*klfo2on
goto NEXT2
Z2:
galfo2=0
NEXT2:
galfo2u=(galfo2*.5)+.5

klfo3F=klfo3r*klfo3x10*klfo3x100
kjit3 jitter klfo3j*klfo3F,4,10
klfo3cps=klfo3F+kjit3
if klfo3fn = 1 then
galfo3 oscili 1,klfo3cps,25
elseif klfo3fn = 2 then 
galfo3 oscili 1,klfo3cps,30
elseif klfo3fn = 3 then 
galfo3 oscili 1,klfo3cps,31
elseif klfo3fn = 4 then 
galfo3 oscili 1,klfo3cps,32
elseif klfo3fn = 5 then 
galfo3 oscili 1,klfo3cps,33
elseif klfo3fn = 6 then 
galfo3 oscili 1,klfo3cps,34
elseif klfo3fn = 7 then 
galfo3 randh 1,klfo3cps
elseif klfo3fn = 8 then 
galfo3 randi 1,klfo3cps
endif
if klfo3r==0 goto Z3
galfo3=galfo3*klfo3on
goto NEXT3
Z3:
galfo3=0
NEXT3:
galfo3u=(galfo3*.5)+.5

klfo4F=klfo4r*klfo4x10*klfo4x100
kjit4 jitter klfo4j*klfo4F,4,10
klfo4cps=klfo4F+kjit4
if klfo4fn = 1 then
galfo4 oscili 1,klfo4cps,25
elseif klfo4fn = 2 then 
galfo4 oscili 1,klfo4cps,30
elseif klfo4fn = 3 then 
galfo4 oscili 1,klfo4cps,31
elseif klfo4fn = 4 then 
galfo4 oscili 1,klfo4cps,32
elseif klfo4fn = 5 then 
galfo4 oscili 1,klfo4cps,33
elseif klfo4fn = 6 then 
galfo4 oscili 1,klfo4cps,34
elseif klfo4fn = 7 then 
galfo4 randh 1,klfo4cps
elseif klfo4fn = 8 then 
galfo4 randi 1,klfo4cps
endif
if klfo4r==0 goto Z4
galfo4=galfo4*klfo4on
goto NEXT4
Z4:
galfo4=0
NEXT4:
galfo4u=(galfo4*.5)+.5

klfo5F=klfo5r*klfo5x10*klfo5x100
kjit5 jitter klfo5j*klfo5F,4,10
klfo5cps=klfo5F+kjit5
if klfo5fn = 1 then
galfo5 oscili 1,klfo5cps,25
elseif klfo5fn = 2 then 
galfo5 oscili 1,klfo5cps,30
elseif klfo5fn = 3 then 
galfo5 oscili 1,klfo5cps,31
elseif klfo5fn = 4 then 
galfo5 oscili 1,klfo5cps,32
elseif klfo5fn = 5 then 
galfo5 oscili 1,klfo5cps,33
elseif klfo5fn = 6 then 
galfo5 oscili 1,klfo5cps,34
elseif klfo5fn = 7 then 
galfo5 randh 1,klfo5cps
elseif klfo5fn = 8 then 
galfo5 randi 1,klfo5cps
endif
if klfo5r==0 goto Z5
galfo5=galfo5*klfo5on
goto NEXT5
Z5:
galfo5=0
NEXT5:
galfo5u=(galfo5*.5)+.5

klfo6F=klfo6r*klfo6x10*klfo6x100
kjit6 jitter klfo6j*klfo6F,4,10
klfo6cps=klfo6F+kjit6
if klfo6fn = 1 then
galfo6 oscili 1,klfo6cps,25
elseif klfo6fn = 2 then 
galfo6 oscili 1,klfo6cps,30
elseif klfo6fn = 3 then 
galfo6 oscili 1,klfo6cps,31
elseif klfo6fn = 4 then 
galfo6 oscili 1,klfo6cps,32
elseif klfo6fn = 5 then 
galfo6 oscili 1,klfo6cps,33
elseif klfo6fn = 6 then 
galfo6 oscili 1,klfo6cps,34
elseif klfo6fn = 7 then 
galfo6 randh 1,klfo6cps
elseif klfo6fn = 8 then 
galfo6 randi 1,klfo6cps
endif
if klfo6r==0 goto Z6
galfo6=galfo6*klfo6on
goto NEXT6
Z6:
galfo6=0
NEXT6:
galfo6u=(galfo6*.5)+.5

klfo7F=klfo7r*klfo7x10*klfo7x100
kjit7 jitter klfo7j*klfo7F,4,10
klfo7cps=klfo7F+kjit7
if klfo7fn = 1 then
galfo7 oscili 1,klfo7cps,25
elseif klfo7fn = 2 then 
galfo7 oscili 1,klfo7cps,30
elseif klfo7fn = 3 then 
galfo7 oscili 1,klfo7cps,31
elseif klfo7fn = 4 then 
galfo7 oscili 1,klfo7cps,32
elseif klfo7fn = 5 then 
galfo7 oscili 1,klfo7cps,33
elseif klfo7fn = 6 then 
galfo7 oscili 1,klfo7cps,34
elseif klfo7fn = 7 then 
galfo7 randh 1,klfo7cps
elseif klfo7fn = 8 then 
galfo7 randi 1,klfo7cps
endif
if klfo7r==0 goto Z7
galfo7=galfo7*klfo7on
goto NEXT7
Z7:
galfo7=0
NEXT7:
galfo7u=(galfo7*.5)+.5

klfo8F=klfo8r*klfo8x10*klfo8x100
kjit8 jitter klfo8j*klfo8F,4,10
klfo8cps=klfo8F+kjit8
if klfo8fn = 1 then
galfo8 oscili 1,klfo8cps,25
elseif klfo8fn = 2 then 
galfo8 oscili 1,klfo8cps,30
elseif klfo8fn = 3 then 
galfo8 oscili 1,klfo8cps,31
elseif klfo8fn = 4 then 
galfo8 oscili 1,klfo8cps,32
elseif klfo8fn = 5 then 
galfo8 oscili 1,klfo8cps,33
elseif klfo8fn = 6 then 
galfo8 oscili 1,klfo8cps,34
elseif klfo8fn = 7 then 
galfo8 randh 1,klfo8cps
elseif klfo8fn = 8 then 
galfo8 randi 1,klfo8cps
endif
if klfo8r==0 goto Z8
galfo8=galfo8*klfo8on
goto NEXT8
Z8:
galfo8=0
NEXT8:
galfo8u=(galfo8*.5)+.5

klfo9F=klfo9r*klfo9x10*klfo9x100
kjit9 jitter klfo9j*klfo9F,4,10
klfo9cps=klfo9F+kjit9
if klfo9fn = 1 then
galfo9 oscili 1,klfo9cps,25
elseif klfo9fn = 2 then 
galfo9 oscili 1,klfo9cps,30
elseif klfo9fn = 3 then 
galfo9 oscili 1,klfo9cps,31
elseif klfo9fn = 4 then 
galfo9 oscili 1,klfo9cps,32
elseif klfo9fn = 5 then 
galfo9 oscili 1,klfo9cps,33
elseif klfo9fn = 6 then 
galfo9 oscili 1,klfo9cps,34
elseif klfo9fn = 7 then 
galfo9 randh 1,klfo9cps
elseif klfo9fn = 8 then 
galfo9 randi 1,klfo9cps
endif
if klfo9r==0 goto Z9
galfo9=galfo9*klfo9on
goto NEXT9
Z9:
galfo9=0
NEXT9:
galfo9u=(galfo9*.5)+.5

klfo10F=klfo10r*klfo10x10*klfo10x100
kjit10 jitter klfo10j*klfo10F,4,10
klfo10cps=klfo10F+kjit10
if klfo10fn = 1 then
galfo10 oscili 1,klfo10cps,25
elseif klfo10fn = 2 then 
galfo10 oscili 1,klfo10cps,30
elseif klfo10fn = 3 then 
galfo10 oscili 1,klfo10cps,31
elseif klfo10fn = 4 then 
galfo10 oscili 1,klfo10cps,32
elseif klfo10fn = 5 then 
galfo10 oscili 1,klfo10cps,33
elseif klfo10fn = 6 then 
galfo10 oscili 1,klfo10cps,34
elseif klfo10fn = 7 then 
galfo10 randh 1,klfo10cps
elseif klfo10fn = 8 then 
galfo10 randi 1,klfo10cps
endif
if klfo10r==0 goto Z10
galfo10=galfo10*klfo10on
goto NEXT10
Z10:
galfo10=0
NEXT10:
galfo10u=(galfo10*.5)+.5
endin

instr	10
;pitch bend controller and pitch ribbon
kbend pchbend 0,1   ;default set at 1 semitones up and down, can modify for each oscillator (before converting MIDI to cps)
kmamp chnget "MAmp" ;master amplitude
kmjit chnget "Mjit" ;master oscillator jitter
kmjitrate chnget "Mjitrate" ;modify jitter speed
kribON chnget "ribon"
kribbon chnget "ribbon"
kribbon port kribbon,.025

if kribON==1 then
goto ribbon
elseif kribON==0 then
kribbon=0
endif
ribbon:

;initialize oscillator output for use as audio rate modulators and k-rate ones for FM
async0 init 0 ;used for sync inputs
async1 init 0
async2 init 0
async3 init 0
async4 init 0
async5 init 0
async6 init 0
async7 init 0
async8 init 0
async9 init 0
async10 init 0
amod1 init 0
amod2 init 0
amod3 init 0
amod4 init 0
amod5 init 0
amod6 init 0
amod7 init 0
amod8 init 0
amod9 init 0
amod10 init 0
amod1u init 0
amod2u init 0
amod3u init 0
amod4u init 0
amod5u init 0
amod6u init 0
amod7u init 0
amod8u init 0
amod9u init 0
amod10u init 0
aosc1 init 0
aosc2 init 0
aosc3 init 0
aosc4 init 0
aosc5 init 0
aosc6 init 0
aosc7 init 0
aosc8 init 0
aosc9 init 0
aosc10 init 0

;ADSR envelopes
i1a chnget "1a"
i1d chnget "1d"
i1s chnget "1s"
i1r chnget "1r"
i2a chnget "2a"
i2d chnget "2d"
i2s chnget "2s"
i2r chnget "2r"
i3a chnget "3a"
i3d chnget "3d"
i3s chnget "3s"
i3r chnget "3r"
i4a chnget "4a"
i4d chnget "4d"
i4s chnget "4s"
i4r chnget "4r"
i5a chnget "5a"
i5d chnget "5d"
i5s chnget "5s"
i5r chnget "5r"
i6a chnget "6a"
i6d chnget "6d"
i6s chnget "6s"
i6r chnget "6r"
i7a chnget "7a"
i7d chnget "7d"
i7s chnget "7s"
i7r chnget "7r"
i8a chnget "8a"
i8d chnget "8d"
i8s chnget "8s"
i8r chnget "8r"
i9a chnget "9a"
i9d chnget "9d"
i9s chnget "9s"
i9r chnget "9r"
i10a chnget "10a"
i10d chnget "10d"
i10s chnget "10s"
i10r chnget "10r"
kenv1 madsr i1a,i1d,i1s,i1r
kenv2 madsr i2a,i2d,i2s,i2r
kenv3 madsr i3a,i3d,i3s,i3r
kenv4 madsr i4a,i4d,i4s,i4r
kenv5 madsr i5a,i5d,i5s,i5r
kenv6 madsr i6a,i6d,i6s,i6r
kenv7 madsr i7a,i7d,i7s,i7r
kenv8 madsr i8a,i8d,i8s,i8r
kenv9 madsr i9a,i9d,i9s,i9r
kenv10 madsr i10a,i10d,i10s,i10r

kmrf1 chnget "mrf1"
kmrf2 chnget "mrf2"
kmrf3 chnget "mrf3"
kmrf4 chnget "mrf4"
kmrf5 chnget "mrf5"
kmrf6 chnget "mrf6"
kmrf7 chnget "mrf7"
kmrf8 chnget "mrf8"
kmrf9 chnget "mrf9"
kmrf10 chnget "mrf10"

;calculate vibrato
kvibdepth chnget "vibdepth"
kvibdepthmax chnget "vibdepthmax"
kvibcps chnget "vibcps"
kvibcpsmax chnget "vibcpsmax"
kvibrand chnget "vibrand"
kvcps randomi kvibcpsmax-(kvibcpsmax*kvibrand),kvibcpsmax+(kvibcpsmax*kvibrand),kvibcpsmax
kvamp randomi kvibdepthmax-(kvibdepthmax*kvibrand),kvibdepthmax+(kvibdepthmax*kvibrand),kvcps
avib oscili kvamp*kvibdepth,kvcps*kvibcps,25
if kvibcps=0 then
 avib=0
endif

kss chnget "ScaleStart" ;MIDI pitch number from which any selected scale is calculated
kscale chnget "MasterScale"
if kscale == 1 then 
ksc=1 ;12 tone scale
elseif kscale == 2 then
ksc=.25 ;1/8 tones
elseif kscale == 3 then
ksc=.33333 ;1/6 tones
elseif kscale == 4 then
ksc=.5 ;1/4 tones
elseif kscale == 5 then
ksc=.66666 ;1/3 tones
elseif kscale == 6 then
ksc=1.714 ;7 tone octave
elseif kscale == 7 then
ksc=1.5 ;8 tone
elseif kscale == 8 then
ksc=1.3333 ;9 tone
elseif kscale == 9 then
ksc=1.2 ;10 tone
elseif kscale == 10 then
ksc=1.09091 ;11 tone
elseif kscale == 11 then
ksc=1.03448 ;11.6 tone
elseif kscale == 12 then
ksc=1.01695 ;11.8 tone
elseif kscale == 13 then
ksc=.98361 ;12.2 tone
elseif kscale == 14 then
ksc=.96774 ;12.4 tone
elseif kscale == 15 then
ksc=.9231 ;13 tone
elseif kscale == 16 then
ksc=.85714 ;14 tone
elseif kscale == 17 then
ksc=.8 ;15 tone
endif

;Random Note Stream Generation
kRNGon chnget "RNGon"
kRNGcps chnget "RNGrate"
kRNGcpsrand chnget "RNGraterand"
kRNGdev chnget "RNGdev"
kmicro chnget "RNGmicro"
kgliss chnget "RNGgliss"

if kRNGon == 0 then
kRNGnote=0
goto OSC1
endif

krateA randh (kRNGcps*kRNGcpsrand),kRNGcps,5 ;seed > 1 = random seeded by the system clock
knoterate=kRNGcps+krateA   ;sets master rate
if kgliss == 1 then
kRNGnote randi kRNGdev,knoterate,-.15
else
kRNGnote randh kRNGdev,knoterate,10
endif

if kmicro == 1 then
kRNGnote=int(kRNGnote) ;12 tone scale
elseif kmicro == 2 then ;all possible frequencies
elseif kmicro == 3 then
kRNGnote=(int(kRNGnote*2)*.5) ;1/4 tones
elseif kmicro == 4 then
kRNGnote=(int(kRNGnote*4)*.25) ;1/8 tones
elseif kmicro == 5 then
kRNGnote=int(kRNGnote)*2 ;Whole tone
elseif kmicro == 6 then
kRNGnote=int(kRNGnote)*3 ;minor 3rds
elseif kmicro == 7 then
kRNGnote=int(kRNGnote)*4 ;major 3rds
elseif kmicro == 8 then
kRNGnote=int(kRNGnote)*5 ;4ths
elseif kmicro == 9 then
kRNGnote=int(kRNGnote)*6 ;tritones
elseif kmicro == 10 then
kRNGnote=int(kRNGnote)*7 ;5ths
elseif kmicro == 11 then
kRNGnote=int(kRNGnote)*1.2 ;10 tone scale
elseif kmicro == 12 then
kRNGnote=int(kRNGnote)*.923 ;13 tone scale
elseif kmicro == 13 then
kRNGnote=int(kRNGnote)*.8 ;15 tone scale
elseif kmicro == 14 then
kRNGnote=int(kRNGnote)*1.715 ;7 tone scale
elseif kmicro == 15 then
kRNGnote=int(kRNGnote)*1.5 ;8 tone scale
endif

;OSCILLATOR 1 DEFINED IN THIS LARGE SECTION
OSC1:
;;get GUI data
kon1 chnget "osc1"
kon1 port kon1,.05
kamp1 chnget "amp1"
kpan1 chnget "pan1"
kfn1 chnget "fn1"
kpw1 chnget "pw1"
kpwr1 chnget "pwr1"
kpwd1 chnget "pwd1"
kesel1 chnget "env1"
kcoarse1 chnget "tc1"
kfine1 chnget "tf1"
kup1 chnget "up1"
kdown1 chnget "down1"
kfm1 chnget "fm1"
kind1 chnget "ind1"
kfmenv1 chnget "fmenv1"
kam1 chnget "am1"
kaind1 chnget "aind1"
kamenv1 chnget "amenv1"
krm1 chnget "rm1"

;calculate bend
if kbend >= 0 then 
kbend1=kbend*kup1
else
kbend1=kbend*kdown1
endif
kbend1 port kbend1,.025

;generate k-rate FM pitch modulators and their envelopes
if kfmenv1 = 1 then
kfmodenv1=kenv1
elseif kfmenv1 = 2 then
kfmodenv1=kenv2
elseif kfmenv1 = 3 then
kfmodenv1=kenv3
elseif kfmenv1 = 4 then
kfmodenv1=kenv4
elseif kfmenv1 = 5 then
kfmodenv1=kenv5
elseif kfmenv1 = 6 then
kfmodenv1=kenv6
elseif kfmenv1 = 7 then
kfmodenv1=kenv7
elseif kfmenv1 = 8 then
kfmodenv1=kenv8
elseif kfmenv1 = 9 then
kfmodenv1=kenv9
elseif kfmenv1 = 10 then
kfmodenv1=kenv10
endif

if kfm1 = 1 then
afmod1=0
elseif kfm1 = 2 then
afmod1 = aosc2*kind1*kfmodenv1
elseif kfm1 = 3 then
afmod1 = aosc3*kind1*kfmodenv1
elseif kfm1 = 4 then
afmod1 = aosc4*kind1*kfmodenv1
elseif kfm1 = 5 then
afmod1 = aosc5*kind1*kfmodenv1
elseif kfm1 = 6 then
afmod1 = aosc6*kind1*kfmodenv1
elseif kfm1 = 7 then
afmod1 = aosc7*kind1*kfmodenv1
elseif kfm1 = 8 then
afmod1 = aosc8*kind1*kfmodenv1
elseif kfm1 = 9 then
afmod1 = aosc9*kind1*kfmodenv1
elseif kfm1 = 10 then
afmod1 = aosc10*kind1*kfmodenv1
elseif kfm1 = 11 then
afmod1 = galfo1*kind1*kfmodenv1
elseif kfm1 = 12 then
afmod1 = galfo2*kind1*kfmodenv1
elseif kfm1 = 13 then
afmod1 = galfo3*kind1*kfmodenv1
elseif kfm1 = 14 then
afmod1 = galfo4*kind1*kfmodenv1
elseif kfm1 = 15 then
afmod1 = galfo5*kind1*kfmodenv1
elseif kfm1 = 16 then
afmod1 = galfo6*kind1*kfmodenv1
elseif kfm1 = 17 then
afmod1 = galfo7*kind1*kfmodenv1
elseif kfm1 = 18 then
afmod1 = galfo8*kind1*kfmodenv1
elseif kfm1 = 19 then
afmod1 = galfo9*kind1*kfmodenv1
elseif kfm1 = 20 then
afmod1 = galfo10*kind1*kfmodenv1
elseif kfm1 = 21 then
afmod1 = galiveAM*kind1*kfmodenv1
endif

;calculate cps
kcps1=cpsmidinn(kss+((p4-kss)*ksc)+kbend1+kfine1+kcoarse1+kRNGnote+kribbon)
;add jitter
kjit1 jitter kcps1*.004*kmjit,2*kmjitrate,7*kmjitrate
acps1=kjit1+(a(kcps1)*exp((avib+afmod1)*.083333))

;moving PW
kpwA1 oscil kpwd1*(1-abs((kpw1*2)-1)),kpwr1
kpw1=kpw1+kpwA1

;oscillator sync select logic
ksync1 chnget "sync1"
if ksync1=1 then 
andx1,async1 syncphasor acps1,async0,0
elseif ksync1=2 then
andx1,async1 syncphasor acps1,async2,0
elseif ksync1=3 then
andx1,async1 syncphasor acps1,async3,0
elseif ksync1=4 then
andx1,async1 syncphasor acps1,async4,0
elseif ksync1=5 then
andx1,async1 syncphasor acps1,async5,0
elseif ksync1=6 then
andx1,async1 syncphasor acps1,async6,0
elseif ksync1=7 then
andx1,async1 syncphasor acps1,async7,0
elseif ksync1=8 then
andx1,async1 syncphasor acps1,async8,0
elseif ksync1=9 then
andx1,async1 syncphasor acps1,async9,0
elseif ksync1=10 then
andx1,async1 syncphasor acps1,async10,0
endif
if kmrf1=0 goto NOMRF1
afn1 tablekt andx1*kpw1,99,1,0,0
goto DWNSMP1
NOMRF1:
afn1 tablekt andx1*kpw1,kfn1+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP1:
aosc1=afn1*p5
amod1u=(aosc1*.5)+.5

ENV1:
if kesel1 = 1 then  ;ADSR selection
ke1=kenv1
elseif kesel1 = 2 then
ke1=kenv2
elseif kesel1 = 3 then
ke1=kenv3
elseif kesel1 = 4 then
ke1=kenv4
elseif kesel1 = 5 then
ke1=kenv5
elseif kesel1 = 6 then
ke1=kenv6
elseif kesel1 = 7 then
ke1=kenv7
elseif kesel1 = 8 then
ke1=kenv8
elseif kesel1 = 9 then
ke1=kenv9
elseif kesel1 = 10 then
ke1=kenv10
endif

a1=aosc1*ke1*kamp1*p5*kon1

;AM env and source selection
if kamenv1 = 1 then
kamodenv1=kenv1
elseif kamenv1 = 2 then
kamodenv1=kenv2
elseif kamenv1 = 3 then
kamodenv1=kenv3
elseif kamenv1 = 4 then
kamodenv1=kenv4
elseif kamenv1 = 5 then
kamodenv1=kenv5
elseif kamenv1 = 6 then
kamodenv1=kenv6
elseif kamenv1 = 7 then
kamodenv1=kenv7
elseif kamenv1 = 8 then
kamodenv1=kenv8
elseif kamenv1 = 9 then
kamodenv1=kenv9
elseif kamenv1 = 10 then
kamodenv1=kenv10
endif

if kam1 = 1 then
a1=a1
elseif kam1 = 2 then
a1=a1*(1+(amod2u*kaind1*kamodenv1))
elseif kam1 = 3 then
a1=a1*(1+(amod3u*kaind1*kamodenv1))
elseif kam1 = 4 then
a1=a1*(1+(amod4u*kaind1*kamodenv1))
elseif kam1 = 5 then
a1=a1*(1+(amod5u*kaind1*kamodenv1))
elseif kam1 = 6 then
a1=a1*(1+(amod6u*kaind1*kamodenv1))
elseif kam1 = 7 then
a1=a1*(1+(amod7u*kaind1*kamodenv1))
elseif kam1 = 8 then
a1=a1*(1+(amod8u*kaind1*kamodenv1))
elseif kam1 = 9 then
a1=a1*(1+(amod9u*kaind1*kamodenv1))
elseif kam1 = 10 then
a1=a1*(1+(amod10u*kaind1*kamodenv1))
elseif kam1 = 11 then
a1=a1*(1+(galfo1u*kaind1*kamodenv1))
elseif kam1 = 12 then
a1=a1*(1+(galfo2u*kaind1*kamodenv1))
elseif kam1 = 13 then
a1=a1*(1+(galfo3u*kaind1*kamodenv1))
elseif kam1 = 14 then
a1=a1*(1+(galfo4u*kaind1*kamodenv1))
elseif kam1 = 15 then
a1=a1*(1+(galfo5u*kaind1*kamodenv1))
elseif kam1 = 16 then
a1=a1*(1+(galfo6u*kaind1*kamodenv1))
elseif kam1 = 17 then
a1=a1*(1+(galfo7u*kaind1*kamodenv1))
elseif kam1 = 18 then
a1=a1*(1+(galfo8u*kaind1*kamodenv1))
elseif kam1 = 19 then
a1=a1*(1+(galfo9u*kaind1*kamodenv1))
elseif kam1 = 20 then
a1=a1*(1+(galfo10u*kaind1*kamodenv1))
elseif kam1 = 21 then
a1=a1*(1+(galiveAM*kaind1*kamodenv1))
endif

if krm1 = 1 then
goto NO_RM1
elseif krm1 = 2 then
a1=a1*aosc2
elseif krm1 = 3 then
a1=a1*aosc3
elseif krm1 = 4 then
a1=a1*aosc4
elseif krm1 = 5 then
a1=a1*aosc5
elseif krm1 = 6 then
a1=a1*aosc6
elseif krm1 = 7 then
a1=a1*aosc7
elseif krm1 = 8 then
a1=a1*aosc8
elseif krm1 = 9 then
a1=a1*aosc9
elseif krm1 = 10 then
a1=a1*aosc10
elseif krm1 = 11 then
a1=a1*galfo1
elseif krm1 = 12 then
a1=a1*galfo2
elseif krm1 = 13 then
a1=a1*galfo3
elseif krm1 = 14 then
a1=a1*galfo4
elseif krm1 = 15 then
a1=a1*galfo5
elseif krm1 = 16 then
a1=a1*galfo6
elseif krm1 = 17 then
a1=a1*galfo7
elseif krm1 = 18 then
a1=a1*galfo8
elseif krm1 = 19 then
a1=a1*galfo9
elseif krm1 = 20 then
a1=a1*galfo10
elseif krm1 = 21 then
a1=a1*galiveRM
endif

NO_RM1:
a1L=a1*(1-kpan1)
a1R=a1*kpan1

OSC2:
;OSCILLATOR 2 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon2 chnget "osc2"
kon2 port kon2,.05
kamp2 chnget "amp2"
kpan2 chnget "pan2"
kfn2 chnget "fn2"
kpw2 chnget "pw2"
kpwr2 chnget "pwr2"
kpwd2 chnget "pwd2"
kesel2 chnget "env2"
kcoarse2 chnget "tc2"
kfine2 chnget "tf2"
kup2 chnget "up2"
kdown2 chnget "down2"
kfm2 chnget "fm2"
kind2 chnget "ind2"
kfmenv2 chnget "fmenv2"
kam2 chnget "am2"
kaind2 chnget "aind2"
kamenv2 chnget "amenv2"
krm2 chnget "rm2"

;calculate bend
if kbend >= 0 then 
kbend2=kbend*kup2
else
kbend2=kbend*kdown2
endif
kbend2 port kbend2,.025

;generate k-rate FM pitch modulators
if kfmenv2 = 1 then
kfmodenv2=kenv1
elseif kfmenv2 = 2 then
kfmodenv2=kenv2
elseif kfmenv2 = 3 then
kfmodenv2=kenv3
elseif kfmenv2 = 4 then
kfmodenv2=kenv4
elseif kfmenv2 = 5 then
kfmodenv2=kenv5
elseif kfmenv2 = 6 then
kfmodenv2=kenv6
elseif kfmenv2 = 7 then
kfmodenv2=kenv7
elseif kfmenv2 = 8 then
kfmodenv2=kenv8
elseif kfmenv2 = 9 then
kfmodenv2=kenv9
elseif kfmenv2 = 10 then
kfmodenv2=kenv10
endif

if kfm2 = 1 then
afmod2=0
elseif kfm2 = 2 then
afmod2 = aosc1*kind2*kfmodenv2
elseif kfm2 = 3 then
afmod2 = aosc3*kind2*kfmodenv2
elseif kfm2 = 4 then
afmod2 = aosc4*kind2*kfmodenv2
elseif kfm2 = 5 then
afmod2 = aosc5*kind2*kfmodenv2
elseif kfm2 = 6 then
afmod2 = aosc6*kind2*kfmodenv2
elseif kfm2 = 7 then
afmod2 = aosc7*kind2*kfmodenv2
elseif kfm2 = 8 then
afmod2 = aosc8*kind2*kfmodenv2
elseif kfm2 = 9 then
afmod2 = aosc9*kind2*kfmodenv2
elseif kfm2 = 10 then
afmod2 = aosc10*kind2*kfmodenv2
elseif kfm2 = 11 then
afmod2 = galfo1*kind2*kfmodenv2
elseif kfm2 = 12 then
afmod2 = galfo2*kind2*kfmodenv2
elseif kfm2 = 13 then
afmod2 = galfo3*kind2*kfmodenv2
elseif kfm2 = 14 then
afmod2 = galfo4*kind2*kfmodenv2
elseif kfm2 = 15 then
afmod2 = galfo5*kind2*kfmodenv2
elseif kfm2 = 16 then
afmod2 = galfo6*kind2*kfmodenv2
elseif kfm2 = 17 then
afmod2 = galfo7*kind2*kfmodenv2
elseif kfm2 = 18 then
afmod2 = galfo8*kind2*kfmodenv2
elseif kfm2 = 19 then
afmod2 = galfo9*kind2*kfmodenv2
elseif kfm2 = 20 then
afmod2 = galfo10*kind2*kfmodenv2
elseif kfm2 = 21 then
afmod2 = galiveAM*kind2*kfmodenv2
endif

kcps2=cpsmidinn(kss+((p4-kss)*ksc)+kbend2+kfine2+kcoarse2+kRNGnote+kribbon)

;add jitter
kjit2 jitter kcps2*.0062*kmjit,3.3*kmjitrate,13*kmjitrate
acps2=kjit2+(a(kcps2)*exp((avib+afmod2)*.083333))

;moving PW
kpwA2 oscil kpwd2*(1-abs((kpw2*2)-1)),kpwr2
kpw2=kpw2+kpwA2

;oscillator sync select logic
ksync2 chnget "sync2"
if ksync2=1 then 
andx2,async2 syncphasor acps2,async0,0
elseif ksync2=2 then
andx2,async2 syncphasor acps2,async1,0
elseif ksync2=3 then
andx2,async2 syncphasor acps2,async3,0
elseif ksync2=4 then
andx2,async2 syncphasor acps2,async4,0
elseif ksync2=5 then
andx2,async2 syncphasor acps2,async5,0
elseif ksync2=6 then
andx2,async2 syncphasor acps2,async6,0
elseif ksync2=7 then
andx2,async2 syncphasor acps2,async7,0
elseif ksync2=8 then
andx2,async2 syncphasor acps2,async8,0
elseif ksync2=9 then
andx2,async2 syncphasor acps2,async9,0
elseif ksync2=10 then
andx2,async2 syncphasor acps2,async10,0
endif
if kmrf2=0 goto NOMRF2
afn2 tablekt andx2*kpw2,99,1,0,0
goto DWNSMP2
NOMRF2:
afn2 tablekt andx2*kpw2,kfn2+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP2:
aosc2=afn2*p5
amod2u=(aosc2*.5)+.5

if kesel2 = 1 then  ;ADSR selection
ke2=kenv1
elseif kesel2 = 2 then
ke2=kenv2
elseif kesel2 = 3 then
ke2=kenv3
elseif kesel2 = 4 then
ke2=kenv4
elseif kesel2 = 5 then
ke2=kenv5
elseif kesel2 = 6 then
ke2=kenv6
elseif kesel2 = 7 then
ke2=kenv7
elseif kesel2 = 8 then
ke2=kenv8
elseif kesel2 = 9 then
ke2=kenv9
elseif kesel2 = 10 then
ke2=kenv10
endif

a2=aosc2*ke2*kamp2*p5*kon2

;AM env and source selection
if kamenv2 = 1 then
kamodenv2=kenv1
elseif kamenv2 = 2 then
kamodenv2=kenv2
elseif kamenv2 = 3 then
kamodenv2=kenv3
elseif kamenv2 = 4 then
kamodenv2=kenv4
elseif kamenv2 = 5 then
kamodenv2=kenv5
elseif kamenv2 = 6 then
kamodenv2=kenv6
elseif kamenv2 = 7 then
kamodenv2=kenv7
elseif kamenv2 = 8 then
kamodenv2=kenv8
elseif kamenv2 = 9 then
kamodenv2=kenv9
elseif kamenv2 = 10 then
kamodenv2=kenv10
endif

if kam2 = 1 then
a2=a2
elseif kam2 = 2 then
a2=a2*(1+(amod1u*kaind2*kamodenv2))
elseif kam2 = 3 then
a2=a2*(1+(amod3u*kaind2*kamodenv2))
elseif kam2 = 4 then
a2=a2*(1+(amod4u*kaind2*kamodenv2))
elseif kam2 = 5 then
a2=a2*(1+(amod5u*kaind2*kamodenv2))
elseif kam2 = 6 then
a2=a2*(1+(amod6u*kaind2*kamodenv2))
elseif kam2 = 7 then
a2=a2*(1+(amod7u*kaind2*kamodenv2))
elseif kam2 = 8 then
a2=a2*(1+(amod8u*kaind2*kamodenv2))
elseif kam2 = 9 then
a2=a2*(1+(amod9u*kaind2*kamodenv2))
elseif kam2 = 10 then
a2=a2*(1+(amod10u*kaind2*kamodenv2))
elseif kam2 = 11 then
a2=a2*(1+(galfo1u*kaind2*kamodenv2))
elseif kam2 = 12 then
a2=a2*(1+(galfo2u*kaind2*kamodenv2))
elseif kam2 = 13 then
a2=a2*(1+(galfo3u*kaind2*kamodenv2))
elseif kam2 = 14 then
a2=a2*(1+(galfo4u*kaind2*kamodenv2))
elseif kam2 = 15 then
a2=a2*(1+(galfo5u*kaind2*kamodenv2))
elseif kam2 = 16 then
a2=a2*(1+(galfo6u*kaind2*kamodenv2))
elseif kam2 = 17 then
a2=a2*(1+(galfo7u*kaind2*kamodenv2))
elseif kam2 = 18 then
a2=a2*(1+(galfo8u*kaind2*kamodenv2))
elseif kam2 = 19 then
a2=a2*(1+(galfo9u*kaind2*kamodenv2))
elseif kam2 = 20 then
a2=a2*(1+(galfo10u*kaind2*kamodenv2))
elseif kam2 = 21 then
a2=a2*(1+(galiveAM*kaind2*kamodenv2))
endif

;RM source selection
if krm2 = 1 then
goto NO_RM2
elseif krm2 = 2 then
a2=a2*aosc1
elseif krm2 = 3 then
a2=a2*aosc3
elseif krm2 = 4 then
a2=a2*aosc4
elseif krm2 = 5 then
a2=a2*aosc5
elseif krm2 = 6 then
a2=a2*aosc6
elseif krm2 = 7 then
a2=a2*aosc7
elseif krm2 = 8 then
a2=a2*aosc8
elseif krm2 = 9 then
a2=a2*aosc9
elseif krm2 = 10 then
a2=a2*aosc10
elseif krm2 = 11 then
a2=a2*galfo1
elseif krm2 = 12 then
a2=a2*galfo2
elseif krm2 = 13 then
a2=a2*galfo3
elseif krm2 = 14 then
a2=a2*galfo4
elseif krm2 = 15 then
a2=a2*galfo5
elseif krm2 = 16 then
a2=a2*galfo6
elseif krm2 = 17 then
a2=a2*galfo7
elseif krm2 = 18 then
a2=a2*galfo8
elseif krm2 = 19 then
a2=a2*galfo9
elseif krm2 = 20 then
a2=a2*galfo10
elseif krm2 = 21 then
a2=a2*galiveRM
endif

NO_RM2:
a2L=a2*(1-kpan2)
a2R=a2*kpan2

OSC3:
;OSCILLATOR 3 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon3 chnget "osc3"
kon3 port kon3,.05
kamp3 chnget "amp3"
kpan3 chnget "pan3"
kfn3 chnget "fn3"
kpw3 chnget "pw3"
kpwr3 chnget "pwr3"
kpwd3 chnget "pwd3"
kesel3 chnget "env3"
kcoarse3 chnget "tc3"
kfine3 chnget "tf3"
kup3 chnget "up3"
kdown3 chnget "down3"
kfm3 chnget "fm3"
kind3 chnget "ind3"
kfmenv3 chnget "fmenv3"
kam3 chnget "am3"
kaind3 chnget "aind3"
kamenv3 chnget "amenv3"
krm3 chnget "rm3"

;calculate bend
if kbend >= 0 then 
kbend3=kbend*kup3
else
kbend3=kbend*kdown3
endif
kbend3 port kbend3,.025

;generate k-rate FM pitch modulators
if kfmenv3 = 1 then
kfmodenv3=kenv1
elseif kfmenv3 = 2 then
kfmodenv3=kenv2
elseif kfmenv3 = 3 then
kfmodenv3=kenv3
elseif kfmenv3 = 4 then
kfmodenv3=kenv4
elseif kfmenv3 = 5 then
kfmodenv3=kenv5
elseif kfmenv3 = 6 then
kfmodenv3=kenv6
elseif kfmenv3 = 7 then
kfmodenv3=kenv7
elseif kfmenv3 = 8 then
kfmodenv3=kenv8
elseif kfmenv3 = 9 then
kfmodenv3=kenv9
elseif kfmenv3 = 10 then
kfmodenv3=kenv10
endif

if kfm3 = 1 then
afmod3=0
elseif kfm3 = 2 then
afmod3 = aosc1*kind3*kfmodenv3
elseif kfm3 = 3 then
afmod3 = aosc2*kind3*kfmodenv3
elseif kfm3 = 4 then
afmod3 = aosc4*kind3*kfmodenv3
elseif kfm3 = 5 then
afmod3 = aosc5*kind3*kfmodenv3
elseif kfm3 = 6 then
afmod3 = aosc6*kind3*kfmodenv3
elseif kfm3 = 7 then
afmod3 = aosc7*kind3*kfmodenv3
elseif kfm3 = 8 then
afmod3 = aosc8*kind3*kfmodenv3
elseif kfm3 = 9 then
afmod3 = aosc9*kind3*kfmodenv3
elseif kfm3 = 10 then
afmod3 = aosc10*kind3*kfmodenv3
elseif kfm3 = 11 then
afmod3 = galfo1*kind3*kfmodenv3
elseif kfm3 = 12 then
afmod3 = galfo2*kind3*kfmodenv3
elseif kfm3 = 13 then
afmod3 = galfo3*kind3*kfmodenv3
elseif kfm3 = 14 then
afmod3 = galfo4*kind3*kfmodenv3
elseif kfm3 = 15 then
afmod3 = galfo5*kind3*kfmodenv3
elseif kfm3 = 16 then
afmod3 = galfo6*kind3*kfmodenv3
elseif kfm3 = 17 then
afmod3 = galfo7*kind3*kfmodenv3
elseif kfm3 = 18 then
afmod3 = galfo8*kind3*kfmodenv3
elseif kfm3 = 19 then
afmod3 = galfo9*kind3*kfmodenv3
elseif kfm3 = 20 then
afmod3 = galfo10*kind3*kfmodenv3
elseif kfm3 = 21 then
afmod3 = galiveAM*kind3*kfmodenv3
endif

kcps3=cpsmidinn(kss+((p4-kss)*ksc)+kbend3+kfine3+kcoarse3+kRNGnote+kribbon)

;add jitter
kjit3 jitter kcps3*.0035*kmjit,2.4*kmjitrate,8.6*kmjitrate
acps3=kjit3+(a(kcps3)*exp((avib+afmod3)*.083333))

;moving PW
kpwA3 oscil kpwd3*(1-abs((kpw3*2)-1)),kpwr3
kpw3=kpw3+kpwA3

;oscillator sync select logic
ksync3 chnget "sync3"
if ksync3=1 then 
andx3,async3 syncphasor acps3,async0,0
elseif ksync3=2 then
andx3,async3 syncphasor acps3,async1,0
elseif ksync3=3 then
andx3,async3 syncphasor acps3,async2,0
elseif ksync3=4 then
andx3,async3 syncphasor acps3,async4,0
elseif ksync3=5 then
andx3,async3 syncphasor acps3,async5,0
elseif ksync3=6 then
andx3,async3 syncphasor acps3,async6,0
elseif ksync3=7 then
andx3,async3 syncphasor acps3,async7,0
elseif ksync3=8 then
andx3,async3 syncphasor acps3,async8,0
elseif ksync3=9 then
andx3,async3 syncphasor acps3,async9,0
elseif ksync3=10 then
andx3,async3 syncphasor acps3,async10,0
endif
if kmrf3=0 goto NOMRF3
afn3 tablekt andx3*kpw3,99,1,0,0
goto DWNSMP3
NOMRF3:
afn3 tablekt andx3*kpw3,kfn3+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP3:
aosc3=afn3*p5
amod3u=(aosc3*.5)+.5

if kesel3 = 1 then  ;ADSR selection
ke3=kenv1
elseif kesel3 = 2 then
ke3=kenv2
elseif kesel3 = 3 then
ke3=kenv3
elseif kesel3 = 4 then
ke3=kenv4
elseif kesel3 = 5 then
ke3=kenv5
elseif kesel3 = 6 then
ke3=kenv6
elseif kesel3 = 7 then
ke3=kenv7
elseif kesel3 = 8 then
ke3=kenv8
elseif kesel3 = 9 then
ke3=kenv9
elseif kesel3 = 10 then
ke3=kenv10
endif

a3=aosc3*ke3*kamp3*p5*kon3

;AM env and source selection
if kamenv3 = 1 then
kamodenv3=kenv1
elseif kamenv3 = 2 then
kamodenv3=kenv2
elseif kamenv3 = 3 then
kamodenv3=kenv3
elseif kamenv3 = 4 then
kamodenv3=kenv4
elseif kamenv3 = 5 then
kamodenv3=kenv5
elseif kamenv3 = 6 then
kamodenv3=kenv6
elseif kamenv3 = 7 then
kamodenv3=kenv7
elseif kamenv3 = 8 then
kamodenv3=kenv8
elseif kamenv3 = 9 then
kamodenv3=kenv9
elseif kamenv3 = 10 then
kamodenv3=kenv10
endif

if kam3 = 1 then
a3=a3
elseif kam3 = 2 then
a3=a3*(1+(amod1u*kaind3*kamodenv3))
elseif kam3 = 3 then
a3=a3*(1+(amod2u*kaind3*kamodenv3))
elseif kam3 = 4 then
a3=a3*(1+(amod4u*kaind3*kamodenv3))
elseif kam3 = 5 then
a3=a3*(1+(amod5u*kaind3*kamodenv3))
elseif kam3 = 6 then
a3=a3*(1+(amod6u*kaind3*kamodenv3))
elseif kam3 = 7 then
a3=a3*(1+(amod7u*kaind3*kamodenv3))
elseif kam3 = 8 then
a3=a3*(1+(amod8u*kaind3*kamodenv3))
elseif kam3 = 9 then
a3=a3*(1+(amod9u*kaind3*kamodenv3))
elseif kam3 = 10 then
a3=a3*(1+(amod10u*kaind3*kamodenv3))
elseif kam3 = 11 then
a3=a3*(1+(galfo1u*kaind3*kamodenv3))
elseif kam3 = 12 then
a3=a3*(1+(galfo2u*kaind3*kamodenv3))
elseif kam3 = 13 then
a3=a3*(1+(galfo3u*kaind3*kamodenv3))
elseif kam3 = 14 then
a3=a3*(1+(galfo4u*kaind3*kamodenv3))
elseif kam3 = 15 then
a3=a3*(1+(galfo5u*kaind3*kamodenv3))
elseif kam3 = 16 then
a3=a3*(1+(galfo6u*kaind3*kamodenv3))
elseif kam3 = 17 then
a3=a3*(1+(galfo7u*kaind3*kamodenv3))
elseif kam3 = 18 then
a3=a3*(1+(galfo8u*kaind3*kamodenv3))
elseif kam3 = 19 then
a3=a3*(1+(galfo9u*kaind3*kamodenv3))
elseif kam3 = 20 then
a3=a3*(1+(galfo10u*kaind3*kamodenv3))
elseif kam3 = 21 then
a3=a3*(1+(galiveAM*kaind3*kamodenv3))
endif

;RM source selection
if krm3 = 1 then
goto NO_RM3
elseif krm3 = 2 then
a3=a3*aosc1
elseif krm3 = 3 then
a3=a3*aosc2
elseif krm3 = 4 then
a3=a3*aosc4
elseif krm3 = 5 then
a3=a3*aosc5
elseif krm3 = 6 then
a3=a3*aosc6
elseif krm3 = 7 then
a3=a3*aosc7
elseif krm3 = 8 then
a3=a3*aosc8
elseif krm3 = 9 then
a3=a3*aosc9
elseif krm3 = 10 then
a3=a3*aosc10
elseif krm3 = 11 then
a3=a3*galfo1
elseif krm3 = 12 then
a3=a3*galfo2
elseif krm3 = 13 then
a3=a3*galfo3
elseif krm3 = 14 then
a3=a3*galfo4
elseif krm3 = 15 then
a3=a3*galfo5
elseif krm3 = 16 then
a3=a3*galfo6
elseif krm3 = 17 then
a3=a3*galfo7
elseif krm3 = 18 then
a3=a3*galfo8
elseif krm3 = 19 then
a3=a3*galfo9
elseif krm3 = 20 then
a3=a3*galfo10
elseif krm3 = 21 then
a3=a3*galiveRM
endif

NO_RM3:
a3L=a3*(1-kpan3)
a3R=a3*kpan3

OSC4:
;OSCILLATOR 4 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon4 chnget "osc4"
kon4 port kon4,.05
kamp4 chnget "amp4"
kpan4 chnget "pan4"
kfn4 chnget "fn4"
kpw4 chnget "pw4"
kpwr4 chnget "pwr4"
kpwd4 chnget "pwd4"
kesel4 chnget "env4"
kcoarse4 chnget "tc4"
kfine4 chnget "tf4"
kup4 chnget "up4"
kdown4 chnget "down4"
kfm4 chnget "fm4"
kind4 chnget "ind4"
kfmenv4 chnget "fmenv4"
kam4 chnget "am4"
kaind4 chnget "aind4"
kamenv4 chnget "amenv4"
krm4 chnget "rm4"

;calculate bend
if kbend >= 0 then 
kbend4=kbend*kup4
else
kbend4=kbend*kdown4
endif
kbend4 port kbend4,.025

;generate k-rate FM pitch modulators
if kfmenv4 = 1 then
kfmodenv4=kenv1
elseif kfmenv4 = 2 then
kfmodenv4=kenv2
elseif kfmenv4 = 3 then
kfmodenv4=kenv3
elseif kfmenv4 = 4 then
kfmodenv4=kenv4
elseif kfmenv4 = 5 then
kfmodenv4=kenv5
elseif kfmenv4 = 6 then
kfmodenv4=kenv6
elseif kfmenv4 = 7 then
kfmodenv4=kenv7
elseif kfmenv4 = 8 then
kfmodenv4=kenv8
elseif kfmenv4 = 9 then
kfmodenv4=kenv9
elseif kfmenv4 = 10 then
kfmodenv4=kenv10
endif

if kfm4 = 1 then
afmod4=0
elseif kfm4 = 2 then
afmod4 = aosc1*kind4*kfmodenv4
elseif kfm4 = 3 then
afmod4 = aosc2*kind4*kfmodenv4
elseif kfm4 = 4 then
afmod4 = aosc3*kind4*kfmodenv4
elseif kfm4 = 5 then
afmod4 = aosc5*kind4*kfmodenv4
elseif kfm4 = 6 then
afmod4 = aosc6*kind4*kfmodenv4
elseif kfm4 = 7 then
afmod4 = aosc7*kind4*kfmodenv4
elseif kfm4 = 8 then
afmod4 = aosc8*kind4*kfmodenv4
elseif kfm4 = 9 then
afmod4 = aosc9*kind4*kfmodenv4
elseif kfm4 = 10 then
afmod4 = aosc10*kind4*kfmodenv4
elseif kfm4 = 11 then
afmod4 = galfo1*kind4*kfmodenv4
elseif kfm4 = 12 then
afmod4 = galfo2*kind4*kfmodenv4
elseif kfm4 = 13 then
afmod4 = galfo3*kind4*kfmodenv4
elseif kfm4 = 14 then
afmod4 = galfo4*kind4*kfmodenv4
elseif kfm4 = 15 then
afmod4 = galfo5*kind4*kfmodenv4
elseif kfm4 = 16 then
afmod4 = galfo6*kind4*kfmodenv4
elseif kfm4 = 17 then
afmod4 = galfo7*kind4*kfmodenv4
elseif kfm4 = 18 then
afmod4 = galfo8*kind4*kfmodenv4
elseif kfm4 = 19 then
afmod4 = galfo9*kind4*kfmodenv4
elseif kfm4 = 20 then
afmod4 = galfo10*kind4*kfmodenv4
elseif kfm4 = 21 then
afmod4 = galiveAM*kind4*kfmodenv4
endif

kcps4=cpsmidinn(kss+((p4-kss)*ksc)+kbend4+kfine4+kcoarse4+kRNGnote+kribbon)

;add jitter
kjit4 jitter kcps4*.0053*kmjit,6*kmjitrate,9.5*kmjitrate
acps4=kjit4+(a(kcps4)*exp((avib+afmod4)*.083333))

;moving PW
kpwA4 oscil kpwd4*(1-abs((kpw4*2)-1)),kpwr4
kpw4=kpw4+kpwA4

;oscillator sync select logic
ksync4 chnget "sync4"
if ksync4=1 then 
andx4,async4 syncphasor acps4,async0,0
elseif ksync4=2 then
andx4,async4 syncphasor acps4,async1,0
elseif ksync4=3 then
andx4,async4 syncphasor acps4,async2,0
elseif ksync4=4 then
andx4,async4 syncphasor acps4,async3,0
elseif ksync4=5 then
andx4,async4 syncphasor acps4,async5,0
elseif ksync4=6 then
andx4,async4 syncphasor acps4,async6,0
elseif ksync4=7 then
andx4,async4 syncphasor acps4,async7,0
elseif ksync4=8 then
andx4,async4 syncphasor acps4,async8,0
elseif ksync4=9 then
andx4,async4 syncphasor acps4,async9,0
elseif ksync4=10 then
andx4,async4 syncphasor acps4,async10,0
endif
if kmrf4=0 goto NOMRF4
afn4 tablekt andx4*kpw4,99,1,0,0
goto DWNSMP4
NOMRF4:
afn4 tablekt andx4*kpw4,kfn4+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP4:
aosc4=afn4*p5
amod4u=(aosc4*.5)+.5

if kesel4 = 1 then  ;ADSR selection
ke4=kenv1
elseif kesel4 = 2 then
ke4=kenv2
elseif kesel4 = 3 then
ke4=kenv3
elseif kesel4 = 4 then
ke4=kenv4
elseif kesel4 = 5 then
ke4=kenv5
elseif kesel4 = 6 then
ke4=kenv6
elseif kesel4 = 7 then
ke4=kenv7
elseif kesel4 = 8 then
ke4=kenv8
elseif kesel4 = 9 then
ke4=kenv9
elseif kesel4 = 10 then
ke4=kenv10
endif

a4=aosc4*ke4*kamp4*p5*kon4

;AM env and source selection
if kamenv4 = 1 then
kamodenv4=kenv1
elseif kamenv4 = 2 then
kamodenv4=kenv2
elseif kamenv4 = 3 then
kamodenv4=kenv3
elseif kamenv4 = 4 then
kamodenv4=kenv4
elseif kamenv4 = 5 then
kamodenv4=kenv5
elseif kamenv4 = 6 then
kamodenv4=kenv6
elseif kamenv4 = 7 then
kamodenv4=kenv7
elseif kamenv4 = 8 then
kamodenv4=kenv8
elseif kamenv4 = 9 then
kamodenv4=kenv9
elseif kamenv4 = 10 then
kamodenv4=kenv10
endif

if kam4 = 1 then
a4=a4
elseif kam4 = 2 then
a4=a4*(1+(amod1u*kaind4*kamodenv4))
elseif kam4 = 3 then
a4=a4*(1+(amod2u*kaind4*kamodenv4))
elseif kam4 = 4 then
a4=a4*(1+(amod3u*kaind4*kamodenv4))
elseif kam4 = 5 then
a4=a4*(1+(amod5u*kaind4*kamodenv4))
elseif kam4 = 6 then
a4=a4*(1+(amod6u*kaind4*kamodenv4))
elseif kam4 = 7 then
a4=a4*(1+(amod7u*kaind4*kamodenv4))
elseif kam4 = 8 then
a4=a4*(1+(amod8u*kaind4*kamodenv4))
elseif kam4 = 9 then
a4=a4*(1+(amod9u*kaind4*kamodenv4))
elseif kam4 = 10 then
a4=a4*(1+(amod10u*kaind4*kamodenv4))
elseif kam4 = 11 then
a4=a4*(1+(galfo1u*kaind4*kamodenv4))
elseif kam4 = 12 then
a4=a4*(1+(galfo2u*kaind4*kamodenv4))
elseif kam4 = 13 then
a4=a4*(1+(galfo3u*kaind4*kamodenv4))
elseif kam4 = 14 then
a4=a4*(1+(galfo4u*kaind4*kamodenv4))
elseif kam4 = 15 then
a4=a4*(1+(galfo5u*kaind4*kamodenv4))
elseif kam4 = 16 then
a4=a4*(1+(galfo6u*kaind4*kamodenv4))
elseif kam4 = 17 then
a4=a4*(1+(galfo7u*kaind4*kamodenv4))
elseif kam4 = 18 then
a4=a4*(1+(galfo8u*kaind4*kamodenv4))
elseif kam4 = 19 then
a4=a4*(1+(galfo9u*kaind4*kamodenv4))
elseif kam4 = 20 then
a4=a4*(1+(galfo10u*kaind4*kamodenv4))
elseif kam4 = 21 then
a4=a4*(1+(galiveAM*kaind4*kamodenv4))
endif

;RM source selection
if krm4 = 1 then
goto NO_RM4
elseif krm4 = 2 then
a4=a4*aosc1
elseif krm4 = 3 then
a4=a4*aosc2
elseif krm4 = 4 then
a4=a4*aosc3
elseif krm4 = 5 then
a4=a4*aosc5
elseif krm4 = 6 then
a4=a4*aosc6
elseif krm4 = 7 then
a4=a4*aosc7
elseif krm4 = 8 then
a4=a4*aosc8
elseif krm4 = 9 then
a4=a4*aosc9
elseif krm4 = 10 then
a4=a4*aosc10
elseif krm4 = 11 then
a4=a4*galfo1
elseif krm4 = 12 then
a4=a4*galfo2
elseif krm4 = 13 then
a4=a4*galfo3
elseif krm4 = 14 then
a4=a4*galfo4
elseif krm4 = 15 then
a4=a4*galfo5
elseif krm4 = 16 then
a4=a4*galfo6
elseif krm4 = 17 then
a4=a4*galfo7
elseif krm4 = 18 then
a4=a4*galfo8
elseif krm4 = 19 then
a4=a4*galfo9
elseif krm4 = 20 then
a4=a4*galfo10
elseif krm4 = 21 then
a4=a4*galiveRM
endif

NO_RM4:
a4L=a4*(1-kpan4)
a4R=a4*kpan4

OSC5:
;OSCILLATOR 5 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon5 chnget "osc5"
kon5 port kon5,.05
kamp5 chnget "amp5"
kpan5 chnget "pan5"
kfn5 chnget "fn5"
kpw5 chnget "pw5"
kpwr5 chnget "pwr5"
kpwd5 chnget "pwd5"
kesel5 chnget "env5"
kcoarse5 chnget "tc5"
kfine5 chnget "tf5"
kup5 chnget "up5"
kdown5 chnget "down5"
kfm5 chnget "fm5"
kind5 chnget "ind5"
kfmenv5 chnget "fmenv5"
kam5 chnget "am5"
kaind5 chnget "aind5"
kamenv5 chnget "amenv5"
krm5 chnget "rm5"

;calculate cps
;calculate bend
if kbend >= 0 then 
kbend5=kbend*kup5
else
kbend5=kbend*kdown5
endif
kbend4 port kbend4,.025

;generate k-rate FM pitch modulators
if kfmenv5 = 1 then
kfmodenv5=kenv1
elseif kfmenv5 = 2 then
kfmodenv5=kenv2
elseif kfmenv5 = 3 then
kfmodenv5=kenv3
elseif kfmenv5 = 4 then
kfmodenv5=kenv4
elseif kfmenv5 = 5 then
kfmodenv5=kenv5
elseif kfmenv5 = 6 then
kfmodenv5=kenv6
elseif kfmenv5 = 7 then
kfmodenv5=kenv7
elseif kfmenv5 = 8 then
kfmodenv5=kenv8
elseif kfmenv5 = 9 then
kfmodenv5=kenv9
elseif kfmenv5 = 10 then
kfmodenv5=kenv10
endif

if kfm5 = 1 then
afmod5=0
elseif kfm5 = 2 then
afmod5 = aosc1*kind5*kfmodenv5
elseif kfm5 = 3 then
afmod5 = aosc2*kind5*kfmodenv5
elseif kfm5 = 4 then
afmod5 = aosc3*kind5*kfmodenv5
elseif kfm5 = 5 then
afmod5 = aosc4*kind5*kfmodenv5
elseif kfm5 = 6 then
afmod5 = aosc6*kind5*kfmodenv5
elseif kfm5 = 7 then
afmod5 = aosc7*kind5*kfmodenv5
elseif kfm5 = 8 then
afmod5 = aosc8*kind5*kfmodenv5
elseif kfm5 = 9 then
afmod5 = aosc9*kind5*kfmodenv5
elseif kfm5 = 10 then
afmod5 = aosc10*kind5*kfmodenv5
elseif kfm5 = 11 then
afmod5 = galfo1*kind5*kfmodenv5
elseif kfm5 = 12 then
afmod5 = galfo2*kind5*kfmodenv5
elseif kfm5 = 13 then
afmod5 = galfo3*kind5*kfmodenv5
elseif kfm5 = 14 then
afmod5 = galfo4*kind5*kfmodenv5
elseif kfm5 = 15 then
afmod5 = galfo5*kind5*kfmodenv5
elseif kfm5 = 16 then
afmod5 = galfo6*kind5*kfmodenv5
elseif kfm5 = 17 then
afmod5 = galfo7*kind5*kfmodenv5
elseif kfm5 = 18 then
afmod5 = galfo8*kind5*kfmodenv5
elseif kfm5 = 19 then
afmod5 = galfo9*kind5*kfmodenv5
elseif kfm5 = 20 then
afmod5 = galfo10*kind5*kfmodenv5
elseif kfm5 = 21 then
afmod5 = galiveAM*kind5*kfmodenv5
endif

kcps5=cpsmidinn(kss+((p4-kss)*ksc)+kbend5+kfine5+kcoarse5+kRNGnote+kribbon)

;add jitter
kjit5 jitter kcps5*.0025*kmjit,3*kmjitrate,9*kmjitrate
acps5=kjit5+(a(kcps5)*exp((avib+afmod5)*.083333))

;moving PW
kpwA5 oscil kpwd5*(1-abs((kpw5*2)-1)),kpwr5
kpw5=kpw5+kpwA5

;;oscillator sync select logic
ksync5 chnget "sync5"
if ksync5=1 then 
andx5,async5 syncphasor acps5,async0,0
elseif ksync5=2 then
andx5,async5 syncphasor acps5,async1,0
elseif ksync5=3 then
andx5,async5 syncphasor acps5,async2,0
elseif ksync5=4 then
andx5,async5 syncphasor acps5,async3,0
elseif ksync5=5 then
andx5,async5 syncphasor acps5,async4,0
elseif ksync5=6 then
andx5,async5 syncphasor acps5,async6,0
elseif ksync5=7 then
andx5,async5 syncphasor acps5,async7,0
elseif ksync5=8 then
andx5,async5 syncphasor acps5,async8,0
elseif ksync5=9 then
andx5,async5 syncphasor acps5,async9,0
elseif ksync5=10 then
andx5,async5 syncphasor acps5,async10,0
endif
if kmrf5=0 goto NOMRF5
afn5 tablekt andx5*kpw5,99,1,0,0
goto DWNSMP5
NOMRF5:
afn5 tablekt andx5*kpw5,kfn5+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP5:
aosc5=afn5*p5
amod5u=(aosc5*.5)+.5

if kesel5 = 1 then  ;ADSR selection
ke5=kenv1
elseif kesel5 = 2 then
ke5=kenv2
elseif kesel5 = 3 then
ke5=kenv3
elseif kesel5 = 4 then
ke5=kenv4
elseif kesel5 = 5 then
ke5=kenv5
elseif kesel5 = 6 then
ke5=kenv6
elseif kesel5 = 7 then
ke5=kenv7
elseif kesel5 = 8 then
ke5=kenv8
elseif kesel5 = 9 then
ke5=kenv9
elseif kesel5 = 10 then
ke5=kenv10
endif

a5=aosc5*ke5*kamp5*p5*kon5

;AM env and source selection
if kamenv5 = 1 then
kamodenv5=kenv1
elseif kamenv5 = 2 then
kamodenv5=kenv2
elseif kamenv5 = 3 then
kamodenv5=kenv3
elseif kamenv5 = 4 then
kamodenv5=kenv4
elseif kamenv5 = 5 then
kamodenv5=kenv5
elseif kamenv5 = 6 then
kamodenv5=kenv6
elseif kamenv5 = 7 then
kamodenv5=kenv7
elseif kamenv5 = 8 then
kamodenv5=kenv8
elseif kamenv5 = 9 then
kamodenv5=kenv9
elseif kamenv5 = 10 then
kamodenv5=kenv10
endif

if kam5 = 1 then
a5=a5
elseif kam5 = 2 then
a5=a5*(1+(amod1u*kaind5*kamodenv5))
elseif kam5 = 3 then
a5=a5*(1+(amod2u*kaind5*kamodenv5))
elseif kam5 = 4 then
a5=a5*(1+(amod3u*kaind5*kamodenv5))
elseif kam5 = 5 then
a5=a5*(1+(amod4u*kaind5*kamodenv5))
elseif kam5 = 6 then
a5=a5*(1+(amod6u*kaind5*kamodenv5))
elseif kam5 = 7 then
a5=a5*(1+(amod7u*kaind5*kamodenv5))
elseif kam5 = 8 then
a5=a5*(1+(amod8u*kaind5*kamodenv5))
elseif kam5 = 9 then
a5=a5*(1+(amod9u*kaind5*kamodenv5))
elseif kam5 = 10 then
a5=a5*(1+(amod10u*kaind5*kamodenv5))
elseif kam5 = 11 then
a5=a5*(1+(galfo1u*kaind5*kamodenv5))
elseif kam5 = 12 then
a5=a5*(1+(galfo2u*kaind5*kamodenv5))
elseif kam5 = 13 then
a5=a5*(1+(galfo3u*kaind5*kamodenv5))
elseif kam5 = 14 then
a5=a5*(1+(galfo4u*kaind5*kamodenv5))
elseif kam5 = 15 then
a5=a5*(1+(galfo5u*kaind5*kamodenv5))
elseif kam5 = 16 then
a5=a5*(1+(galfo6u*kaind5*kamodenv5))
elseif kam5 = 17 then
a5=a5*(1+(galfo7u*kaind5*kamodenv5))
elseif kam5 = 18 then
a5=a5*(1+(galfo8u*kaind5*kamodenv5))
elseif kam5 = 19 then
a5=a5*(1+(galfo9u*kaind5*kamodenv5))
elseif kam5 = 20 then
a5=a5*(1+(galfo10u*kaind5*kamodenv5))
elseif kam5 = 21 then
a5=a5*(1+(galiveAM*kaind5*kamodenv5))
endif

;RM source selection
if krm5 = 1 then
goto NO_RM5
elseif krm5 = 2 then
a5=a5*aosc1
elseif krm5 = 3 then
a5=a5*aosc2
elseif krm5 = 4 then
a5=a5*aosc3
elseif krm5 = 5 then
a5=a5*aosc4
elseif krm5 = 6 then
a5=a5*aosc6
elseif krm5 = 7 then
a5=a5*aosc7
elseif krm5 = 8 then
a5=a5*aosc8
elseif krm5 = 9 then
a5=a5*aosc9
elseif krm5 = 10 then
a5=a5*aosc10
elseif krm5 = 11 then
a5=a5*galfo1
elseif krm5 = 12 then
a5=a5*galfo2
elseif krm5 = 13 then
a5=a5*galfo3
elseif krm5 = 14 then
a5=a5*galfo4
elseif krm5 = 15 then
a5=a5*galfo5
elseif krm5 = 16 then
a5=a5*galfo6
elseif krm5 = 17 then
a5=a5*galfo7
elseif krm5 = 18 then
a5=a5*galfo8
elseif krm5 = 19 then
a5=a5*galfo9
elseif krm5 = 20 then
a5=a5*galfo10
elseif krm5 = 21 then
a5=a5*galiveRM
endif

NO_RM5:
a5L=a5*(1-kpan5)
a5R=a5*kpan5

OSC6:
;OSCILLATOR 6 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon6 chnget "osc6"
kon6 port kon6,.05
kamp6 chnget "amp6"
kpan6 chnget "pan6"
kfn6 chnget "fn6"
kpw6 chnget "pw6"
kpwr6 chnget "pwr6"
kpwd6 chnget "pwd6"
kesel6 chnget "env6"
kcoarse6 chnget "tc6"
kfine6 chnget "tf6"
kup6 chnget "up6"
kdown6 chnget "down6"
kfm6 chnget "fm6"
kind6 chnget "ind6"
kfmenv6 chnget "fmenv6"
kam6 chnget "am6"
kaind6 chnget "aind6"
kamenv6 chnget "amenv6"
krm6 chnget "rm6"

;calculate cps
;calculate bend
if kbend >= 0 then 
kbend6=kbend*kup6
else
kbend6=kbend*kdown6
endif
kbend6 port kbend6,.025

;generate k-rate FM pitch modulators
if kfmenv6 = 1 then
kfmodenv6=kenv1
elseif kfmenv6 = 2 then
kfmodenv6=kenv2
elseif kfmenv6 = 3 then
kfmodenv6=kenv3
elseif kfmenv6 = 4 then
kfmodenv6=kenv4
elseif kfmenv6 = 5 then
kfmodenv6=kenv5
elseif kfmenv6 = 6 then
kfmodenv6=kenv6
elseif kfmenv6 = 7 then
kfmodenv6=kenv7
elseif kfmenv6 = 8 then
kfmodenv6=kenv8
elseif kfmenv6 = 9 then
kfmodenv6=kenv9
elseif kfmenv6 = 10 then
kfmodenv6=kenv10
endif

if kfm6 = 1 then
afmod6=0
elseif kfm6 = 2 then
afmod6 = aosc1*kind6*kfmodenv6
elseif kfm6 = 3 then
afmod6 = aosc2*kind6*kfmodenv6
elseif kfm6 = 4 then
afmod6 = aosc3*kind6*kfmodenv6
elseif kfm6 = 5 then
afmod6 = aosc4*kind6*kfmodenv6
elseif kfm6 = 6 then
afmod6 = aosc5*kind6*kfmodenv6
elseif kfm6 = 7 then
afmod6 = aosc7*kind6*kfmodenv6
elseif kfm6 = 8 then
afmod6 = aosc8*kind6*kfmodenv6
elseif kfm6 = 9 then
afmod6 = aosc9*kind6*kfmodenv6
elseif kfm6 = 10 then
afmod6 = aosc10*kind6*kfmodenv6
elseif kfm6 = 11 then
afmod6 = galfo1*kind6*kfmodenv6
elseif kfm6 = 12 then
afmod6 = galfo2*kind6*kfmodenv6
elseif kfm6 = 13 then
afmod6 = galfo3*kind6*kfmodenv6
elseif kfm6 = 14 then
afmod6 = galfo4*kind6*kfmodenv6
elseif kfm6 = 15 then
afmod6 = galfo5*kind6*kfmodenv6
elseif kfm6 = 16 then
afmod6 = galfo6*kind6*kfmodenv6
elseif kfm6 = 17 then
afmod6 = galfo7*kind6*kfmodenv6
elseif kfm6 = 18 then
afmod6 = galfo8*kind6*kfmodenv6
elseif kfm6 = 19 then
afmod6 = galfo9*kind6*kfmodenv6
elseif kfm6 = 20 then
afmod6 = galfo10*kind6*kfmodenv6
elseif kfm6 = 21 then
afmod6 = galiveAM*kind6*kfmodenv6
endif

kcps6=cpsmidinn(kss+((p4-kss)*ksc)+kbend6+kfine6+kcoarse6+kRNGnote+kribbon)

;add jitter
kjit6 jitter kcps6*.0038*kmjit,5.5*kmjitrate,11.7*kmjitrate
acps6=kjit6+(a(kcps6)*exp((avib+afmod6)*.083333))

;moving PW
kpwA6 oscil kpwd6*(1-abs((kpw6*2)-1)),kpwr6
kpw6=kpw6+kpwA6

;oscillator sync select logic
ksync6 chnget "sync6"
if ksync6=1 then 
andx6,async6 syncphasor acps6,async0,0
elseif ksync6=2 then
andx6,async6 syncphasor acps6,async1,0
elseif ksync6=3 then
andx6,async6 syncphasor acps6,async2,0
elseif ksync6=4 then
andx6,async6 syncphasor acps6,async3,0
elseif ksync6=5 then
andx6,async6 syncphasor acps6,async4,0
elseif ksync6=6 then
andx6,async6 syncphasor acps6,async5,0
elseif ksync6=7 then
andx6,async6 syncphasor acps6,async7,0
elseif ksync6=8 then
andx6,async6 syncphasor acps6,async8,0
elseif ksync6=9 then
andx6,async6 syncphasor acps6,async9,0
elseif ksync6=10 then
andx6,async6 syncphasor acps6,async10,0
endif
if kmrf6=0 goto NOMRF6
afn6 tablekt andx6*kpw6,99,1,0,0
goto DWNSMP6
NOMRF6:
afn6 tablekt andx6*kpw6,kfn6+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP6:
aosc6=afn6*p5
amod6u=(aosc6*.5)+.5

if kesel6 = 1 then  ;ADSR selection
ke6=kenv1
elseif kesel6 = 2 then
ke6=kenv2
elseif kesel6 = 3 then
ke6=kenv3
elseif kesel6 = 4 then
ke6=kenv4
elseif kesel6 = 5 then
ke6=kenv5
elseif kesel6 = 6 then
ke6=kenv6
elseif kesel6 = 7 then
ke6=kenv7
elseif kesel6 = 8 then
ke6=kenv8
elseif kesel6 = 9 then
ke6=kenv9
elseif kesel6 = 10 then
ke6=kenv10
endif

a6=aosc6*ke6*kamp6*p5*kon6

;AM env and source selection
if kamenv6 = 1 then
kamodenv6=kenv1
elseif kamenv6 = 2 then
kamodenv6=kenv2
elseif kamenv6 = 3 then
kamodenv6=kenv3
elseif kamenv6 = 4 then
kamodenv6=kenv4
elseif kamenv6 = 5 then
kamodenv6=kenv5
elseif kamenv6 = 6 then
kamodenv6=kenv6
elseif kamenv6 = 7 then
kamodenv6=kenv7
elseif kamenv6 = 8 then
kamodenv6=kenv8
elseif kamenv6 = 9 then
kamodenv6=kenv9
elseif kamenv6 = 10 then
kamodenv6=kenv10
endif

if kam6 = 1 then
a6=a6
elseif kam6 = 2 then
a6=a6*(1+(amod1u*kaind6*kamodenv6))
elseif kam6 = 3 then
a6=a6*(1+(amod2u*kaind6*kamodenv6))
elseif kam6 = 4 then
a6=a6*(1+(amod3u*kaind6*kamodenv6))
elseif kam6 = 5 then
a6=a6*(1+(amod4u*kaind6*kamodenv6))
elseif kam6 = 6 then
a6=a6*(1+(amod5u*kaind6*kamodenv6))
elseif kam6 = 7 then
a6=a6*(1+(amod7u*kaind6*kamodenv6))
elseif kam6 = 8 then
a6=a6*(1+(amod8u*kaind6*kamodenv6))
elseif kam6 = 9 then
a6=a6*(1+(amod9u*kaind6*kamodenv6))
elseif kam6 = 10 then
a6=a6*(1+(amod10u*kaind6*kamodenv6))
elseif kam6 = 11 then
a6=a6*(1+(galfo1u*kaind6*kamodenv6))
elseif kam6 = 12 then
a6=a6*(1+(galfo2u*kaind6*kamodenv6))
elseif kam6 = 13 then
a6=a6*(1+(galfo3u*kaind6*kamodenv6))
elseif kam6 = 14 then
a6=a6*(1+(galfo4u*kaind6*kamodenv6))
elseif kam6 = 15 then
a6=a6*(1+(galfo5u*kaind6*kamodenv6))
elseif kam6 = 16 then
a6=a6*(1+(galfo6u*kaind6*kamodenv6))
elseif kam6 = 17 then
a6=a6*(1+(galfo7u*kaind6*kamodenv6))
elseif kam6 = 18 then
a6=a6*(1+(galfo8u*kaind6*kamodenv6))
elseif kam6 = 19 then
a6=a6*(1+(galfo9u*kaind6*kamodenv6))
elseif kam6 = 20 then
a6=a6*(1+(galfo10u*kaind6*kamodenv6))
elseif kam6 = 21 then
a6=a6*(1+(galiveAM*kaind6*kamodenv6))
endif

;RM source selection
if krm6 = 1 then
goto NO_RM6
elseif krm6 = 2 then
a6=a6*aosc1
elseif krm6 = 3 then
a6=a6*aosc2
elseif krm6 = 4 then
a6=a6*aosc3
elseif krm6 = 5 then
a6=a6*aosc4
elseif krm6 = 6 then
a6=a6*aosc5
elseif krm6 = 7 then
a6=a6*aosc7
elseif krm6 = 8 then
a6=a6*aosc8
elseif krm6 = 9 then
a6=a6*aosc9
elseif krm6 = 10 then
a6=a6*aosc10
elseif krm6 = 11 then
a6=a6*galfo1
elseif krm6 = 12 then
a6=a6*galfo2
elseif krm6 = 13 then
a6=a6*galfo3
elseif krm6 = 14 then
a6=a6*galfo4
elseif krm6 = 15 then
a6=a6*galfo5
elseif krm6 = 16 then
a6=a6*galfo6
elseif krm6 = 17 then
a6=a6*galfo7
elseif krm6 = 18 then
a6=a6*galfo8
elseif krm6 = 19 then
a6=a6*galfo9
elseif krm6 = 20 then
a6=a6*galfo10
elseif krm6 = 21 then
a6=a6*galiveRM
endif

NO_RM6:
a6L=a6*(1-kpan6)
a6R=a6*kpan6

OSC7:
;OSCILLATOR 7 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon7 chnget "osc7"
kon7 port kon7,.05
kamp7 chnget "amp7"
kpan7 chnget "pan7"
kfn7 chnget "fn7"
kpw7 chnget "pw7"
kpwr7 chnget "pwr7"
kpwd7 chnget "pwd7"
kesel7 chnget "env7"
kcoarse7 chnget "tc7"
kfine7 chnget "tf7"
kup7 chnget "up7"
kdown7 chnget "down7"
kfm7 chnget "fm7"
kind7 chnget "ind7"
kfmenv7 chnget "fmenv7"
kam7 chnget "am7"
kaind7 chnget "aind7"
kamenv7 chnget "amenv7"
krm7 chnget "rm7"

;calculate cps
;calculate bend
if kbend >= 0 then 
kbend7=kbend*kup7
else
kbend7=kbend*kdown7
endif
kbend7 port kbend7,.025

;generate k-rate FM pitch modulators
if kfmenv7 = 1 then
kfmodenv7=kenv1
elseif kfmenv7 = 2 then
kfmodenv7=kenv2
elseif kfmenv7 = 3 then
kfmodenv7=kenv3
elseif kfmenv7 = 4 then
kfmodenv7=kenv4
elseif kfmenv7 = 5 then
kfmodenv7=kenv5
elseif kfmenv7 = 6 then
kfmodenv7=kenv6
elseif kfmenv7 = 7 then
kfmodenv7=kenv7
elseif kfmenv7 = 8 then
kfmodenv7=kenv8
elseif kfmenv7 = 9 then
kfmodenv7=kenv9
elseif kfmenv7 = 10 then
kfmodenv7=kenv10
endif

if kfm7 = 1 then
afmod7=0
elseif kfm7 = 2 then
afmod7 = aosc1*kind7*kfmodenv7
elseif kfm7 = 3 then
afmod7 = aosc2*kind7*kfmodenv7
elseif kfm7 = 4 then
afmod7 = aosc3*kind7*kfmodenv7
elseif kfm7 = 5 then
afmod7 = aosc4*kind7*kfmodenv7
elseif kfm7 = 6 then
afmod7 = aosc5*kind7*kfmodenv7
elseif kfm7 = 7 then
afmod7 = aosc6*kind7*kfmodenv7
elseif kfm7 = 8 then
afmod7 = aosc8*kind7*kfmodenv7
elseif kfm7 = 9 then
afmod7 = aosc9*kind7*kfmodenv7
elseif kfm7 = 10 then
afmod7 = aosc10*kind7*kfmodenv7
elseif kfm7 = 11 then
afmod7 = galfo1*kind7*kfmodenv7
elseif kfm7 = 12 then
afmod7 = galfo2*kind7*kfmodenv7
elseif kfm7 = 13 then
afmod7 = galfo3*kind7*kfmodenv7
elseif kfm7 = 14 then
afmod7 = galfo4*kind7*kfmodenv7
elseif kfm7 = 15 then
afmod7 = galfo5*kind7*kfmodenv7
elseif kfm7 = 16 then
afmod7 = galfo6*kind7*kfmodenv7
elseif kfm7 = 17 then
afmod7 = galfo7*kind7*kfmodenv7
elseif kfm7 = 18 then
afmod7 = galfo8*kind7*kfmodenv7
elseif kfm7 = 19 then
afmod7 = galfo9*kind7*kfmodenv7
elseif kfm7 = 20 then
afmod7 = galfo10*kind7*kfmodenv7
elseif kfm7 = 21 then
afmod7 = galiveAM*kind7*kfmodenv7
endif

kcps7=cpsmidinn(kss+((p4-kss)*ksc)+kbend7+kfine7+kcoarse7+kRNGnote+kribbon)

;add jitter
kjit7 jitter kcps7*.0033*kmjit,2*kmjitrate,8*kmjitrate
acps7=kjit7+(a(kcps7)*exp((avib+afmod7)*.083333))

;moving PW
kpwA7 oscil kpwd7*(1-abs((kpw7*2)-1)),kpwr7
kpw7=kpw7+kpwA7

;oscillator sync select logic
ksync7 chnget "sync7"
if ksync7=1 then 
andx7,async7 syncphasor acps7,async0,0
elseif ksync7=2 then
andx7,async7 syncphasor acps7,async1,0
elseif ksync7=3 then
andx7,async7 syncphasor acps7,async2,0
elseif ksync7=4 then
andx7,async7 syncphasor acps7,async3,0
elseif ksync7=5 then
andx7,async7 syncphasor acps7,async4,0
elseif ksync7=6 then
andx7,async7 syncphasor acps7,async5,0
elseif ksync7=7 then
andx7,async7 syncphasor acps7,async6,0
elseif ksync7=8 then
andx7,async7 syncphasor acps7,async8,0
elseif ksync7=9 then
andx7,async7 syncphasor acps7,async9,0
elseif ksync7=10 then
andx7,async7 syncphasor acps7,async10,0
endif
if kmrf7=0 goto NOMRF7
afn7 tablekt andx7*kpw7,99,1,0,0
goto DWNSMP7
NOMRF7:
afn7 tablekt andx7*kpw7,kfn7+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP7:
aosc7=afn7*p5
amod7u=(aosc7*.5)+.5

if kesel7 = 1 then  ;ADSR selection
ke7=kenv1
elseif kesel7 = 2 then
ke7=kenv2
elseif kesel7 = 3 then
ke7=kenv3
elseif kesel7 = 4 then
ke7=kenv4
elseif kesel7 = 5 then
ke7=kenv5
elseif kesel7 = 6 then
ke7=kenv6
elseif kesel7 = 7 then
ke7=kenv7
elseif kesel7 = 8 then
ke7=kenv8
elseif kesel7 = 9 then
ke7=kenv9
elseif kesel7 = 10 then
ke7=kenv10
endif

a7=aosc7*ke7*kamp7*p5*kon7

;AM env and source selection
if kamenv7 = 1 then
kamodenv7=kenv1
elseif kamenv7 = 2 then
kamodenv7=kenv2
elseif kamenv7 = 3 then
kamodenv7=kenv3
elseif kamenv7 = 4 then
kamodenv7=kenv4
elseif kamenv7 = 5 then
kamodenv7=kenv5
elseif kamenv7 = 6 then
kamodenv7=kenv6
elseif kamenv7 = 7 then
kamodenv7=kenv7
elseif kamenv7 = 8 then
kamodenv7=kenv8
elseif kamenv7 = 9 then
kamodenv7=kenv9
elseif kamenv7 = 10 then
kamodenv7=kenv10
endif

if kam7 = 1 then
a7=a7
elseif kam7 = 2 then
a7=a7*(1+(amod1u*kaind7*kamodenv7))
elseif kam7 = 3 then
a7=a7*(1+(amod2u*kaind7*kamodenv7))
elseif kam7 = 4 then
a7=a7*(1+(amod3u*kaind7*kamodenv7))
elseif kam7 = 5 then
a7=a7*(1+(amod4u*kaind7*kamodenv7))
elseif kam7 = 6 then
a7=a7*(1+(amod5u*kaind7*kamodenv7))
elseif kam7 = 7 then
a7=a7*(1+(amod6u*kaind7*kamodenv7))
elseif kam7 = 8 then
a7=a7*(1+(amod8u*kaind7*kamodenv7))
elseif kam7 = 9 then
a7=a7*(1+(amod9u*kaind7*kamodenv7))
elseif kam7 = 10 then
a7=a7*(1+(amod10u*kaind7*kamodenv7))
elseif kam7 = 11 then
a7=a7*(1+(galfo1u*kaind7*kamodenv7))
elseif kam7 = 12 then
a7=a7*(1+(galfo2u*kaind7*kamodenv7))
elseif kam7 = 13 then
a7=a7*(1+(galfo3u*kaind7*kamodenv7))
elseif kam7 = 14 then
a7=a7*(1+(galfo4u*kaind7*kamodenv7))
elseif kam7 = 15 then
a7=a7*(1+(galfo5u*kaind7*kamodenv7))
elseif kam7 = 16 then
a7=a7*(1+(galfo6u*kaind7*kamodenv7))
elseif kam7 = 17 then
a7=a7*(1+(galfo7u*kaind7*kamodenv7))
elseif kam7 = 18 then
a7=a7*(1+(galfo8u*kaind7*kamodenv7))
elseif kam7 = 19 then
a7=a7*(1+(galfo9u*kaind7*kamodenv7))
elseif kam7 = 20 then
a7=a7*(1+(galfo10u*kaind7*kamodenv7))
elseif kam7 = 21 then
a7=a7*(1+(galiveAM*kaind7*kamodenv7))
endif

;RM source selection
if krm7 = 1 then
goto NO_RM7
elseif krm7 = 2 then
a7=a7*aosc1
elseif krm7 = 3 then
a7=a7*aosc2
elseif krm7 = 4 then
a7=a7*aosc3
elseif krm7 = 5 then
a7=a7*aosc4
elseif krm7 = 6 then
a7=a7*aosc5
elseif krm7 = 7 then
a7=a7*aosc6
elseif krm7 = 8 then
a7=a7*aosc8
elseif krm7 = 9 then
a7=a7*aosc9
elseif krm7 = 10 then
a7=a7*aosc10
elseif krm7 = 11 then
a7=a7*galfo1
elseif krm7 = 12 then
a7=a7*galfo2
elseif krm7 = 13 then
a7=a7*galfo3
elseif krm7 = 14 then
a7=a7*galfo4
elseif krm7 = 15 then
a7=a7*galfo5
elseif krm7 = 16 then
a7=a7*galfo6
elseif krm7 = 17 then
a7=a7*galfo7
elseif krm7 = 18 then
a7=a7*galfo8
elseif krm7 = 19 then
a7=a7*galfo9
elseif krm7 = 20 then
a7=a7*galfo10
elseif krm7 = 21 then
a7=a7*galiveRM
endif

NO_RM7:
a7L=a7*(1-kpan7)
a7R=a7*kpan7

OSC8:
;OSCILLATOR 8 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon8 chnget "osc8"
kon8 port kon8,.05
kamp8 chnget "amp8"
kpan8 chnget "pan8"
kfn8 chnget "fn8"
kpw8 chnget "pw8"
kpwr8 chnget "pwr8"
kpwd8 chnget "pwd8"
kesel8 chnget "env8"
kcoarse8 chnget "tc8"
kfine8 chnget "tf8"
kup8 chnget "up8"
kdown8 chnget "down8"
kfm8 chnget "fm8"
kind8 chnget "ind8"
kfmenv8 chnget "fmenv8"
kam8 chnget "am8"
kaind8 chnget "aind8"
kamenv8 chnget "amenv8"
krm8 chnget "rm8"

;calculate cps
;calculate bend
if kbend >= 0 then 
kbend8=kbend*kup8
else
kbend8=kbend*kdown8
endif
kbend8 port kbend8,.025

;generate k-rate FM pitch modulators
if kfmenv8 = 1 then
kfmodenv8=kenv1
elseif kfmenv8 = 2 then
kfmodenv8=kenv2
elseif kfmenv8 = 3 then
kfmodenv8=kenv3
elseif kfmenv8 = 4 then
kfmodenv8=kenv4
elseif kfmenv8 = 5 then
kfmodenv8=kenv5
elseif kfmenv8 = 6 then
kfmodenv8=kenv6
elseif kfmenv8 = 7 then
kfmodenv8=kenv7
elseif kfmenv8 = 8 then
kfmodenv8=kenv8
elseif kfmenv8 = 9 then
kfmodenv8=kenv9
elseif kfmenv8 = 10 then
kfmodenv8=kenv10
endif

if kfm8 = 1 then
afmod8=0
elseif kfm8 = 2 then
afmod8 = aosc1*kind8*kfmodenv8
elseif kfm8 = 3 then
afmod8 = aosc2*kind8*kfmodenv8
elseif kfm8 = 4 then
afmod8 = aosc3*kind8*kfmodenv8
elseif kfm8 = 5 then
afmod8 = aosc4*kind8*kfmodenv8
elseif kfm8 = 6 then
afmod8 = aosc5*kind8*kfmodenv8
elseif kfm8 = 7 then
afmod8 = aosc6*kind8*kfmodenv8
elseif kfm8 = 8 then
afmod8 = aosc7*kind8*kfmodenv8
elseif kfm8 = 9 then
afmod8 = aosc9*kind8*kfmodenv8
elseif kfm8 = 10 then
afmod8 = aosc10*kind8*kfmodenv8
elseif kfm8 = 11 then
afmod8 = galfo1*kind8*kfmodenv8
elseif kfm8 = 12 then
afmod8 = galfo2*kind8*kfmodenv8
elseif kfm8 = 13 then
afmod8 = galfo3*kind8*kfmodenv8
elseif kfm8 = 14 then
afmod8 = galfo4*kind8*kfmodenv8
elseif kfm8 = 15 then
afmod8 = galfo5*kind8*kfmodenv8
elseif kfm8 = 16 then
afmod8 = galfo6*kind8*kfmodenv8
elseif kfm8 = 17 then
afmod8 = galfo7*kind8*kfmodenv8
elseif kfm8 = 18 then
afmod8 = galfo8*kind8*kfmodenv8
elseif kfm8 = 19 then
afmod8 = galfo9*kind8*kfmodenv8
elseif kfm8 = 20 then
afmod8 = galfo10*kind8*kfmodenv8
elseif kfm8 = 21 then
afmod8 = galiveAM*kind8*kfmodenv8
endif

kcps8=cpsmidinn(kss+((p4-kss)*ksc)+kbend8+kfine8+kcoarse8+kRNGnote+kribbon)
;add jitter
kjit8 jitter kcps8*.0025*kmjit,5*kmjitrate,10*kmjitrate
acps8=kjit8+(a(kcps8)*exp((avib+afmod8)*.083333))

;moving PW
kpwA8 oscil kpwd8*(1-abs((kpw8*2)-1)),kpwr8
kpw8=kpw8+kpwA8

;oscillator sync select logic
ksync8 chnget "sync8"
if ksync8=1 then 
andx8,async8 syncphasor acps8,async0,0
elseif ksync8=2 then
andx8,async8 syncphasor acps8,async1,0
elseif ksync8=3 then
andx8,async8 syncphasor acps8,async2,0
elseif ksync8=4 then
andx8,async8 syncphasor acps8,async3,0
elseif ksync8=5 then
andx8,async8 syncphasor acps8,async4,0
elseif ksync8=6 then
andx8,async8 syncphasor acps8,async5,0
elseif ksync8=7 then
andx8,async8 syncphasor acps8,async6,0
elseif ksync8=8 then
andx8,async8 syncphasor acps8,async7,0
elseif ksync8=9 then
andx8,async8 syncphasor acps8,async9,0
elseif ksync8=10 then
andx8,async8 syncphasor acps8,async10,0
endif
if kmrf8=0 goto NOMRF8
afn8 tablekt andx8*kpw8,99,1,0,0
goto DWNSMP8
NOMRF8:
afn8 tablekt andx8*kpw8,kfn8+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP8:
aosc8=afn8*p5
amod8u=(aosc8*.5)+.5

if kesel8 = 1 then  ;ADSR selection
ke8=kenv1
elseif kesel8 = 2 then
ke8=kenv2
elseif kesel8 = 3 then
ke8=kenv3
elseif kesel8 = 4 then
ke8=kenv4
elseif kesel8 = 5 then
ke8=kenv5
elseif kesel8 = 6 then
ke8=kenv6
elseif kesel8 = 7 then
ke8=kenv7
elseif kesel8 = 8 then
ke8=kenv8
elseif kesel8 = 9 then
ke8=kenv9
elseif kesel8 = 10 then
ke8=kenv10
endif

a8=aosc8*ke8*kamp8*p5*kon8

;AM env and source selection
if kamenv8 = 1 then
kamodenv8=kenv1
elseif kamenv8 = 2 then
kamodenv8=kenv2
elseif kamenv8 = 3 then
kamodenv8=kenv3
elseif kamenv8 = 4 then
kamodenv8=kenv4
elseif kamenv8 = 5 then
kamodenv8=kenv5
elseif kamenv8 = 6 then
kamodenv8=kenv6
elseif kamenv8 = 7 then
kamodenv8=kenv7
elseif kamenv8 = 8 then
kamodenv8=kenv8
elseif kamenv8 = 9 then
kamodenv8=kenv9
elseif kamenv8 = 10 then
kamodenv8=kenv10
endif

if kam8 = 1 then
a8=a8
elseif kam8 = 2 then
a8=a8*(1+(amod1u*kaind8*kamodenv8))
elseif kam8 = 3 then
a8=a8*(1+(amod2u*kaind8*kamodenv8))
elseif kam8 = 4 then
a8=a8*(1+(amod3u*kaind8*kamodenv8))
elseif kam8 = 5 then
a8=a8*(1+(amod4u*kaind8*kamodenv8))
elseif kam8 = 6 then
a8=a8*(1+(amod5u*kaind8*kamodenv8))
elseif kam8 = 7 then
a8=a8*(1+(amod6u*kaind8*kamodenv8))
elseif kam8 = 8 then
a8=a8*(1+(amod7u*kaind8*kamodenv8))
elseif kam8 = 9 then
a8=a8*(1+(amod9u*kaind8*kamodenv8))
elseif kam8 = 10 then
a8=a8*(1+(amod10u*kaind8*kamodenv8))
elseif kam8 = 11 then
a8=a8*(1+(galfo1u*kaind8*kamodenv8))
elseif kam8 = 12 then
a8=a8*(1+(galfo2u*kaind8*kamodenv8))
elseif kam8 = 13 then
a8=a8*(1+(galfo3u*kaind8*kamodenv8))
elseif kam8 = 14 then
a8=a8*(1+(galfo4u*kaind8*kamodenv8))
elseif kam8 = 15 then
a8=a8*(1+(galfo5u*kaind8*kamodenv8))
elseif kam8 = 16 then
a8=a8*(1+(galfo6u*kaind8*kamodenv8))
elseif kam8 = 17 then
a8=a8*(1+(galfo7u*kaind8*kamodenv8))
elseif kam8 = 18 then
a8=a8*(1+(galfo8u*kaind8*kamodenv8))
elseif kam8 = 19 then
a8=a8*(1+(galfo9u*kaind8*kamodenv8))
elseif kam8 = 20 then
a8=a8*(1+(galfo10u*kaind8*kamodenv8))
elseif kam8 = 21 then
a8=a8*(1+(galiveAM*kaind8*kamodenv8))
endif

;RM source selection
if krm8 = 1 then
goto NO_RM8
elseif krm8 = 2 then
a8=a8*aosc1
elseif krm8 = 3 then
a8=a8*aosc2
elseif krm8 = 4 then
a8=a8*aosc3
elseif krm8 = 5 then
a8=a8*aosc4
elseif krm8 = 6 then
a8=a8*aosc5
elseif krm8 = 7 then
a8=a8*aosc6
elseif krm8 = 8 then
a8=a8*aosc7
elseif krm8 = 9 then
a8=a8*aosc9
elseif krm8 = 10 then
a8=a8*aosc10
elseif krm8 = 11 then
a8=a8*galfo1
elseif krm8 = 12 then
a8=a8*galfo2
elseif krm8 = 13 then
a8=a8*galfo3
elseif krm8 = 14 then
a8=a8*galfo4
elseif krm8 = 15 then
a8=a8*galfo5
elseif krm8 = 16 then
a8=a8*galfo6
elseif krm8 = 17 then
a8=a8*galfo7
elseif krm8 = 18 then
a8=a8*galfo8
elseif krm8 = 19 then
a8=a8*galfo9
elseif krm8 = 20 then
a8=a8*galfo10
elseif krm8 = 21 then
a8=a8*galiveRM
endif

NO_RM8:
a8L=a8*(1-kpan8)
a8R=a8*kpan8

OSC9:
;OSCILLATOR 9 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon9 chnget "osc9"
kon9 port kon9,.05
kamp9 chnget "amp9"
kpan9 chnget "pan9"
kfn9 chnget "fn9"
kpw9 chnget "pw9"
kpwr9 chnget "pwr9"
kpwd9 chnget "pwd9"
kesel9 chnget "env9"
kcoarse9 chnget "tc9"
kfine9 chnget "tf9"
kup9 chnget "up9"
kdown9 chnget "down9"
kfm9 chnget "fm9"
kind9 chnget "ind9"
kfmenv9 chnget "fmenv9"
kam9 chnget "am9"
kaind9 chnget "aind9"
kamenv9 chnget "amenv9"
krm9 chnget "rm9"

;calculate cps
;calculate bend
if kbend >= 0 then 
kbend9=kbend*kup9
else
kbend9=kbend*kdown9
endif
kbend9 port kbend9,.025

;generate k-rate FM pitch modulators
if kfmenv9 = 1 then
kfmodenv9=kenv1
elseif kfmenv9 = 2 then
kfmodenv9=kenv2
elseif kfmenv9 = 3 then
kfmodenv9=kenv3
elseif kfmenv9 = 4 then
kfmodenv9=kenv4
elseif kfmenv9 = 5 then
kfmodenv9=kenv5
elseif kfmenv9 = 6 then
kfmodenv9=kenv6
elseif kfmenv9 = 7 then
kfmodenv9=kenv7
elseif kfmenv9 = 8 then
kfmodenv9=kenv8
elseif kfmenv9 = 9 then
kfmodenv9=kenv9
elseif kfmenv9 = 10 then
kfmodenv9=kenv10
endif

if kfm9 = 1 then
afmod9=0
elseif kfm9 = 2 then
afmod9 = aosc1*kind9*kfmodenv9
elseif kfm9 = 3 then
afmod9 = aosc2*kind9*kfmodenv9
elseif kfm9 = 4 then
afmod9 = aosc3*kind9*kfmodenv9
elseif kfm9 = 5 then
afmod9 = aosc4*kind9*kfmodenv9
elseif kfm9 = 6 then
afmod9 = aosc5*kind9*kfmodenv9
elseif kfm9 = 7 then
afmod9 = aosc6*kind9*kfmodenv9
elseif kfm9 = 8 then
afmod9 = aosc7*kind9*kfmodenv9
elseif kfm9 = 9 then
afmod9 = aosc8*kind9*kfmodenv9
elseif kfm9 = 10 then
afmod9 = aosc10*kind9*kfmodenv9
elseif kfm9 = 11 then
afmod9 = galfo1*kind9*kfmodenv9
elseif kfm9 = 12 then
afmod9 = galfo2*kind9*kfmodenv9
elseif kfm9 = 13 then
afmod9 = galfo3*kind9*kfmodenv9
elseif kfm9 = 14 then
afmod9 = galfo4*kind9*kfmodenv9
elseif kfm9 = 15 then
afmod9 = galfo5*kind9*kfmodenv9
elseif kfm9 = 16 then
afmod9 = galfo6*kind9*kfmodenv9
elseif kfm9 = 17 then
afmod9 = galfo7*kind9*kfmodenv9
elseif kfm9 = 18 then
afmod9 = galfo8*kind9*kfmodenv9
elseif kfm9 = 19 then
afmod9 = galfo9*kind9*kfmodenv9
elseif kfm9 = 20 then
afmod9 = galfo10*kind9*kfmodenv9
elseif kfm9 = 21 then
afmod9 = galiveAM*kind9*kfmodenv9
endif

kcps9=cpsmidinn(kss+((p4-kss)*ksc)+kbend9+kfine9+kcoarse9+kRNGnote+kribbon)

;add jitter
kjit9 jitter kcps9*.0016*kmjit,3*kmjitrate,14*kmjitrate
acps9=kjit9+(a(kcps9)*exp((avib+afmod9)*.083333))


;moving PW
kpwA9 oscil kpwd9*(1-abs((kpw9*2)-1)),kpwr9
kpw9=kpw9+kpwA9

;oscillator sync select logic
ksync9 chnget "sync9"
if ksync9=1 then 
andx9,async9 syncphasor acps9,async0,0
elseif ksync9=2 then
andx9,async9 syncphasor acps9,async1,0
elseif ksync9=3 then
andx9,async9 syncphasor acps9,async2,0
elseif ksync9=4 then
andx9,async9 syncphasor acps9,async3,0
elseif ksync9=5 then
andx9,async9 syncphasor acps9,async4,0
elseif ksync9=6 then
andx9,async9 syncphasor acps9,async5,0
elseif ksync9=7 then
andx9,async9 syncphasor acps9,async6,0
elseif ksync9=8 then
andx9,async9 syncphasor acps9,async7,0
elseif ksync9=9 then
andx9,async9 syncphasor acps9,async8,0
elseif ksync9=10 then
andx9,async9 syncphasor acps9,async10,0
endif
if kmrf9=0 goto NOMRF9
afn9 tablekt andx9*kpw9,99,1,0,0
goto DWNSMP9
NOMRF9:
afn9 tablekt andx9*kpw9,kfn9+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP9:
aosc9=afn9*p5
amod9u=(aosc9*.5)+.5

if kesel9 = 1 then  ;ADSR selection
ke9=kenv1
elseif kesel9 = 2 then
ke9=kenv2
elseif kesel9 = 3 then
ke9=kenv3
elseif kesel9 = 4 then
ke9=kenv4
elseif kesel9 = 5 then
ke9=kenv5
elseif kesel9 = 6 then
ke9=kenv6
elseif kesel9 = 7 then
ke9=kenv7
elseif kesel9 = 8 then
ke9=kenv8
elseif kesel9 = 9 then
ke9=kenv9
elseif kesel9 = 10 then
ke9=kenv10
endif

a9=aosc9*ke9*kamp9*p5*kon9

;AM env and source selection
if kamenv9 = 1 then
kamodenv9=kenv1
elseif kamenv9 = 2 then
kamodenv9=kenv2
elseif kamenv9 = 3 then
kamodenv9=kenv3
elseif kamenv9 = 4 then
kamodenv9=kenv4
elseif kamenv9 = 5 then
kamodenv9=kenv5
elseif kamenv9 = 6 then
kamodenv9=kenv6
elseif kamenv9 = 7 then
kamodenv9=kenv7
elseif kamenv9 = 8 then
kamodenv9=kenv8
elseif kamenv9 = 9 then
kamodenv9=kenv9
elseif kamenv9 = 10 then
kamodenv9=kenv10
endif

if kam9 = 1 then
a9=a9
elseif kam9 = 2 then
a9=a9*(1+(amod1u*kaind9*kamodenv9))
elseif kam9 = 3 then
a9=a9*(1+(amod2u*kaind9*kamodenv9))
elseif kam9 = 4 then
a9=a9*(1+(amod3u*kaind9*kamodenv9))
elseif kam9 = 5 then
a9=a9*(1+(amod4u*kaind9*kamodenv9))
elseif kam9 = 6 then
a9=a9*(1+(amod5u*kaind9*kamodenv9))
elseif kam9 = 7 then
a9=a9*(1+(amod6u*kaind9*kamodenv9))
elseif kam9 = 8 then
a9=a9*(1+(amod7u*kaind9*kamodenv9))
elseif kam9 = 9 then
a9=a9*(1+(amod8u*kaind9*kamodenv9))
elseif kam9 = 10 then
a9=a9*(1+(amod10u*kaind9*kamodenv9))
elseif kam9 = 11 then
a9=a9*(1+(galfo1u*kaind9*kamodenv9))
elseif kam9 = 12 then
a9=a9*(1+(galfo2u*kaind9*kamodenv9))
elseif kam9 = 13 then
a9=a9*(1+(galfo3u*kaind9*kamodenv9))
elseif kam9 = 14 then
a9=a9*(1+(galfo4u*kaind9*kamodenv9))
elseif kam9 = 15 then
a9=a9*(1+(galfo5u*kaind9*kamodenv9))
elseif kam9 = 16 then
a9=a9*(1+(galfo6u*kaind9*kamodenv9))
elseif kam9 = 17 then
a9=a9*(1+(galfo7u*kaind9*kamodenv9))
elseif kam9 = 18 then
a9=a9*(1+(galfo8u*kaind9*kamodenv9))
elseif kam9 = 19 then
a9=a9*(1+(galfo9u*kaind9*kamodenv9))
elseif kam9 = 20 then
a9=a9*(1+(galfo10u*kaind9*kamodenv9))
elseif kam9 = 21 then
a9=a9*(1+(galiveAM*kaind9*kamodenv9))
endif

;RM source selection
if krm9 = 1 then
goto NO_RM9
elseif krm9 = 2 then
a9=a9*aosc1
elseif krm9 = 3 then
a9=a9*aosc2
elseif krm9 = 4 then
a9=a9*aosc3
elseif krm9 = 5 then
a9=a9*aosc4
elseif krm9 = 6 then
a9=a9*aosc5
elseif krm9 = 7 then
a9=a9*aosc6
elseif krm9 = 8 then
a9=a9*aosc7
elseif krm9 = 9 then
a9=a9*aosc8
elseif krm9 = 10 then
a9=a9*aosc10
elseif krm9 = 11 then
a9=a9*galfo1
elseif krm9 = 12 then
a9=a9*galfo2
elseif krm9 = 13 then
a9=a9*galfo3
elseif krm9 = 14 then
a9=a9*galfo4
elseif krm9 = 15 then
a9=a9*galfo5
elseif krm9 = 16 then
a9=a9*galfo6
elseif krm9 = 17 then
a9=a9*galfo7
elseif krm9 = 18 then
a9=a9*galfo8
elseif krm9 = 19 then
a9=a9*galfo9
elseif krm9 = 20 then
a9=a9*galfo10
elseif krm9 = 21 then
a9=a9*galiveRM
endif

NO_RM9:
a9L=a9*(1-kpan9)
a9R=a9*kpan9

OSC10:
;OSCILLATOR 10 DEFINED IN THIS LARGE SECTION
;;get GUI data
kon10 chnget "osc10"
kon10 port kon10,.05
kamp10 chnget "amp10"
kpan10 chnget "pan10"
kfn10 chnget "fn10"
kpw10 chnget "pw10"
kpwr10 chnget "pwr10"
kpwd10 chnget "pwd10"
kesel10 chnget "env10"
kcoarse10 chnget "tc10"
kfine10 chnget "tf10"
kup10 chnget "up10"
kdown10 chnget "down10"
kfm10 chnget "fm10"
kind10 chnget "ind10"
kfmenv10 chnget "fmenv10"
kam10 chnget "am10"
kaind10 chnget "aind10"
kamenv10 chnget "amenv10"
krm10 chnget "rm10"

;calculate cps
;calculate bend
if kbend >= 0 then 
kbend10=kbend*kup10
else
kbend10=kbend*kdown10
endif
kbend10 port kbend10,.025

;generate k-rate FM pitch modulators
if kfmenv10 = 1 then
kfmodenv10=kenv1
elseif kfmenv10 = 2 then
kfmodenv10=kenv2
elseif kfmenv10 = 3 then
kfmodenv10=kenv3
elseif kfmenv10 = 4 then
kfmodenv10=kenv4
elseif kfmenv10 = 5 then
kfmodenv10=kenv5
elseif kfmenv10 = 6 then
kfmodenv10=kenv6
elseif kfmenv10 = 7 then
kfmodenv10=kenv7
elseif kfmenv10 = 8 then
kfmodenv10=kenv8
elseif kfmenv10 = 9 then
kfmodenv10=kenv9
elseif kfmenv10 = 10 then
kfmodenv10=kenv10
endif

if kfm10 = 1 then
afmod10=0
elseif kfm10 = 2 then
afmod10 = aosc1*kind10*kfmodenv10
elseif kfm10 = 3 then
afmod10 = aosc2*kind10*kfmodenv10
elseif kfm10 = 4 then
afmod10 = aosc3*kind10*kfmodenv10
elseif kfm10 = 5 then
afmod10 = aosc4*kind10*kfmodenv10
elseif kfm10 = 6 then
afmod10 = aosc5*kind10*kfmodenv10
elseif kfm10 = 7 then
afmod10 = aosc6*kind10*kfmodenv10
elseif kfm10 = 8 then
afmod10 = aosc7*kind10*kfmodenv10
elseif kfm10 = 9 then
afmod10 = aosc8*kind10*kfmodenv10
elseif kfm10 = 10 then
afmod10 = aosc9*kind10*kfmodenv10
elseif kfm10 = 11 then
afmod10 = galfo1*kind10*kfmodenv10
elseif kfm10 = 12 then
afmod10 = galfo2*kind10*kfmodenv10
elseif kfm10 = 13 then
afmod10 = galfo3*kind10*kfmodenv10
elseif kfm10 = 14 then
afmod10 = galfo4*kind10*kfmodenv10
elseif kfm10 = 15 then
afmod10 = galfo5*kind10*kfmodenv10
elseif kfm10 = 16 then
afmod10 = galfo6*kind10*kfmodenv10
elseif kfm10 = 17 then
afmod10 = galfo7*kind10*kfmodenv10
elseif kfm10 = 18 then
afmod10 = galfo8*kind10*kfmodenv10
elseif kfm10 = 19 then
afmod10 = galfo9*kind10*kfmodenv10
elseif kfm10 = 20 then
afmod10 = galfo10*kind10*kfmodenv10
elseif kfm10 = 21 then
afmod10 = galiveAM*kind10*kfmodenv10
endif

kcps10=cpsmidinn(kss+((p4-kss)*ksc)+kbend10+kfine10+kcoarse10+kRNGnote+kribbon)

;add jitter
kjit10 jitter kcps10*.0037*kmjit,3.5*kmjitrate,12*kmjitrate
acps10=kjit10+(a(kcps10)*exp((avib+afmod10)*.083333)) 

;moving PW
kpwA10 oscil kpwd10*(1-abs((kpw10*2)-1)),kpwr10
kpw10=kpw10+kpwA10

;oscillator sync select logic
ksync10 chnget "sync10"
if ksync10=1 then 
andx10,async10 syncphasor acps10,async0,0
elseif ksync10=2 then
andx10,async10 syncphasor acps10,async1,0
elseif ksync10=3 then
andx10,async10 syncphasor acps10,async2,0
elseif ksync10=4 then
andx10,async10 syncphasor acps10,async3,0
elseif ksync10=5 then
andx10,async10 syncphasor acps10,async4,0
elseif ksync10=6 then
andx10,async10 syncphasor acps10,async5,0
elseif ksync10=7 then
andx10,async10 syncphasor acps10,async6,0
elseif ksync10=8 then
andx10,async10 syncphasor acps10,async7,0
elseif ksync10=9 then
andx10,async10 syncphasor acps10,async8,0
elseif ksync10=10 then
andx10,async10 syncphasor acps10,async9,0
endif
if kmrf10=0 goto NOMRF10
afn10 tablekt andx10*kpw10,99,1,0,0
goto DWNSMP10
NOMRF10:
afn10 tablekt andx10*kpw10,kfn10+100,1,0,0 ;no wrap around to get PW Mod
DWNSMP10:
aosc10=afn10*p5
amod10u=(aosc10*.5)+.5

if kesel10 = 1 then  ;ADSR selection
ke10=kenv1
elseif kesel10 = 2 then
ke10=kenv2
elseif kesel10 = 3 then
ke10=kenv3
elseif kesel10 = 4 then
ke10=kenv4
elseif kesel10 = 5 then
ke10=kenv5
elseif kesel10 = 6 then
ke10=kenv6
elseif kesel10 = 7 then
ke10=kenv7
elseif kesel10 = 8 then
ke10=kenv8
elseif kesel10 = 9 then
ke10=kenv9
elseif kesel10 = 10 then
ke10=kenv10
endif

a10=aosc10*ke10*kamp10*p5*kon10

;AM env and source selection
if kamenv10 = 1 then
kamodenv10=kenv1
elseif kamenv10 = 2 then
kamodenv10=kenv2
elseif kamenv10 = 3 then
kamodenv10=kenv3
elseif kamenv10 = 4 then
kamodenv10=kenv4
elseif kamenv10 = 5 then
kamodenv10=kenv5
elseif kamenv10 = 6 then
kamodenv10=kenv6
elseif kamenv10 = 7 then
kamodenv10=kenv7
elseif kamenv10 = 8 then
kamodenv10=kenv8
elseif kamenv10 = 9 then
kamodenv10=kenv9
elseif kamenv10 = 10 then
kamodenv10=kenv10
endif

if kam10 = 1 then
a10=a10
elseif kam10 = 2 then
a10=a10*(1+(amod1u*kaind10*kamodenv10))
elseif kam10 = 3 then
a10=a10*(1+(amod2u*kaind10*kamodenv10))
elseif kam10 = 4 then
a10=a10*(1+(amod3u*kaind10*kamodenv10))
elseif kam10 = 5 then
a10=a10*(1+(amod4u*kaind10*kamodenv10))
elseif kam10 = 6 then
a10=a10*(1+(amod5u*kaind10*kamodenv10))
elseif kam10 = 7 then
a10=a10*(1+(amod6u*kaind10*kamodenv10))
elseif kam10 = 8 then
a10=a10*(1+(amod7u*kaind10*kamodenv10))
elseif kam10 = 9 then
a10=a10*(1+(amod8u*kaind10*kamodenv10))
elseif kam10 = 10 then
a10=a10*(1+(amod9u*kaind10*kamodenv10))
elseif kam10 = 11 then
a10=a10*(1+(galfo1u*kaind10*kamodenv10))
elseif kam10 = 12 then
a10=a10*(1+(galfo2u*kaind10*kamodenv10))
elseif kam10 = 13 then
a10=a10*(1+(galfo3u*kaind10*kamodenv10))
elseif kam10 = 14 then
a10=a10*(1+(galfo4u*kaind10*kamodenv10))
elseif kam10 = 15 then
a10=a10*(1+(galfo5u*kaind10*kamodenv10))
elseif kam10 = 16 then
a10=a10*(1+(galfo6u*kaind10*kamodenv10))
elseif kam10 = 17 then
a10=a10*(1+(galfo7u*kaind10*kamodenv10))
elseif kam10 = 18 then
a10=a10*(1+(galfo8u*kaind10*kamodenv10))
elseif kam10 = 19 then
a10=a10*(1+(galfo9u*kaind10*kamodenv10))
elseif kam10 = 20 then
a10=a10*(1+(galfo10u*kaind10*kamodenv10))
elseif kam10 = 21 then
a10=a10*(1+(galiveAM*kaind10*kamodenv10))
endif

;RM source selection
if krm10 = 1 then
goto NO_RM10
elseif krm10 = 2 then
a10=a10*aosc1
elseif krm10 = 3 then
a10=a10*aosc2
elseif krm10 = 4 then
a10=a10*aosc3
elseif krm10 = 5 then
a10=a10*aosc4
elseif krm10 = 6 then
a10=a10*aosc5
elseif krm10 = 7 then
a10=a10*aosc6
elseif krm10 = 8 then
a10=a10*aosc7
elseif krm10 = 9 then
a10=a10*aosc8
elseif krm10 = 10 then
a10=a10*aosc9
elseif krm10 = 11 then
a10=a10*galfo1
elseif krm10 = 12 then
a10=a10*galfo2
elseif krm10 = 13 then
a10=a10*galfo3
elseif krm10 = 14 then
a10=a10*galfo4
elseif krm10 = 15 then
a10=a10*galfo5
elseif krm10 = 16 then
a10=a10*galfo6
elseif krm10 = 17 then
a10=a10*galfo7
elseif krm10 = 18 then
a10=a10*galfo8
elseif krm10 = 19 then
a10=a10*galfo9
elseif krm10 = 20 then
a10=a10*galfo10
elseif krm10 = 21 then
a10=a10*galiveRM
endif

NO_RM10:
a10L=a10*(1-kpan10)
a10R=a10*kpan10

SUM:       ;sum all oscillators
aL=a1L+a2L+a3L+a4L+a5L+a6L+a7L+a8L+a9L+a10L
aR=a1R+a2R+a3R+a4R+a5R+a6R+a7R+a8R+a9R+a10R
aLd delay1 aL
aRd delay1 aR
aL=kmamp*.1*(aL+aLd)    ;simple LP at Nyquist F
aR=kmamp*.1*(aR+aRd)

;dynamic filter section
kLLPon chnget "LLPon"
kLLPlp chnget "LLPlp"
kLLPlp port kLLPlp,.05
kLLPbp chnget "LLPbp"
kLLPbp port kLLPbp,.05
kLLPhp chnget "LLPhp"
kLLPhp port kLLPhp,.05
kLLPcfset chnget "LLPcfset"
kLLPadsr chnget "LLPadsr"
koffset chnget "offset"
kbase chnget "base"
ktarget chnget "target"
kLLPQadsr chnget "LLPQadsr"
kLLPQbase chnget "LLPQbase"
kLLPQtarget chnget "LLPQtarget"
if kLLPon==0 goto noLLP

if kLLPadsr = 1 then
kcfenv=kenv1
elseif kLLPadsr = 2 then
kcfenv=kenv2
elseif kLLPadsr = 3 then
kcfenv=kenv3
elseif kLLPadsr = 4 then
kcfenv=kenv4
elseif kLLPadsr = 5 then
kcfenv=kenv5
elseif kLLPadsr = 6 then
kcfenv=kenv6
elseif kLLPadsr = 7 then
kcfenv=kenv7
elseif kLLPadsr = 8 then
kcfenv=kenv8
elseif kLLPadsr = 9 then
kcfenv=kenv9
elseif kLLPadsr = 10 then
kcfenv=kenv10
endif
if kLLPcfset==1 then
kLLPcf=cpsmidinn(p4+koffset+(kcfenv*(p4+koffset+ktarget-(p4+koffset))))
else 
kLLPcf=cpsmidinn(kbase+(kcfenv*((kbase+ktarget)-kbase)))
endif
kLLPcf limit kLLPcf,50,25000

if kLLPQadsr = 1 then
kQenv=kenv1
elseif kLLPQadsr = 2 then
kQenv=kenv2
elseif kLLPQadsr = 3 then
kQenv=kenv3
elseif kLLPQadsr = 4 then
kQenv=kenv4
elseif kLLPQadsr = 5 then
kQenv=kenv5
elseif kLLPQadsr = 6 then
kQenv=kenv6
elseif kLLPQadsr = 7 then
kQenv=kenv7
elseif kLLPQadsr = 8 then
kQenv=kenv8
elseif kLLPQadsr = 9 then
kQenv=kenv9
elseif kLLPQadsr = 10 then
kQenv=kenv10
endif
kQenv=kenv1
kLLPQ=kLLPQbase+(kQenv*(kLLPQtarget-kLLPQbase))
kLLPQ limit kLLPQ,.5,25

alpL,abpL,ahpL zdf_2pole_mode aL,kLLPcf,kLLPQ
alpR,abpR,ahpR zdf_2pole_mode aR,kLLPcf,kLLPQ

aLLPL=(alpL*kLLPlp)+(abpL*kLLPbp)+(ahpL*kLLPhp)
aLLPR=(alpR*kLLPlp)+(abpR*kLLPbp)+(ahpR*kLLPhp)
aL balance aLLPL,aL
aR balance aLLPR,aR

noLLP:
gaSynL=gaSynL+aL
gaSynR=gaSynR+aR

endin

instr 20    ;always on for noise generators
kduston chnget "duston"
kdustamp chnget "dustamp"
kdustrate chnget "dustrate"
kwhiteon chnget "whiteon"
kwhiteamp chnget "whiteamp"
kpinkon chnget "pinkon"
kpinkamp chnget "pinkamp"
kgausson chnget "gausson"
kgaussamp chnget "gaussamp"

adust1 dust2 kdustamp,kdustrate 
adust2 dust2 kdustamp,kdustrate  
awhite1 rand kwhiteamp 
awhite2 rand kwhiteamp
apink1 pinkish kpinkamp 
apink2 pinkish kpinkamp
agauss1 gauss kgaussamp 
agauss2 gauss kgaussamp
gaSynL=gaSynL+(adust1*kduston)+(awhite1*kwhiteon)+(apink1*kpinkon)+(agauss1*kgausson)
gaSynR=gaSynR+(adust2*kduston)+(awhite2*kwhiteon)+(apink2*kpinkon)+(agauss2*kgausson)
DUSTEND:
endin

instr 25 ;GUI control for FM/AM controls, and Dynamic Filter CF Offset vs. Base
kfm1 chnget "fm1"
kfm2 chnget "fm2"
kfm3 chnget "fm3"
kfm4 chnget "fm4"
kfm5 chnget "fm5"
kfm6 chnget "fm6"
kfm7 chnget "fm7"
kfm8 chnget "fm8"
kfm9 chnget "fm9"
kfm10 chnget "fm10"
kam1 chnget "am1"
kam2 chnget "am2"
kam3 chnget "am3"
kam4 chnget "am4"
kam5 chnget "am5"
kam6 chnget "am6"
kam7 chnget "am7"
kam8 chnget "am8"
kam9 chnget "am9"
kam10 chnget "am10"
kLLPcfset chnget "LLPcfset"
if changed(kLLPcfset)==1 then
  if kLLPcfset==1 then
  chnset "visible(1)", "LLPoffset"
  chnset "visible(1)", "offsetlabel"
  chnset "visible(0)", "LLPbase"
  chnset "visible(0)", "baselabel"
  elseif kLLPcfset==2 then
  chnset "visible(0)", "LLPoffset"
  chnset "visible(0)", "offsetlabel"
  chnset "visible(1)", "LLPbase"
  chnset "visible(1)", "baselabel"
  endif
endif
if changed(kfm1)==1 then
  if kfm1==1 then
  chnset "visible(0)","fi1"
  chnset "visible(0)","fe1"
  else
  chnset "visible(1)","fi1"
  chnset "visible(1)","fe1"
  endif
endif
if changed(kfm2)==1 then
  if kfm2==1 then
  chnset "visible(0)","fi2"
  chnset "visible(0)","fe2"
  else
  chnset "visible(1)","fi2"
  chnset "visible(1)","fe2"
  endif
endif
if changed(kfm3)==1 then
  if kfm3==1 then
  chnset "visible(0)","fi3"
  chnset "visible(0)","fe3"
  else
  chnset "visible(1)","fi3"
  chnset "visible(1)","fe3"
  endif
endif
if changed(kfm4)==1 then
  if kfm4==1 then
  chnset "visible(0)","fi4"
  chnset "visible(0)","fe4"
  else
  chnset "visible(1)","fi4"
  chnset "visible(1)","fe4"
  endif
endif
if changed(kfm5)==1 then
  if kfm5==1 then
  chnset "visible(0)","fi5"
  chnset "visible(0)","fe5"
  else
  chnset "visible(1)","fi5"
  chnset "visible(1)","fe5"
  endif
endif
if changed(kfm6)==1 then
  if kfm6==1 then
  chnset "visible(0)","fi6"
  chnset "visible(0)","fe6"
  else
  chnset "visible(1)","fi6"
  chnset "visible(1)","fe6"
  endif
endif
if changed(kfm7)==1 then
  if kfm7==1 then
  chnset "visible(0)","fi7"
  chnset "visible(0)","fe7"
  else
  chnset "visible(1)","fi7"
  chnset "visible(1)","fe7"
  endif
endif
if changed(kfm8)==1 then
  if kfm8==1 then
  chnset "visible(0)","fi8"
  chnset "visible(0)","fe8"
  else
  chnset "visible(1)","fi8"
  chnset "visible(1)","fe8"
  endif
endif
if changed(kfm9)==1 then
  if kfm9==1 then
  chnset "visible(0)","fi9"
  chnset "visible(0)","fe9"
  else
  chnset "visible(1)","fi9"
  chnset "visible(1)","fe9"
  endif
endif
if changed(kfm10)==1 then
  if kfm10==1 then
  chnset "visible(0)","fi10"
  chnset "visible(0)","fe10"
  else
  chnset "visible(1)","fi10"
  chnset "visible(1)","fe10"
  endif
endif
if changed(kam1)==1 then
  if kam1==1 then
  chnset "visible(0)","ai1"
  chnset "visible(0)","ae1"
  else
  chnset "visible(1)","ai1"
  chnset "visible(1)","ae1"
  endif
endif
if changed(kam2)==1 then
  if kam2==1 then
  chnset "visible(0)","ai2"
  chnset "visible(0)","ae2"
  else
  chnset "visible(1)","ai2"
  chnset "visible(1)","ae2"
  endif
endif
if changed(kam3)==1 then
  if kam3==1 then
  chnset "visible(0)","ai3"
  chnset "visible(0)","ae3"
  else
  chnset "visible(1)","ai3"
  chnset "visible(1)","ae3"
  endif
endif
if changed(kam4)==1 then
  if kam4==1 then
  chnset "visible(0)","ai4"
  chnset "visible(0)","ae4"
  else
  chnset "visible(1)","ai4"
  chnset "visible(1)","ae4"
  endif
endif
if changed(kam5)==1 then
  if kam5==1 then
  chnset "visible(0)","ai5"
  chnset "visible(0)","ae5"
  else
  chnset "visible(1)","ai5"
  chnset "visible(1)","ae5"
  endif
endif
if changed(kam6)==1 then
  if kam6==1 then
  chnset "visible(0)","ai6"
  chnset "visible(0)","ae6"
  else
  chnset "visible(1)","ai6"
  chnset "visible(1)","ae6"
  endif
endif
if changed(kam7)==1 then
  if kam7==1 then
  chnset "visible(0)","ai7"
  chnset "visible(0)","ae7"
  else
  chnset "visible(1)","ai7"
  chnset "visible(1)","ae7"
  endif
endif
if changed(kam8)==1 then
  if kam8==1 then
  chnset "visible(0)","ai8"
  chnset "visible(0)","ae8"
  else
  chnset "visible(1)","ai8"
  chnset "visible(1)","ae8"
  endif
endif
if changed(kam9)==1 then
  if kam9==1 then
  chnset "visible(0)","ai9"
  chnset "visible(0)","ae9"
  else
  chnset "visible(1)","ai9"
  chnset "visible(1)","ae9"
  endif
endif
if changed(kam10)==1 then
  if kam10==1 then
  chnset "visible(0)","ai10"
  chnset "visible(0)","ae10"
  else
  chnset "visible(1)","ai10"
  chnset "visible(1)","ae10"
  endif
endif
endin

instr 60 ;vocal filter preset controller
 gkvpreset	chnget	"vpresets"
 ktrig		changed	gkvpreset 

 #define SET_PRESET(N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16)
 #
 if i(gkvpreset)==$N then
  chnset	$set1,"parsel1"	  
  chnset	$set2,"parsel2"    
  chnset	$set3,"parsel3"   
  chnset	$set4,"parsel4"
  chnset	$set5,"parF1"
  chnset	$set6,"parF2"  
  chnset	$set7,"parF3"
  chnset	$set8,"parF4"
  chnset	$set9,"parres1"
  chnset	$set10,"parres2"
  chnset	$set11,"parres3"   
  chnset	$set12,"parres4"   
  chnset	$set13,"paramp1" 
  chnset	$set14,"paramp2" 
  chnset	$set15,"paramp3"
  chnset	$set16,"paramp4"
 endif
 #
 if ktrig==1 then
  reinit SEND_PRESET
 endif
 SEND_PRESET: ;1-21=default, Sop a,e,i,o,u, Alto a,e,i,o,u, Tenor a,e,i,o,u, and Bass a,e,i,o,u
 ;           N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16
 $SET_PRESET(1'1'2'2'3'8'9'10'11'1'1'1'1'1'1'1'1)
 $SET_PRESET(2'2'2'2'2'octmidinn(79.4)'octmidinn(85.6)'octmidinn(101.6)'octmidinn(106.85)'800/80'1150/120'2900/200'3900/130'ampdbfs(0)'ampdbfs(-6)'ampdbfs(-32)'ampdbfs(-20)) ;soprano
 $SET_PRESET(3'2'2'2'2'octmidinn(65)'octmidinn(95.2)'octmidinn(101.1)'octmidinn(105.45)'350/60'2000/100'2800/120'3600/150'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-15)'ampdbfs(-40))
 $SET_PRESET(4'2'2'2'2'octmidinn(60.6)'octmidinn(96.4)'octmidinn(101.9)'octmidinn(106.85)'270/60'2140/90'2950/100'3900/120'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-26)'ampdbfs(-26))
 $SET_PRESET(5'2'2'2'2'octmidinn(69.4)'octmidinn(79.4)'octmidinn(101.2)'octmidinn(106.4)'450/40'800/80'2830/100'3800/120'ampdbfs(0)'ampdbfs(-11)'ampdbfs(-22)'ampdbfs(-22))
 $SET_PRESET(6'2'2'2'2'octmidinn(63.75)'octmidinn(77)'octmidinn(100.45)'octmidinn(106.4)'325/50'700/60'2700/170'3800/180'ampdbfs(0)'ampdbfs(-16)'ampdbfs(-35)'ampdbfs(-40))
 $SET_PRESET(7'2'2'2'2'octmidinn(79.4)'octmidinn(85.6)'octmidinn(101.1)'octmidinn(104.9)'800/80'1150/90'2800/120'3500/130'ampdbfs(0)'ampdbfs(-4)'ampdbfs(-20)'ampdbfs(-36)) ;alto
 $SET_PRESET(8'2'2'2'2'octmidinn(67.4)'octmidinn(91.4)'octmidinn(100.45)'octmidinn(103.85)'400/60'1600/80'2700/120'3300/150'ampdbfs(0)'ampdbfs(-24)'ampdbfs(-30)'ampdbfs(-35))
 $SET_PRESET(9'2'2'2'2'octmidinn(65)'octmidinn(92.4)'octmidinn(100.45)'octmidinn(105.9)'350/50'1700/100'2700/120'3700/150'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-30)'ampdbfs(-36))
 $SET_PRESET(10'2'2'2'2'octmidinn(69.4)'octmidinn(79.4)'octmidinn(101.2)'octmidinn(104.9)'450/70'800/80'2830/100'3500/130'ampdbfs(0)'ampdbfs(-9)'ampdbfs(-16)'ampdbfs(-28))
 $SET_PRESET(11'2'2'2'2'octmidinn(63.75)'octmidinn(77)'octmidinn(99.3)'octmidinn(104.9)'325/50'700/60'2530/170'3500/180'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-30)'ampdbfs(-40))
 $SET_PRESET(12'2'2'2'2'octmidinn(75.75)'octmidinn(84.6)'octmidinn(100.1)'octmidinn(101.6)'650/80'1080/90'2650/120'2900/130'ampdbfs(0)'ampdbfs(-6)'ampdbfs(-7)'ampdbfs(-8)) ;tenor
 $SET_PRESET(13'2'2'2'2'octmidinn(67.4)'octmidinn(92.4)'octmidinn(99.7)'octmidinn(103.4)'400/70'1700/80'2600/100'3200/120'ampdbfs(0)'ampdbfs(-14)'ampdbfs(-12)'ampdbfs(-14))
 $SET_PRESET(14'2'2'2'2'octmidinn(61.66)'octmidinn(94.1)'octmidinn(101.1)'octmidinn(103.6)'290/40'1870/90'2800/100'3250/120'ampdbfs(0)'ampdbfs(-15)'ampdbfs(-18)'ampdbfs(-20))
 $SET_PRESET(15'2'2'2'2'octmidinn(67.4)'octmidinn(79.4)'octmidinn(99.7)'octmidinn(101.1)'400/70'800/80'2600/100'2800/130'ampdbfs(0)'ampdbfs(-10)'ampdbfs(-12)'ampdbfs(-12))
 $SET_PRESET(16'2'2'2'2'octmidinn(65)'octmidinn(74.3)'octmidinn(100.45)'octmidinn(101.6)'350/40'600/60'2700/100'2900/120'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-17)'ampdbfs(-14))
 $SET_PRESET(17'2'2'2'2'octmidinn(74.3)'octmidinn(83.9)'octmidinn(97.2)'octmidinn(98.6)'600/60'1040/70'2250/110'2450/120'ampdbfs(0)'ampdbfs(-7)'ampdbfs(-9)'ampdbfs(-9)) ;bass
 $SET_PRESET(18'2'2'2'2'octmidinn(67.4)'octmidinn(91.6)'octmidinn(98.4)'octmidinn(101.1)'400/40'1620/80'2400/100'2800/120'ampdbfs(0)'ampdbfs(-12)'ampdbfs(-9)'ampdbfs(-12))
 $SET_PRESET(19'2'2'2'2'octmidinn(59.33)'octmidinn(92.9)'octmidinn(99.7)'octmidinn(102.5)'250/60'1750/90'2600/100'3050/120'ampdbfs(0)'ampdbfs(-30)'ampdbfs(-16)'ampdbfs(-22))
 $SET_PRESET(20'2'2'2'2'octmidinn(67.4)'octmidinn(78.25)'octmidinn(98.4)'octmidinn(99.7)'400/40'750/80'2400/100'2600/120'ampdbfs(0)'ampdbfs(-11)'ampdbfs(-21)'ampdbfs(-20))
 $SET_PRESET(21'2'2'2'2'octmidinn(65)'octmidinn(74.3)'octmidinn(98.4)'octmidinn(100.3)'350/40'600/80'2400/100'2675/120'ampdbfs(0)'ampdbfs(-20)'ampdbfs(-32)'ampdbfs(-28))

endin

instr 61 ;Transposer preset controller
 gkTpreset	chnget	"Tpresets"
 ktrig		changed	gkTpreset 

 #define SET_PRESET(N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12)
 #
 if i(gkTpreset)==$N then
  chnset	$set1,"harmon1C"	  
  chnset	$set2,"harmon1F"    
  chnset	$set3,"harmon2C"   
  chnset	$set4,"harmon2F"
  chnset	$set5,"harmon3C"
  chnset	$set6,"harmon3F"  
  chnset	$set7,"harmon4C"
  chnset	$set8,"harmon4F"
  chnset	$set9,"harmon5C"
  chnset	$set10,"harmon5F"
  chnset	$set11,"harmon6C"   
  chnset	$set12,"harmon6F"
 endif
 #
 if ktrig==1 then
  reinit SEND_PRESET
 endif
 SEND_PRESET:
 ;           N'set1'set2'set3'set4'set5'set6'set7'set8'set9'set10'set11'set12'set13'set14'set15'set16
 $SET_PRESET(1'0'.14'0'-.16'0'.09'0'-.12'0'.11'0'-.05)
 $SET_PRESET(2'0'.15'0'-.16'0'.18'0'-.25'0'.24'0'-.21)
 $SET_PRESET(3'0'-.32'0'.67'0'-.65'-1'.01'1'-.06'0'.34)
 $SET_PRESET(4'7'-.05'7'.1'7'-.08'7'.01'7'-.06'7'.03)
 $SET_PRESET(5'5'.05'5'-.1'5'.08'5'-.03'5'.06'5'-.05)
 $SET_PRESET(6'4'-.07'4'.04'4'-.02'4'.06'4'-.08'4'.09)
 $SET_PRESET(7'3'.05'3'.11'3'.08'3'-.01'3'-.06'3'-.09)
 $SET_PRESET(8'0'.5'0'-.5'1'0'-1'.01'1'-.51'-1'.53)
 $SET_PRESET(9'-1'-.05'1'.1'-2'-.08'2'.01'-3'-.06'3'.03)
 $SET_PRESET(10'4'-.05'-4'.1'6'-.08'-6'.01'2'-.06'-2'.03)
 $SET_PRESET(11'21'-.05'-21'.1'7'-.08'-7'.01'14'-.06'-14'.03)
 $SET_PRESET(12'-10'-.05'10'.1'-15'-.08'15'.01'-5'-.06'5'.03)
 $SET_PRESET(13'4'-.05'-4'.1'12'-.08'-12'.01'8'-.06'-8'.03)
 $SET_PRESET(14'-9'-.05'9'.1'-6'-.08'6'.01'-3'-.06'3'.03)
 $SET_PRESET(15'-12'-.15'-24'.19'-12'-.18'24'.17'12'-.16'12'.13)
 $SET_PRESET(16'-12'-.05'-5'.1'-12'-.08'-5'.01'7'-.06'12'.03)
 $SET_PRESET(17'16'-.05'-12'.1'7'-.08'-5'.01'12'-.06'-12'.03)
 $SET_PRESET(18'12'-.05'-5'.1'3'-.08'-12'.01'7'-.06'15'.03)
 $SET_PRESET(19'4'-.05'12'.1'10'-.08'-12'.01'-5'-.06'10'.03)
 $SET_PRESET(20'7'-.05'-12'.1'-5'-.08'11'.01'4'-.06'12'.03)
 $SET_PRESET(21'11'-.05'4'.1'12'-.08'2'.01'-12'-.06'-5'.03)
 $SET_PRESET(22'10'-.05'12'.1'7'-.08'3'.01'-5'-.06'-12'.03)
 $SET_PRESET(23'-12'-.05'-5'.1'5'-.08'7'.01'0'-.06'12'.03)
 $SET_PRESET(24'7'-.05'10'.1'12'-.08'-12'.01'-5'-.06'5'.03)
 $SET_PRESET(25'12'-.05'10'.1'-12'-.08'-5'.01'4'-.06'15'.03)
 $SET_PRESET(26'10'-.05'-12'.1'12'-.08'4'.01'-5'-.06'14'.03)
 $SET_PRESET(27'0'-.05'4'.1'-12'-.08'10'.01'15'-.06'4'.03)

endin

instr 100   ;instrument to monitor MIDI controller numbers, creates global MIDI outputs that are evaluated by instr 110-300         
            ;also controls popup for latched LowPass and soundfile string management
gkstatus,gkchan,gkdata1,gkdata2 midiin
if changed(gkstatus)==1 then  
    if gkstatus==176 then
    chnset gkdata1,"CtrlNum" ;displays current controller number in GUI
    endif
endif
endin

instr 101 ;master volume MIDI mapping
kmapMamp chnget "mapMamp"
kmapMampX chnget "mapMampX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapMamp==1 then
      turnoff2 102,2,0
      event "i",102,0,999999999
    endif
  endif
endif
if kmapMampX==1 then
  turnoff2 102,2,0
endif
endin

instr 102
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1.5000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "MAmp"
endin

instr 103 ;pitch ribbon MIDI mapping
kmaprib chnget "maprib"
kmapribX chnget "mapribX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmaprib==1 then
      turnoff2 104,2,0
      event "i",104,0,999999999
    endif
  endif
endif
if kmapribX==1 then
  turnoff2 104,2,0
endif
endin

instr 104
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-36,36 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "ribbon"
endin

instr 105 ;Live Audio Amp MIDI mapping
kmapliveamp chnget "mapliveamp"
kmapliveampX chnget "mapliveampX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapliveamp==1 then
      turnoff2 106,2,0
      event "i",106,0,999999999
    endif
  endif
endif
if kmapliveampX==1 then
  turnoff2 106,2,0
endif
endin

instr 106
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2.5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "liveamp"
endin


instr 107 ;Live Audio Amp MIDI mapping
kmapmorph chnget "mapmorph"
kmapmorphX chnget "mapmorphX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapmorph==1 then
      turnoff2 108,2,0
      event "i",108,0,999999999
    endif
  endif
endif
if kmapmorphX==1 then
  turnoff2 108,2,0
endif
endin

instr 108
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,9 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "morph"
endin

instr 109 ;Live Audio Amp MIDI mapping
kmapliveamp chnget "mapsfamp"
kmapliveampX chnget "mapsfampX"
if changed(gkstatus)==1 then
  if gkstatus==176 then
    if kmapliveamp==1 then
      turnoff2 110,2,0
      event "i",110,0,999999999
    endif
  endif
endif
if kmapliveampX==1 then
  turnoff2 110,2,0
endif
endin

instr 110
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "sfamp"
endin

instr 200
;receive MIDI mapping buttons for RNG
kmapRNGrate chnget "mapRNGrate"
kmapRNGrateX chnget "mapRNGrateX"
kmapRNGraterand chnget "mapRNGraterand"
kmapRNGraterandX chnget "mapRNGraterandX"
kmapRNGdev chnget "mapRNGdev"
kmapRNGdevX chnget "mapRNGdevX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapRNGrate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 201, 2, 0
            event "i", 201, 0, 999999999
        elseif kmapRNGraterand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 202, 2, 0
            event "i", 202, 0, 999999999
        elseif kmapRNGdev == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 204, 2, 0
            event "i", 204, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapRNGrateX == 1 then
    turnoff2 201, 2, 0
elseif kmapRNGraterandX == 1 then
    turnoff2 202, 2, 0
elseif kmapRNGdevX == 1 then
    turnoff2 204, 2, 0
endif
endin

instr 201 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGrate"
endin

instr 202 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGraterand"
endin

instr 204 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,60 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGdev"
endin

instr 210
;receive MIDI mapping buttons for Distortion
kmapdist chnget "mapdist"
kmapdistX chnget "mapdistX"
kmapdist2 chnget "mapdist2"
kmapdist2X chnget "mapdist2X"
kmapdist3 chnget "mapdist3"
kmapdist3X chnget "mapdist3X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdist == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 211, 2, 0
            event "i", 211, 0, 999999999
        elseif kmapdist2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 212, 2, 0
            event "i", 212, 0, 999999999
        elseif kmapdist3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 213, 2, 0
            event "i", 213, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdistX == 1 then
    turnoff2 211, 2, 0
elseif kmapdist2X == 1 then
    turnoff2 212, 2, 0
elseif kmapdist3X == 1 then
    turnoff2 213, 2, 0
endif
endin

instr 211 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "distA"
endin

instr 212 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "distB"
endin

instr 213 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "distC"
endin

instr 220
;receive MIDI mapping buttons for Vibrato
kmapvibrand chnget "mapvibrand"
kmapvibrandX chnget "mapvibrandX"
kmapvibcps chnget "mapvibcps"
kmapvibcpsX chnget "mapvibcpsX"
kmapvibdepth chnget "mapvibdepth"
kmapvibdepthX chnget "mapvibdepthX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapvibrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 221, 2, 0
            event "i", 221, 0, 999999999
        elseif kmapvibcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 222, 2, 0
            event "i", 222, 0, 999999999
        elseif kmapvibdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 223, 2, 0
            event "i", 223, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapvibrandX == 1 then
    turnoff2 221, 2, 0
elseif kmapvibcpsX == 1 then
    turnoff2 222, 2, 0
elseif kmapvibdepthX == 1 then
    turnoff2 223, 2, 0
endif
endin

instr 221 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibrand"
endin

instr 222 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibcps"
endin

instr 223 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibdepth"
endin

instr 230
;receive MIDI mapping buttons for Lowpass
kmapLPcps chnget "mapLPcps"
kmapLPcpsX chnget "mapLPcpsX"
kmapLPres chnget "mapLPres"
kmapLPresX chnget "mapLPresX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapLPcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 231, 2, 0
            event "i", 231, 0, 999999999
        elseif kmapLPres == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 232, 2, 0
            event "i", 232, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapLPcpsX == 1 then
    turnoff2 231, 2, 0
elseif kmapLPresX == 1 then
    turnoff2 232, 2, 0
endif
endin

instr 231 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,2,14 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPcps"
endin

instr 232 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPres"
endin

instr 240
;receive MIDI mapping buttons for Phaser
kmapphscps chnget "mapphscps"
kmapphscpsX chnget "mapphscpsX"
kmapphsFB chnget "mapphsFB"
kmapphsFBX chnget "mapphsFBX"
kmapphsQ chnget "mapphsQ"
kmapphsQX chnget "mapphsQX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapphscps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 241, 2, 0
            event "i", 241, 0, 999999999
        elseif kmapphsFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 242, 2, 0
            event "i", 242, 0, 999999999
        elseif kmapphsQ == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 243, 2, 0
            event "i", 243, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapphscpsX == 1 then
    turnoff2 241, 2, 0
elseif kmapphsFBX == 1 then
    turnoff2 242, 2, 0
elseif kmapphsQX == 1 then
    turnoff2 243, 2, 0
endif
endin

instr 241 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phscps"
endin

instr 242 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsFB"
endin

instr 243 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsQ"
endin

instr 250
;receive MIDI mapping buttons for Flanger
kmapflcps chnget "mapflcps"
kmapflcpsX chnget "mapflcpsX"
kmapflFB chnget "mapflFB"
kmapflFBX chnget "mapflFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapflcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 251, 2, 0
            event "i", 251, 0, 999999999
        elseif kmapflFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 252, 2, 0
            event "i", 252, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapflcpsX == 1 then
    turnoff2 251, 2, 0
elseif kmapflFBX == 1 then
    turnoff2 252, 2, 0
endif
endin

instr 251 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flcps"
endin

instr 252 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flFB"
endin

instr 260
;receive MIDI mapping buttons for Transposer
kmapharmmix chnget "mapharmmix"
kmapharmmixX chnget "mapharmmixX"
kmapharmon1C chnget "mapharmon1C"
kmapharmon1CX chnget "mapharmon1CX"
kmapharmon1F chnget "mapharmon1F"
kmapharmon1FX chnget "mapharmon1FX"
kmapharmon2C chnget "mapharmon2C"
kmapharmon2CX chnget "mapharmon2CX"
kmapharmon2F chnget "mapharmon2F"
kmapharmon2FX chnget "mapharmon2FX"
kmapharmon3C chnget "mapharmon3C"
kmapharmon3CX chnget "mapharmon3CX"
kmapharmon3F chnget "mapharmon3F"
kmapharmon3FX chnget "mapharmon3FX"
kmapharmon4C chnget "mapharmon4C"
kmapharmon4CX chnget "mapharmon4CX"
kmapharmon4F chnget "mapharmon4F"
kmapharmon4FX chnget "mapharmon4FX"
kmapharmon5C chnget "mapharmon5C"
kmapharmon5CX chnget "mapharmon5CX"
kmapharmon5F chnget "mapharmon5F"
kmapharmon5FX chnget "mapharmon5FX"
kmapharmon6C chnget "mapharmon6C"
kmapharmon6CX chnget "mapharmon6CX"
kmapharmon6F chnget "mapharmon6F"
kmapharmon6FX chnget "mapharmon6FX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapharmmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 261, 2, 0
            event "i", 261, 0, 999999999
        elseif kmapharmon1C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 262, 2, 0
            event "i", 262, 0, 999999999
        elseif kmapharmon1F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 263, 2, 0
            event "i", 263, 0, 999999999
        elseif kmapharmon2C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 264, 2, 0
            event "i", 264, 0, 999999999
        elseif kmapharmon2F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 265, 2, 0
            event "i", 265, 0, 999999999
        elseif kmapharmon3C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 266, 2, 0
            event "i", 266, 0, 999999999
        elseif kmapharmon3F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 267, 2, 0
            event "i", 267, 0, 999999999
        elseif kmapharmon4C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 268, 2, 0
            event "i", 268, 0, 999999999
        elseif kmapharmon4F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 269, 2, 0
            event "i", 269, 0, 999999999
        elseif kmapharmon5C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 270, 2, 0
            event "i", 270, 0, 999999999
        elseif kmapharmon5F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 271, 2, 0
            event "i", 271, 0, 999999999
        elseif kmapharmon6C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 272, 2, 0
            event "i", 272, 0, 999999999
        elseif kmapharmon6F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 273, 2, 0
            event "i", 273, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapharmmixX == 1 then
    turnoff2 261, 2, 0
elseif kmapharmon1CX == 1 then
    turnoff2 262, 2, 0
elseif kmapharmon1FX == 1 then
    turnoff2 263, 2, 0
elseif kmapharmon2CX == 1 then
    turnoff2 264, 2, 0
elseif kmapharmon2FX == 1 then
    turnoff2 265, 2, 0
elseif kmapharmon3CX == 1 then
    turnoff2 266, 2, 0
elseif kmapharmon3FX == 1 then
    turnoff2 267, 2, 0
elseif kmapharmon4CX == 1 then
    turnoff2 268, 2, 0
elseif kmapharmon4FX == 1 then
    turnoff2 269, 2, 0
elseif kmapharmon5CX == 1 then
    turnoff2 270, 2, 0
elseif kmapharmon5FX == 1 then
    turnoff2 271, 2, 0
elseif kmapharmon6CX == 1 then
    turnoff2 272, 2, 0
elseif kmapharmon6FX == 1 then
    turnoff2 273, 2, 0
endif
endin

instr 261 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmmix"
endin

instr 262 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1C"
endin

instr 263 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1F"
endin

instr 264 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2C"
endin

instr 265 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2F"
endin

instr 266 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3C"
endin

instr 267 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3F"
endin

instr 268 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4C"
endin

instr 269 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4F"
endin

instr 270 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5C"
endin

instr 271 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5F"
endin

instr 272 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6C"
endin

instr 273 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6F"
endin

instr 280
;receive MIDI mapping buttons for Chorus
kmapchmix chnget "mapchmix"
kmapchmixX chnget "mapchmixX"
kmapchcps chnget "mapchcps"
kmapchcpsX chnget "mapchcpsX"
kmapchFB chnget "mapchFB"
kmapchFBX chnget "mapchFBX"
kmapchdepth chnget "mapchdepth"
kmapchdepthX chnget "mapchdepthX"
kmapchdel chnget "mapchdel"
kmapchdelX chnget "mapchdelX"
kmapchrand chnget "mapchrand"
kmapchrandX chnget "mapchrandX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapchmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 281, 2, 0
            event "i", 281, 0, 999999999
        elseif kmapchcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 282, 2, 0
            event "i", 282, 0, 999999999
        elseif kmapchFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 283, 2, 0
            event "i", 283, 0, 999999999
        elseif kmapchdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 284, 2, 0
            event "i", 284, 0, 999999999
        elseif kmapchdel == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 285, 2, 0
            event "i", 285, 0, 999999999
        elseif kmapchrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 286, 2, 0
            event "i", 286, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapchmixX == 1 then
    turnoff2 281, 2, 0
elseif kmapchcpsX == 1 then
    turnoff2 282, 2, 0
elseif kmapchFBX == 1 then
    turnoff2 283, 2, 0
elseif kmapchdepthX == 1 then
    turnoff2 284, 2, 0
elseif kmapchdelX == 1 then
    turnoff2 285, 2, 0
elseif kmapchrandX == 1 then
    turnoff2 286, 2, 0
endif
endin

instr 281 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chmix"
endin

instr 282 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chcps"
endin

instr 283 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chFB"
endin

instr 284 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdepth"
endin

instr 285 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdel"
endin

instr 286 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.9 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chrand"
endin

instr 290
;receive MIDI mapping buttons for Delay
kmapdeltime chnget "mapdeltime"
kmapdeltimeX chnget "mapdeltimeX"
kmapdelFB chnget "mapdelFB"
kmapdelFBX chnget "mapdelFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdeltime == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 291, 2, 0
            event "i", 291, 0, 999999999
        elseif kmapdelFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 292, 2, 0
            event "i", 292, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdeltimeX == 1 then
    turnoff2 291, 2, 0
elseif kmapdelFBX == 1 then
    turnoff2 292, 2, 0
endif
endin

instr 291 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,4.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "deltime"
endin

instr 292 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "delFB"
endin

instr 300
;receive MIDI mapping buttons for Reverb
kmaprevmix chnget "maprevmix"
kmaprevmixX chnget "maprevmixX"
kmaprevFB chnget "maprevFB"
kmaprevFBX chnget "maprevFBX"
kmaprevLP chnget "maprevLP"
kmaprevLPX chnget "maprevLPX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaprevmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 301, 2, 0
            event "i", 301, 0, 999999999
        elseif kmaprevFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 302, 2, 0
            event "i", 302, 0, 999999999
        elseif kmaprevLP == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 303, 2, 0
            event "i", 303, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmaprevmixX == 1 then
    turnoff2 301, 2, 0
elseif kmaprevFBX == 1 then
    turnoff2 302, 2, 0
elseif kmaprevLPX == 1 then
    turnoff2 303, 2, 0
endif
endin

instr 301 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revmix"
endin

instr 302 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revFB"
endin

instr 303 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,200,20000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revLP"
endin

instr 500   ;global FX for EQ, distortion, LP, Phaser, Flanger, etc
;input gaSynL and gaSynR, output gaFXL and gaFXR
;master effects section

aL=gaSynL+galiveL
aR=gaSynR+galiveR

;distortion
kdiston chnget "diston"
if kdiston==0 goto nodist
kdist chnget "distA"
kdist port kdist,.05
ad1L distort aL,kdist,26
ad1R distort aR,kdist,26
aL balance2 ad1L,aL
aR balance2 ad1R,aR

kdist2 chnget "distB"
kdist2=1-kdist2
kdist2 port kdist2,.05
ad2L powershape aL,kdist2
ad2R powershape aR,kdist2
aL balance2 ad2L,aL
aR balance2 ad2R,aR

kdist3 chnget "distC"
kdist3 port kdist3,.05
ad3L fold aL,kdist3
ad3R fold aR,kdist3
aL balance2 ad3L,aL
aR balance2 ad3R,aR

nodist:
;LP filter
kLPon chnget "LPon"
if kLPon==0 goto noLP
kLPsel chnget "LPsel"
kLPcps chnget "LPcps"
kLPcps port kLPcps,.1
kLPcfr chnget "LPcfr"
kLPcfd chnget "LPcfd"
kLPcfrand chnget "LPrand"
kLPres chnget "LPres"
kLPresr chnget "LPresr"
kLPresd chnget "LPresd"
kLPjit jitter kLPcfr*kLPcfrand,3,11
kLPcf oscili kLPcfd,kLPcfr+kLPjit,25
kLPQ oscili kLPresd,kLPresr,25
a1L,a2L,a3L,a4L mvclpf4 aL,cpsoct(kLPcf+kLPcps),kLPQ+kLPres
a1R,a2R,a3R,a4R mvclpf4 aR,cpsoct(kLPcf+kLPcps),kLPQ+kLPres
if kLPsel=1 then
alpL=a1L
alpR=a1R
elseif kLPsel=2 then
alpL=a2L
alpR=a2R
elseif kLPsel=3 then
alpL=a3L
alpR=a3R
elseif kLPsel=4 then
alpL=a4L
alpR=a4R
endif
aL balance alpL,aL
aR balance alpR,aR

noLP:
;4 Parallel Filters
kparon chnget "paron"
kfport chnget "fport"
if kparon==0 goto nopar
kparsel1 chnget "parsel1"
kparsel2 chnget "parsel2"
kparsel3 chnget "parsel3"
kparsel4 chnget "parsel4"
kparF1 chnget "parF1"
kparF2 chnget "parF2"
kparF3 chnget "parF3"
kparF4 chnget "parF4"
kparF1 portk kparF1,kfport
kparF2 portk kparF2,kfport
kparF3 portk kparF3,kfport
kparF4 portk kparF4,kfport
kparcfr1 chnget "parcfr1"
kparcfr2 chnget "parcfr2"
kparcfr3 chnget "parcfr3"
kparcfr4 chnget "parcfr4"
kparcfd1 chnget "parcfd1"
kparcfd2 chnget "parcfd2"
kparcfd3 chnget "parcfd3"
kparcfd4 chnget "parcfd4"
kparcfrnd1 chnget "parcfrnd1"
kparcfrnd2 chnget "parcfrnd2"
kparcfrnd3 chnget "parcfrnd3"
kparcfrnd4 chnget "parcfrnd4"
kparres1 chnget "parres1"
kparres2 chnget "parres2"
kparres3 chnget "parres3"
kparres4 chnget "parres4"
kparres1 portk kparres1,kfport
kparres2 portk kparres2,kfport
kparres3 portk kparres3,kfport
kparres4 portk kparres4,kfport
kparamp1 chnget "paramp1"
kparamp2 chnget "paramp2"
kparamp3 chnget "paramp3"
kparamp4 chnget "paramp4"
kparamp1 portk kparamp1,kfport
kparamp2 portk kparamp2,kfport
kparamp3 portk kparamp3,kfport
kparamp4 portk kparamp4,kfport
kparjit1 jitter kparcfr1*kparcfrnd1,2.5,8
kparjit2 jitter kparcfr2*kparcfrnd2,3.5,11
kparjit3 jitter kparcfr3*kparcfrnd3,3,10
kparjit4 jitter kparcfr4*kparcfrnd4,2.1,9
kpardev1 oscili kparcfd1,kparcfr1+kparjit1,25
kpardev2 oscili kparcfd2,kparcfr2+kparjit2,25
kpardev3 oscili kparcfd3,kparcfr3+kparjit3,25
kpardev4 oscili kparcfd4,kparcfr4+kparjit4,25
a1lpL,a1bpL,a1hpL zdf_2pole_mode aL,cpsoct(kparF1+kpardev1),kparres1
a1lpR,a1bpR,a1hpR zdf_2pole_mode aR,cpsoct(kparF1+kpardev1),kparres1
a2lpL,a2bpL,a2hpL zdf_2pole_mode aL,cpsoct(kparF2+kpardev2),kparres2
a2lpR,a2bpR,a2hpR zdf_2pole_mode aR,cpsoct(kparF2+kpardev2),kparres2
a3lpL,a3bpL,a3hpL zdf_2pole_mode aL,cpsoct(kparF3+kpardev3),kparres3
a3lpR,a3bpR,a3hpR zdf_2pole_mode aR,cpsoct(kparF3+kpardev3),kparres3
a4lpL,a4bpL,a4hpL zdf_2pole_mode aL,cpsoct(kparF4+kpardev4),kparres4
a4lpR,a4bpR,a4hpR zdf_2pole_mode aR,cpsoct(kparF4+kpardev4),kparres4
if kparsel1=1 then
apar1L=a1lpL
apar1R=a1lpR
elseif kparsel1=2 then
apar1L=a1bpL
apar1R=a1bpR
elseif kparsel1=3 then
apar1L=a1hpL
apar1R=a1hpR
elseif kparsel1=4 then
apar1L=0
apar1R=0
endif
if kparsel2=1 then
apar2L=a2lpL
apar2R=a2lpR
elseif kparsel2=2 then
apar2L=a2bpL
apar2R=a2bpR
elseif kparsel2=3 then
apar2L=a2hpL
apar2R=a2hpR
elseif kparsel2=4 then
apar2L=0
apar2R=0
endif
if kparsel3=1 then
apar3L=a3lpL
apar3R=a3lpR
elseif kparsel3=2 then
apar3L=a3bpL
apar3R=a3bpR
elseif kparsel3=3 then
apar3L=a3hpL
apar3R=a3hpR
elseif kparsel3=4 then
apar3L=0
apar3R=0
endif
if kparsel3=1 then
apar4L=a4lpL
apar4R=a4lpR
elseif kparsel4=2 then
apar4L=a4bpL
apar4R=a4bpR
elseif kparsel4=3 then
apar4L=a4hpL
apar4R=a4hpR
elseif kparsel4=4 then
apar4L=0
apar4R=0
endif
aparsumL=(apar1L*kparamp1)+(apar2L*kparamp2)+(apar3L*kparamp3)+(apar4L*kparamp4)
aparsumR=(apar1R*kparamp1)+(apar2R*kparamp2)+(apar3R*kparamp3)+(apar4R*kparamp4)
aL balance aparsumL,aL
aR balance aparsumR,aR

nopar:
;phaser
kphson chnget "phson"
if kphson==0 goto nophaser
kphscps chnget "phscps"
kphsQ chnget "phsQ"
kphsFB chnget "phsFB"
kphsdev oscil 25,kphscps,25
aLphs phaser2 aL,100+kphsdev,kphsQ,20,1,1,kphsFB
aRphs phaser2 aR,100+kphsdev,kphsQ,20,1,1,kphsFB
aL=(aL+aLphs)*.5
aR=(aR+aRphs)*.5

nophaser:
;flanger
kflon chnget "flon"
if kflon==0 goto noflanger
kflcps chnget "flcps"
kflFB chnget "flFB"
adel oscil .02,kflcps,27
aLfl flanger aL,adel*.05,kflFB,.1
aLfl clip aLfl,1,1
aRfl flanger aR,adel*.05,kflFB,.1
aRfl clip aRfl,1,1
aL=(aL+aLfl)*.5
aR=(aR+aRfl)*.5

noflanger:
;global transposer with 6 voices
kton chnget "ton"
if kton==0 goto noharmon
kharmon1 chnget "harmon1" ;on/off button
kharmon2 chnget "harmon2"
kharmon3 chnget "harmon3"
kharmon4 chnget "harmon4"
kharmon5 chnget "harmon5"
kharmon6 chnget "harmon6"
kharm1 port kharmon1,.05
kharm2 port kharmon2,.05
kharm3 port kharmon3,.05
kharm4 port kharmon4,.05
kharm5 port kharmon5,.05
kharm6 port kharmon6,.05

kTport chnget "Tport"
kT1C chnget "harmon1C"
kT1F chnget "harmon1F"
kT2C chnget "harmon2C"
kT2F chnget "harmon2F"
kT3C chnget "harmon3C"
kT3F chnget "harmon3F"
kT4C chnget "harmon4C"
kT4F chnget "harmon4F"
kT5C chnget "harmon5C"
kT5F chnget "harmon5F"
kT6C chnget "harmon6C"
kT6F chnget "harmon6F"
kT1C portk kT1C,kTport
kT1F portk kT1F,kTport
kT2C portk kT2C,kTport
kT2F portk kT2F,kTport
kT3C portk kT3C,kTport
kT3F portk kT3F,kTport
kT4C portk kT4C,kTport
kT4F portk kT4F,kTport
kT5C portk kT5C,kTport
kT5F portk kT5F,kTport
kT6C portk kT6C,kTport
kT6F portk kT6F,kTport

kshift1=kT1C+kT1F
kshift2=kT2C+kT2F
kshift3=kT3C+kT3F
kshift4=kT4C+kT4F
kshift5=kT5C+kT5F
kshift6=kT6C+kT6F
kharmmix chnget "harmmix"
ibase=cpsoct(8) ;middle C as base frequency

kratio1=cpsoct(8+(kshift1/12))/ibase ;Transposition ratio
kratio2=cpsoct(8+(kshift2/12))/ibase 
kratio3=cpsoct(8+(kshift3/12))/ibase 
kratio4=cpsoct(8+(kshift4/12))/ibase 
kratio5=cpsoct(8+(kshift5/12))/ibase 
kratio6=cpsoct(8+(kshift6/12))/ibase 

kjit1 jitter .002,.75,3.7
kjit2 jitter .001,.15,2.11
kjit3 jitter .0023,.1,1.4
kjit4 jitter .0025,.4,4.7
kjit5 jitter .0016,.6,3.8
kjit6 jitter .0019,.31,5.6

kratio1=kratio1+kjit1
kratio2=kratio2+kjit2
kratio3=kratio3+kjit3
kratio4=kratio4+kjit4
kratio5=kratio5+kjit5
kratio6=kratio6+kjit6

fftinL pvsanal aL,512,128,512,1 ;FFT analysis
fftinR pvsanal aR,512,128,512,1

fftT1L pvscale fftinL,kratio1 ;pitch scaling and resynthesis
fftT1R pvscale fftinR,kratio1
aT1L pvsynth fftT1L
aT1R pvsynth fftT1R

fftT2L pvscale fftinL,kratio2
fftT2R pvscale fftinR,kratio2
aT2L pvsynth fftT2L
aT2R pvsynth fftT2R

fftT3L pvscale fftinL,kratio3
fftT3R pvscale fftinR,kratio3
aT3L pvsynth fftT3L
aT3R pvsynth fftT3R

fftT4L pvscale fftinL,kratio4
fftT4R pvscale fftinR,kratio4
aT4L pvsynth fftT4L
aT4R pvsynth fftT4R

fftT5L pvscale fftinL,kratio5
fftT5R pvscale fftinR,kratio5
aT5L pvsynth fftT5L
aT5R pvsynth fftT5R

fftT6L pvscale fftinL,kratio6
fftT6R pvscale fftinR,kratio6
aT6L pvsynth fftT6L
aT6R pvsynth fftT6R

asumL=(aT1L*kharm1)+(aT2L*kharm2)+(aT3L*kharm3)+(aT4L*kharm4)+(aT5L*kharm5)+(aT6L*kharm6)
asumR=(aT1R*kharm1)+(aT2R*kharm2)+(aT3R*kharm3)+(aT4R*kharm4)+(aT5R*kharm5)+(aT6R*kharm6)
aL=(aL*(1-kharmmix))+(asumL*kharmmix)
aR=(aR*(1-kharmmix))+(asumR*kharmmix)

noharmon:
gaFXL=aL
gaFXR=aR

endin

;does global harmonizer with 6 voices need to be its own instrument here?

instr 502   ;global chorus
kchon chnget "chon"
kchmix chnget "chmix"
kchFB chnget "chFB"
kchdepth chnget "chdepth"
kchcps chnget "chcps"
kchrand chnget "chrand"
kchdel chnget "chdel"
if kchon==0 goto NOCHOR
achorusFBL init 0
achorusFBR init 0
afeedL=gaFXL+achorusFBL
afeedR=gaFXR+achorusFBR
kdepthrand=kchdepth*kchrand*.001
kchdel=kchdel*.001
kcpsrand=kchcps*kchrand
kchcps randomi kchcps-kcpsrand,kchcps+kcpsrand,kchcps
kchdepth randomi kchdepth-kdepthrand,kchdepth+kdepthrand,kchcps
kchdepth port kchdepth,.1
ardelL oscili kchdepth,kchcps,25
ardelR oscili kchdepth,kchcps,25,.25
ardel3 oscili kchdepth,kchcps,25,.5
ardel4 oscili kchdepth,kchcps,25,.75
ardelL=ardelL+(kchdepth*2.1+kchdel)
ardelR=ardelR+(kchdepth*2.1+kchdel)
ardel3=ardel3+(kchdepth*2.1+kchdel)
ardel4=ardel4+(kchdepth*2.1+kchdel)
amodL vdelay afeedL,ardelL,200
amodR vdelay afeedR,ardelR,200
amod3 vdelay afeedL*.33+afeedR*.66,ardel3,200
amod4 vdelay afeedR*.33+afeedL*.66,ardel4,200
achorusFBL=dcblock(((amodL*.6)+(amod4*.3)+(amod3*.15))*-kchFB)
achorusFBR=dcblock(((amodR*.6)+(amod3*.3)+(amod4*.15))*-kchFB)
gaChorL=((afeedL*.7+amodL)*kchmix)+((1-kchmix)*gaFXL)
gaChorR=((afeedR*.7+amodR)*kchmix)+((1-kchmix)*gaFXR)
goto LAST
NOCHOR:
gaChorL=gaFXL
gaChorR=gaFXR
LAST:
endin

instr 505   ;global FB delay FX
kdelon chnget "delon"
if kdelon==0 goto NODEL
aFBL init 0
aFBR init 0
kdel chnget "deltime"
kdel port kdel,.05
adel interp kdel*1000
kDelFB chnget "delFB"
aLdel vdelay gaChorL+aFBL,adel,5000
aRdel vdelay gaChorR+aFBR,adel,5000
aFBL=dcblock((aLdel*kDelFB)+gaChorL)
aFBR=dcblock((aRdel*kDelFB)+gaChorR)
gaDelL=aFBL
gaDelR=aFBR
goto LAST
NODEL:
gaDelL=gaChorL
gaDelR=gaChorR
LAST:
endin

instr 510   ;global reverb, always on
krevon chnget "revon"
if krevon==0 goto NOREV
krevmix chnget "revmix"
krevmix port krevmix,.05
krevFB chnget "revFB"
krevLP chnget "revLP"
aLrev,aRrev reverbsc gaDelL,gaDelR,krevFB,krevLP,gisr,.075
gafinalL=(gaDelL*(1-krevmix))+(aLrev*krevmix)
gafinalR=(gaDelR*(1-krevmix))+(aRrev*krevmix)
goto FINALOUT
NOREV:
gafinalL=gaDelL
gafinalR=gaDelR
FINALOUT:
outs gafinalL,gafinalR
endin

instr 600	; record file
irecch chnget "recch"
ibit chnget "bit"
 print	p1
 if gkplay==1 then
  chnset	k(0),"record"
  turnoff
 endif
 gkFileRecorded		init	1
 itim     date
 Stim     dates     itim
 itim     date
 Stim     dates     itim
 Syear    strsub    Stim, 20, 24
 Smonth   strsub    Stim, 4, 7
 Sday     strsub    Stim, 8, 10
 iday     strtod    Sday
 Shor     strsub    Stim, 11, 13
 Smin     strsub    Stim, 14, 16
 Ssec     strsub    Stim, 17, 19
 Sfilnam  sprintf  "%s_%s_%02d_%s_%s_%s.wav", Syear, Smonth, iday, Shor,Smin, Ssec
 gSname   sprintf "Syncopath_%s", Sfilnam
 if gkrecord==1 then			; record
  if ibit=1 then
   imode=4
  elseif ibit=2 then
   imode=8
  elseif ibit=3 then
   imode=5
  endif
  if irecch=1 then
   fout gSname,imode,(gafinalL+gafinalR)*.7
  elseif irecch=2 then
   fout gSname,imode,gafinalL, gafinalR
  endif
 endif
 gkRecordingActiveFlag	=	1 - release()
endin

instr	601	; play file
 if gkplay==0 then
  turnoff
 endif 
   aL,aR	diskin2	gSname,1
  	outs	aL,aR
 iFileLen	filelen	gSname
 p3	=	iFileLen
 xtratim	0.1 
 krelease	release
 	chnset	1-krelease,"play"
endin

instr 750   ;clear global audio paths that include feedback (don't need to clear the global LFO outputs)
clear   gaSynL,gaSynR,gaDelL,gaDelR,gaFXL,gaFXR,galiveL,galiveR,galiveRM,galiveAM,gafinalL,gafinalR
endin

</CsInstruments>

<CsScore>
;causes Csound to run for about 7000 years...
f0 z
f25 0 8193 10 1   ;sine for FM and AM
f26 0 8193 7 -1 3500 -1 1193 1 3500 1   ;for distort opcode waveshaping
f27 0 16385 7 0 8192 1 8193 0   ;used to control flanger delay
f28 0 8193 10 1 0 .333 0 .2 0 .144 0 .1111 ;square wave
f29 0 8193 20 3 ;triangle envelope for harmonizer
f30 0 8193 7 0 2048 1 4097 -1 2048 0 ;triangle for LFO
f31 0 8193 7 1 4096 1 0 -1 4097 -1 ;square for LFO
f32 0 8193 7 0 8193 1 ;ramp up for LFO
f33 0 8193 7 0 8193 -1 ;ramp down for LFO
f34 0 8193 10 1 1 1 1 1 1 1 1 1 1 .9 .7 .5 .3 .1 ;pulse for LFO
f35 0 8193 10 1 -.5 .33333 -.25 .2 -.1666 .14286 -.125 .11111 -.1 ;saw

;morphing function tables
f98 0 8 -2 101 102 103 104 105 106 107 108 ;table contains ftable numbers for morphing, gets re-instantiated each time a function is selected
f99 0 8193 10 1 ;this is the target ftmorf function table with the mixed waveform, just a sine with the appropriate size

;function tables for waveform select
f101 0 8193 10 1 ;sine
f102 0 8193 10 1 0 .333 0 .2 0 .144 0 .1111 0 .090909 0 .076923 0 .0666666 0 .0588235 0 .052632 ;square wave
f103 0 8193 10 1 -.5 .33333 -.25 .2 -.1666 .14286 -.125 .11111 -.1 .090909 -.83333 .076923 -.071428 .0666666 -.0625 .0588235 -.055555 .052632 ;saw
f104 0 8193 10 1 1 1 1 1 1 1 1 1 1 1 1 .9 .8 .7 .6 .5 .4 .3 .2 .1 ;pulse
f105 0 8193 7 0 2048 1 4097 -1 2048 0 ;triangle
f106 0 8193 7 -1 8193 1 ;ramp
f107 0 8193 10 0 1 ;harmonic 1
f108 0 8193 10 0 0 1 ;harmonic 2
f109 0 8193 10 0 0 0 1 ;harmonic 3
f110 0 8193 10 0 0 0 0 1 ;harmonic 4
f111 0 8193 10 0 0 0 0 0 1 ;harmonic 5
f112 0 8193 10 0 0 0 0 0 0 1 ;harmonic 6
f113 0 8193 10 0 0 0 0 0 0 0 1 ;harmonic 7
f114 0 8193 10 0 0 0 0 0 0 0 0 1 ;harmonic 8
f115 0 8193 10 0 0 0 0 0 0 0 0 0 1 ;harmonic 9
f116 0 8193 10 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 10
f117 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 11
f118 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 12
f119 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 13
f120 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 14
f121 0 8193 10 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 ;harmonic 15
;cello
f122 0 8193 10 0.022943 0.412962 0.548431 0.578468 0.092241 0.116378 0.052974 0.029585 0.093977 0.119660 0.064074 0.051807 0.015094 0.094184 0.015488 0.006640 0.007091 0.011557 0.043467 0.023330 0.018118 0.026921 0.010285 0.007653 0.015306 0.023175
;violin
f123 0 8193 10 0.403041 0.281156 0.259204 0.392900 0.236559 0.108769 0.117288 0.063588 0.039483 0.018245 0.012717 0.020183 0.008506 0.017915 0.008925 0.008575 0.006947 0.008142 0.005487 0.005970 0.004402 0.003161 0.002361 0.001942
;bass tbn
f124 0 8193 10 0.102601 0.100887 0.167098 0.516781 0.330986 0.422868 0.412850 0.397849 0.628756 0.686835 0.929709 0.845577 0.935266 0.508059 0.792158 0.281350 0.378308 0.568489 0.346813 0.566233 0.413541 0.405762 0.359363 0.216505
;F horn
f125 0 8193 10 10 0.150333 0.205756 0.869097 0.723941 0.707935 0.116871 0.238125 0.330962 0.443031 0.325212 0.131256 0.267361 0.273576 0.146568 0.209758 0.158564 0.179271 0.084668 0.112177 0.118845 0.124993 0.096945 0.128906 0.125534 0.125534
;trumpet
f126 0 8193 10 .569 .543 .633 .7 .67 .675 .555 .41 .46 .305 .31 .365 .315 .25 .21 .24 .225 .175 .155 .185 .155 .16 .245
;contra bassoon
f127 0 8193 10 0.076357 0.137793 0.174617 0.207802 0.302523 0.705801 0.162577 0.073808 0.224559 0.050465 0.066110 0.181682 0.062409 0.052317 0.037698 0.029936 0.042341 0.053436 0.135414 0.059248 0.025689 0.033567 0.051201 0.029910 0.028697 0.052991
;bassoon
f128 0 8193 10 0.147763 0.340255 0.879202 0.404023 0.259274 0.130887 0.095096 0.039056 0.091976 0.009828 0.004879 0.013408 0.016090 0.015931 0.012402 0.003430 0.006421 0.004323 0.002018 0.001465 0.003012 0.001397 0.002446 0.002683 0.002425 0.004828
;oboe
f129 0 8193 10 0.297865 0.916220 0.218345 0.030903 0.016039 0.045984 0.003571 0.006255 0.007310 0.003701 0.001306 0.001355 0.000361 0.001108 0.001552 0.000991 0.000588 0.000780 0.000678 0.001103 0.000615 0.000264 0.000310 0.000464 0.000464
;saxophone
f130 0 8193 10 .14 .23 .142 .18 .2 .07 .015 .05 .062 .09 .043 .01 .025 .037 .056 .06 .057 .049 .062 .048 .03 .023 .02 .011 .017
;contrabass clarinet
f131 0 8193 10 0.227476 0.006718 0.707706 0.018101 0.539432 0.018848 0.590242 0.029143 0.512926 0.035712 0.324304 0.035306 0.035964 0.050992 0.096916 0.025035 0.098203 0.072427 0.068155 0.060324 0.042818 0.074538 0.049430 0.100999 0.052956 0.109337
; bass clarinet
f132 0 8193 10 0.819856 0.006052 0.508263 0.007439 0.271031 0.012967 0.059374 0.017922 0.016997 0.004014 0.027132 0.014921 0.020230 0.012123 0.021066 0.004875 0.016894 0.004428 0.004157 0.007603 0.004211 0.011103 0.005054 0.007329 0.004043 0.002169
;clarinet
f133 0 8193 10 0.753504 0.011446 0.501720 0.055791 0.241768 0.037889 0.027203 0.062793 0.102494 0.030506 0.042453 0.050202 0.031077 0.027208 0.020897 0.022205 0.012154 0.008160 0.004886 0.005076 0.003805 0.001322 0.001149 0.001450 0.001450
;bass flute
f134 0 8193 10 0.801592 0.068816 0.032303 0.012614 0.002660 0.014692 0.002493 0.006175 0.001826 0.001416 0.002607 0.001063 0.001542 0.001053 0.001293 0.001226 0.000781 0.001142 0.000975 0.000922 0.000693 0.000570 0.000538 0.000429 0.000587
;flute
f135 0 8193 10 0.925667 0.059839 0.214284 0.013980 0.026778 0.008733 0.019436 0.002640 0.004217 0.002126 0.003513 0.002455 0.001336 0.001508 0.001589 0.002155 0.002549 0.001951 0.001614 0.001076 0.001253 0.001138 0.001073 0.000990 0.000990
;piccolo
f136 0 8193 10 0.730803 0.323120 0.277720 0.044844 0.009400 0.022785 0.004602 0.005762 0.006400 0.002483 0.001490 0.002354 0.004728 0.002669 0.003175 0.001177 0.000761 0.000509 0.000449 0.000703 0.001078 0.002471 0.003905 0.004114 0.004114
;piano (low res)
f137 0 8193 10 1 .11 .333 .07 .055 .055 .003 .025 .002 .003 0 .003 .004 .001 .0005
;guitar
f138 0 8193 10 1 .675 1.265 .125 .12 .115 .005 .01 .185 .055 .015 .008 .009 .01 .003 .002 .002
;ahhh
f139 0 8193 10 0.600063 0.256340 0.126445 0.040717 0.097956 0.082383 0.135342 0.006369 0.002414 0.002312 0.001526 0.000552 0.000868 0.000435 0.000576 0.001145 0.001706 0.003688 0.013234 0.006626 0.006840 0.012971 0.003639 0.002955 0.001962 0.001988

i1 0 999999     ;live audio input and sf management
;i2 and i3 play and load soundfiles for input
i4 0 999999    ;mixes mic/line and soundfile playback, generates audio data for modulation
i5 0 999999    ;LFO generator
;i10 is the big synth controlled by MIDI
i20 0 999999    ;noise generator
i25 0 999999    ;PW rslider GUI control
i60 0 999999 ;vocal formant parallel filter preset control
i61 0 999999 ;Transposer preset control
i100 0 999999 ;MIDI controller mapping
i101 0 999999 ;MIDI controller instruments
i103 0 999999
i105 0 999999
i107 0 999999
i109 0 999999
i200 0 999999
i210 0 999999
i220 0 999999
i230 0 999999
i240 0 999999
i250 0 999999
i260 0 999999
i280 0 999999
i290 0 999999
i300 0 999999
i500 0 999999       ;global FX
i502 0 999999
i505 0 999999       ;global delay
i510 0 999999       ;global reverb
i750 0 999999       ;global audio clear

</CsScore>
</CsoundSynthesizer>
